/*****************************************************************************
 *  CDM_Macros.h:                                                            *
 * ----------------------                                                    *
 *  This file defines the macro subsystem of the Collection and Document     *
 *  Manager (CDM) Public API.                                                *
 *  Version: 1.0                                                             *
 *  For more details regarding CDM Version consult file "CDM_Version.h"      *
 *  CDM is the Collection and Document Manager and the core component of the *
 *  Ellogon Text Engineering Platform.                                       *
 *  CDM was designed and implemented by Georgios Petasis,                    *
 *  e-mail: petasis@iit.demokritos.gr                                        *
 *  URL:    http://www.iit.demokritos.gr/~petasis                            *
 *                                                                           *
 *  Copyright 1998-2010 by:                                                  *
 *  Georgios Petasis,                                                        *
 *  Software and Knowledge Engineering Laboratory,                           *
 *  Institute of Informatics and Telecommunications,                         *
 *  National Center for Scientific Research (N.C.S.R.) "Demokritos",         *
 *  Athens, Greece.                                                          *
 *  E-mail: petasis@iit.demokritos.gr                                        *
 *                                                                           *
 *  This file is part of the "Ellogon" Text Engineering Platform.            *
 *  For licencing information, please refer to the licence conditions of     *
 *  "Ellogon" Text Engineering Platform.                                     *
 *****************************************************************************/
#ifndef _CDM_MACROS
#define _CDM_MACROS
#include "CDM.h"

/******************************************************************************
 ******************************************************************************
 ****    +-------------------------------------------------------+         ****
 ****    | S Y S T E M   M A N I P U L A T I O N   S E C T I O N |         ****
 ****    +-------------------------------------------------------+         ****
 ******************************************************************************
 *****************************************************************************/
typedef Tcl_Obj * CDM_MACRO_SYSTEM;
typedef Tcl_Obj * CDM_MACRO_SYSTEM_COLLECTION;
CDM_EXPORT
CDM_MACRO_SYSTEM CDM_MACRO_GetContainerSystem(const CDM_Collection col);
CDM_EXPORT
CDM_MACRO_SYSTEM CDM_MACRO_OpenSystem(const char *name,
                                      const char *folder = "/");
CDM_EXPORT
CDM_MACRO_SYSTEM CDM_MACRO_EditSystem(const char *name,
                                      const char *folder = "/");
CDM_EXPORT
CDM_MACRO_SYSTEM_COLLECTION CDM_MACRO_OpenInSystem(
                                      const CDM_MACRO_SYSTEM system,
                                      const char *collection_name,
                                      const char *document_id = "");
CDM_EXPORT
CDM_Collection   CDM_MACRO_GetOpenedCollection(
                                      const CDM_MACRO_SYSTEM_COLLECTION token);
CDM_EXPORT
CDM_Document     CDM_MACRO_GetOpenedDocument(
                                      const CDM_MACRO_SYSTEM_COLLECTION token);
CDM_EXPORT
int              CDM_MACRO_RunSystemComponent(
                                      const CDM_MACRO_SYSTEM system,
                                      const CDM_MACRO_SYSTEM_COLLECTION token,
                                      const char *Annotator,
                                      const int force = 0);
CDM_EXPORT
int              CDM_MACRO_RunSystemComponent(
                                      const CDM_MACRO_SYSTEM system,
                                      CDM_Collection col,
                                      CDM_Document doc,
                                      const char *Annotator,
                                      const int force = 0);
CDM_EXPORT
int              CDM_MACRO_RunSystemTool(
                                      const CDM_MACRO_SYSTEM system,
                                      const CDM_MACRO_SYSTEM_COLLECTION token,
                                      const char *Annotator,
                                      const int force = 0);
CDM_EXPORT
int              CDM_MACRO_RunSystemTool(
                                      const CDM_MACRO_SYSTEM system,
                                      CDM_Collection col,
                                      CDM_Document doc,
                                      const char *Annotator,
                                      const int force = 0);
CDM_EXPORT
int              CDM_MACRO_DisplayViewer(
                                      const CDM_MACRO_SYSTEM system,
                                      const char *viewer_name,
                                      CDM_Document doc,
                                      const char *parameter1,
                                      const char *parameter2);

CDM_EXPORT
int              CDM_MACRO_NFoldExecution(
                                      CDM_Collection col,
                                      const int folds,
                                      CDM_ByteSequenceSet TrainingCommands,
                                      CDM_ByteSequenceSet EvaluationCommands);
#endif /* _CDM_MACROS */
