##############################################################################
##  CDM_RDF.tcl -                                                           ##
## -----------------                                                        ##
##  Facilities related to CDM Core RDF services.                            ##
##  Copyright 1998-2004 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Software and Knowledge Engineering Laboratory,                          ##
##  Institute of Informatics and Telecommunications,                        ##
##  N.C.S.R. "Demokritos"                                                   ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Text Engineering Platform.                                    ##
##############################################################################

namespace eval ::CDM::RDF {

  proc Initialise {} {
    ## Initialise the Redland package.
    InitialiseRedland
  };# proc ::CDM::RDF::Initialise

  proc InitialiseRedland {} {
    global HomeDir ApplicationInfo env
    ## As a first step, we should change the CWD into the redland library,
    ## so as libraries can be loaded...
    set CWD [pwd]
    set RedlandLibPath \
      $HomeDir/lib/redland/lib/$ApplicationInfo(LoadBinaryFolderName)
    ## Update the LD_LIBRARY_PATH & PATH environmental variables...
    append env(LD_LIBRARY_PATH) :$RedlandLibPath
    append env(PATH) :$RedlandLibPath
    cd $HomeDir/lib/redland/lib/$ApplicationInfo(LoadBinaryFolderName)
    ## Load the Tcl package.
    load $HomeDir/lib/redland/tcl/Redland[info sharedlibextension]
    cd $CWD
  };# InitialiseRedland
};# ::CDM::RDF namespace 
