/*****************************************************************************
 *  Annotation.java:                                                         *
 * ----------------------------------                                        *
 *  This file contains support code for offering Compatibility modes for     *
 *  other platforms.                                                         *
 *  This class was designed and implemented by Georgios Petasis,             *
 *  e-mail: petasis@iit.demokritos.gr                                        *
 *  URL:    http://www.iit.demokritos.gr/~petasis                            *
 *                                                                           *
 *  Copyright 1998-2003 by:                                                  *
 *  Georgios Petasis,                                                        *
 *  Software and Knowledge Engineering Laboratory,                           *
 *  Institute of Informatics and Telecommunications,                         *
 *  National Center for Scientific Research (N.C.S.R.) "Demokritos",         *
 *  Athens, Greece.                                                          *
 *  E-mail: petasis@iit.demokritos.gr                                        *
 *                                                                           *
 *  This file is part of the "Ellogon" Text Engineering Platform.            *
 *  For licencing information, please refer to the licence conditions of     *
 *  "Ellogon" Text Engineering Platform.                                     *
 *****************************************************************************/

package gate;
import tcl.lang.*;
import Ellogon.JCDM.*;

public class Annotation extends OCDM_Annotation {
  
  public Annotation(
    Integer id, Node start, Node end, String type, FeatureMap features) {
    super(type, start.getOffset().intValue(), end.getOffset().intValue(),
                                              features);
  }; /* Annotation */

  public Integer getId() {
    return new Integer(GetId());
  }; /* getId */

  public String getType() {
    return GetType();
  }; /* getType */

  public Node getStartNode() {
    OCDM_Span span = GetFirstSpan();
    return new Node(new Integer(GetId()), new Long(span.GetStart()));
  }; /* getStartNode */

  public Node getEndNode() {
    OCDM_Span span = GetFirstSpan();
    return new Node(new Integer(GetId()), new Long(span.GetEnd()));
  }; /* getEndNode */

}; /* class Annotation */
