/*****************************************************************************
 *  FeatureMap.java:                                                         *
 * ----------------------------------                                        *
 *  This file contains support code for offering Compatibility modes for     *
 *  other platforms.                                                         *
 *  This class was designed and implemented by Georgios Petasis,             *
 *  e-mail: petasis@iit.demokritos.gr                                        *
 *  URL:    http://www.iit.demokritos.gr/~petasis                            *
 *                                                                           *
 *  Copyright 1998-2003 by:                                                  *
 *  Georgios Petasis,                                                        *
 *  Software and Knowledge Engineering Laboratory,                           *
 *  Institute of Informatics and Telecommunications,                         *
 *  National Center for Scientific Research (N.C.S.R.) "Demokritos",         *
 *  Athens, Greece.                                                          *
 *  E-mail: petasis@iit.demokritos.gr                                        *
 *                                                                           *
 *  This file is part of the "Ellogon" Text Engineering Platform.            *
 *  For licencing information, please refer to the licence conditions of     *
 *  "Ellogon" Text Engineering Platform.                                     *
 *****************************************************************************/

package gate;
import tcl.lang.*;
import Ellogon.JCDM.*;

public class FeatureMap extends OCDM_AttributeSet {
 
  public FeatureMap() {
  }; /* FeatureMap */

  public OCDM_Attribute put(String key, String value) {
    OCDM_Attribute attribute = new OCDM_Attribute(key, OCDM.OCDM_STRING, value);
    AddAttribute(attribute);
    return attribute;
  }; /* put */

  public String get(String key) {
    OCDM_Attribute attribute = GetAttribute(key);
    return attribute.GetValueString();
  }; /* get */

  public Integer remove(String key) {
    return new Integer(RemoveAttribute(key));
  }

}; /* class Node */
