/*****************************************************************************
 *  Node.java:                                                               *
 * ----------------------------------                                        *
 *  This file contains support code for offering Compatibility modes for     *
 *  other platforms.                                                         *
 *  This class was designed and implemented by Georgios Petasis,             *
 *  e-mail: petasis@iit.demokritos.gr                                        *
 *  URL:    http://www.iit.demokritos.gr/~petasis                            *
 *                                                                           *
 *  Copyright 1998-2003 by:                                                  *
 *  Georgios Petasis,                                                        *
 *  Software and Knowledge Engineering Laboratory,                           *
 *  Institute of Informatics and Telecommunications,                         *
 *  National Center for Scientific Research (N.C.S.R.) "Demokritos",         *
 *  Athens, Greece.                                                          *
 *  E-mail: petasis@iit.demokritos.gr                                        *
 *                                                                           *
 *  This file is part of the "Ellogon" Text Engineering Platform.            *
 *  For licencing information, please refer to the licence conditions of     *
 *  "Ellogon" Text Engineering Platform.                                     *
 *****************************************************************************/

package gate;
import tcl.lang.*;
import Ellogon.JCDM.*;

public class Node {
  Integer id;
  Long offset;

  public Node(Integer id) {
    this.id = id;
    offset = null;
  }; /* Node */

  public Node (Integer id, Long offset) {
    this.id = id;
    this.offset = offset;
  }; /* Node */

  public Integer getId() {
    return id;
  }; /* getId */

  public Long getOffset() {
    return offset;
  }; /* getOffset */

  public String toString() {
    return "Node: id=" + id + "; offset=" + offset;
  }; /* toString */
  
  void setOffset(Long offset) {
    this.offset = offset;
  }; /* setOffset */
}; /* class Node */
