/*****************************************************************************
 *  OCDM_EllogonRegisterStdChannels.java:                                    *
 * ---------------------------------------                                   *
 *  This file implements utilities for redirecting Java console output to    *
 *  Ellogon console                                                          *
 *  This class was designed and implemented by Georgios Petasis,             *
 *  e-mail: petasis@iit.demokritos.gr                                        *
 *  URL:    http://www.iit.demokritos.gr/~petasis                            *
 *                                                                           *
 *  Copyright 1998-2004 by:                                                  *
 *  Georgios Petasis,                                                        *
 *  Software and Knowledge Engineering Laboratory,                           *
 *  Institute of Informatics and Telecommunications,                         *
 *  National Center for Scientific Research (N.C.S.R.) "Demokritos",         *
 *  Athens, Greece.                                                          *
 *  E-mail: petasis@iit.demokritos.gr                                        *
 *                                                                           *
 *  This file is part of the "Ellogon" Text Engineering Platform.            *
 *  For licencing information, please refer to the licence conditions of     *
 *  "Ellogon" Text Engineering Platform.                                     *
 *****************************************************************************/

package Ellogon.JCDM;
import java.lang.*;
import java.io.*;
import tcl.lang.*;

public class OCDM_EllogonRegisterStdChannels {
  public OCDM_EllogonRegisterStdChannels(Interp interp) {
    PrintStream tcl_stdout = new OCDM_EllogonConsolePrintStream(System.out,
                                                              interp, "stdout");
    PrintStream tcl_stderr = new OCDM_EllogonConsolePrintStream(System.err,
                                                              interp, "stderr");
    System.out.flush();
    System.err.flush();
    System.setOut(tcl_stdout);
    System.out.flush();
    System.err.flush();
    System.setErr(tcl_stderr);
    System.err.flush();

    // Test the registration...
    System.out.println("JCDM: Link between Java \"System.out\" and " +
                       "Tcl \"stdout\" successful...");
    System.err.println("JCDM: Link between Java \"System.err\" and " +
                       "Tcl \"stderr\" successful...");
  }; /* OCDM_EllogonRegisterStdChannels */
}; /* OCDM_EllogonRegisterStdChannels */
