// test.java
import java.lang.*;
import Ellogon.JCDM.*;
//import test;
public class test {
  static{
    try {
      System.load("/disk2a/users/petasis/Ellogon/CDM/Java/libJCDM.so");
      //System.loadLibrary("libJCDMSA");
    }
    catch (UnsatisfiedLinkError e) {
      System.err.println("Native code library failed to load. " + e);
      System.exit(1);
    }
  } //static

  public static void main(String args[]){

    /*************************************************************************
     ** Testing Class: OCDM_ByteSequence                                    **
     *************************************************************************/
    System.out.println("#### Testing Class: OCDM_ByteSequence");
    // Empty Object:
    OCDM_ByteSequence byteseq = new OCDM_ByteSequence();
    // Is the object valid?
    System.out.println("Creating \"byteseq\" = \"" + byteseq +"\"");
    System.out.println("Is byteseq valid? " + byteseq.Valid());
    System.out.println("Setting byteseq to a string: ");
    byteseq.Set("This is an example string!");
    System.out.println("byteseq is = \"" + byteseq + "\"");
    System.out.println("Is byteseq valid? " + byteseq.Valid());
    System.out.println("\n");

    /*************************************************************************
     ** Testing Class: OCDM_Span                                            **
     *************************************************************************/
    System.out.println("#### Testing Class: OCDM_Span");
    OCDM_Span span = new OCDM_Span(10, 20);
    System.out.println("Span start = " + span.GetStart());
    System.out.println("Span end   = " + span.GetEnd());
    System.out.println("Setting span to [0,10]");
    span = new OCDM_Span(0, 10);
    System.out.println("Span start = " + span.GetStart());
    System.out.println("Span end   = " + span.GetEnd());
    System.out.println("Span.toString() = \"" + span.toString() + "\"");
    System.out.println("\n");

    /*************************************************************************
     ** Testing Class: OCDM_SpanSet                                         **
     *************************************************************************/
    System.out.println("#### Testing Class: OCDM_SpanSet");
    OCDM_SpanSet spanset = new OCDM_SpanSet(9,13);
    spanset.AddSpan(span);
    System.out.println("SpanSet start = " + span.GetStart());
    System.out.println("SpanSet end   = " + span.GetEnd());
    System.out.println("SpanSet.toString() = \"" + spanset.toString() + "\"");
    System.out.println("SpanSet[0] = \"" + spanset.get(0) + "\"");
    System.out.println("SpanSet[1] = \"" + spanset.get(1) + "\"");
    System.out.println("\n");
    
    /*************************************************************************
     ** Testing Class: OCDM_AttributeValue                                  **
     *************************************************************************/
    System.out.println("#### Testing Class: OCDM_AttributeValue");
    OCDM_AttributeValue AttrVal = new OCDM_AttributeValue(
                                      OCDM.OCDM_STRING, "value");
    System.out.println("AttrVal.toString() = \"" + AttrVal.toString() + "\"");
    
    /*
     * OCDM_Attribute Class
     */
    OCDM_Attribute Attr = new OCDM_Attribute("Name", AttrVal);
    System.out.println("Attr.toString() = \"" + Attr.toString() + "\"");
    
    /*
     * OCDM_AttributeSet Class
     */
    OCDM_AttributeSet AttrSet = new OCDM_AttributeSet("Name2", AttrVal);
    System.out.println("AttrSet.toString() = \"" + AttrSet.toString() + "\"");
    AttrSet.AddAttribute(Attr);
    System.out.println("AttrSet.toString() = \"" + AttrSet.toString() + "\"");
    System.out.println("AttrSet[0] = \"" + AttrSet.get(0) + "\"");
    System.out.println("AttrSet[1] = \"" + AttrSet.get(1) + "\"");
    
    
    System.out.println("Attribute Value      = " + Attr.GetValue());
    System.out.println("Attribute String     = " + Attr.GetValueString()); 
    System.out.println("Attribute Type       = " + Attr.GetValueType());
    System.out.println("Attribute ValueValue = " + Attr.GetValueValue());
    System.out.println("Reconstructing Attribute...");
    Attr.ReconstructAttribute();
    System.out.println("Attribute Object  =" + Attr); 

    /*************************************************************************
     ******************** End of Attribute Section ***************************
     *************************************************************************/
    
    /*
     * OCDM_Collection Class
     */
    OCDM_Collection Collection = 
                          new OCDM_Collection("Petasis", AttrSet, "iso8859-7");
    System.out.println("Collection Name   = " + Collection.GetName());
    System.out.println("Collection Length = " + Collection.Length()); 
    System.out.println("Collection Object = " + Collection);
   
    /********************** Start Of Annotation Section***********************/
    OCDM_Annotation Annotation  = new OCDM_Annotation("SKEL", spanset, AttrSet);
    OCDM_Annotation Annotation1 =
                          new OCDM_Annotation("Demokrtitos", spanset, AttrSet);
    OCDM_ByteSequence ByteSeq  = new OCDM_ByteSequence("Dim");
    OCDM_AnnotationSet AnnotationSet  = new OCDM_AnnotationSet();
    OCDM_AnnotationSet AnnotationSet2 = new OCDM_AnnotationSet();
    Collection.CreateDocument("Path", ByteSeq, AnnotationSet, AttrSet);
    AnnotationSet.AddAnnotation(Annotation);
    
    OCDM_Document Document = new OCDM_Document();
    //System.out.println("Compare Annotations " + AnnotationSet.CompareAnnotations(Annotation, Annotation1);
    
    //Annotation.DisplaceAnnotation(3,5);
    //System.out.println("Displace Annotation " + Document.DisplaceAnnotations(3,5));
    //ByteSeq = Document.GetAnnotatedTextRanges(Annotation);
    //Annotation = Document.GetAnnotation(3);
    //Annotation = AnnotationSet.GetAnnotation(3);
    //ta apenergopoiisa giati den ginetai na trexoyn oles mazi oi enotites
    
    Attr = Collection.GetAttribute("SKEL");
    Attr = Annotation.GetAttribute("SKEL");
    
    
    AttrSet = Collection.GetAttributes();
    AttrSet = Annotation.GetAttributes();
    
    //edo xtypaei o pirinas
    //ByteSeq = Document.GetFirstAnnotatedTextRange(Annotation);
    //spanset = Annotation.GetFirstSpan();
    
    //System.out.println("Document Id " + Document.GetId());
    
    spanset = Annotation.GetSpans();
    System.out.println("Annotation Type " + Annotation.GetType());
    //ByteSeq = Annotation.GetTypeObj();
    System.out.println("Collection Length " + Collection.Length());
    
    Annotation.ReconstructAnnotation();
    
   System.out.println("Collection PutAttribute " + Collection.PutAttribute(Attr));
   System.out.println("Document PutAttribute " + Document.PutAttribute(Attr));
   Annotation.PutAttribute(Attr);
   
   System.out.println("Document RemoveAnnotation " + Document.RemoveAnnotation(2));
   AnnotationSet.RemoveAnnotation(2);
   
   System.out.println("Collection RemoveAttribute " + Collection.RemoveAttribute("Name"));
   System.out.println("Document RemoveAttribute " + Document.RemoveAttribute("Name"));
   Annotation.RemoveAttribute("Name");
   
   Annotation.RemoveSpan(3,4);
    
    //Xtypaei o Pirinas
   //AnnotationSet = AnnotationSet.SelectAnnotations("token");
   //AnnotationSet = Document.SelectAnnotations("token");
   //AnnotationSet = AnnotationSet.SelectAnnotationsSorted("token");
   //AnnotationSet = Document.SelectAnnotationsSorted("token");
   //AnnotationSet = AnnotationSet.SortAnnotationSet();
   
   
    
                                          
 }//main
}//test

