(define (ellogon-scale-bmp image size outDir root interp)
  (let* ( (scaled   (car (gimp-image-duplicate image)))
          (drawable (car (gimp-image-get-active-layer scaled)))
          (sizeDir  (string-append (number->string size) "/"))
          (outFile  (string-append outDir sizeDir root ".bmp")) ) 
    (gimp-image-scale-full scaled size size interp)
    (file-bmp-save RUN-NONINTERACTIVE image drawable outFile outFile)
    (gimp-image-delete scaled)
  ); end let
); end define


(define (ellogon-generate-bmp)
  (let* ( (filelist (append (cadr (file-glob "*.png" 1))
                            (cadr (file-glob "*.xcf" 1)))) )
    (while (not (null? filelist))
      (let* (
          (filename (car filelist))
          (image (car (gimp-file-load RUN-NONINTERACTIVE filename filename)))
          (scaled image)
          ; Merge visible layers...
          (drawable (car (gimp-image-merge-visible-layers image 
                                                             CLIP-TO-IMAGE)))
          (width  (car (gimp-image-width  image)))
          (height (car (gimp-image-height image)))
          (size width) (len 0) (dot 0) (root "") (outFile "")
          (outDir "BMP/") (sizeDir "")
            )
        (set! sizeDir (string-append (number->string size) "/"))
        ; Remove the extension...
        (set! len (string-length filename))
        (set! dot (- len 4))
        ; (gimp-message (number->string dot))
        (set! root (substring filename 0 dot))
        ; (gimp-message root)
        (set! outFile (string-append outDir  sizeDir root ".bmp"))
        (gimp-message (string-append filename " -> " root ".bmp"))
        ; Save the image as a BMP...
        (file-bmp-save RUN-NONINTERACTIVE image drawable outFile outFile)
        
        ; Create the various sizes...
        
        (ellogon-scale-bmp image 128 outDir root INTERPOLATION-LINEAR)
        (ellogon-scale-bmp image  64 outDir root INTERPOLATION-LINEAR)
        (ellogon-scale-bmp image  48 outDir root INTERPOLATION-LINEAR)
        (ellogon-scale-bmp image  40 outDir root INTERPOLATION-LINEAR)
        (ellogon-scale-bmp image  32 outDir root INTERPOLATION-LINEAR)
        (ellogon-scale-bmp image  24 outDir root INTERPOLATION-LINEAR)
        (ellogon-scale-bmp image  20 outDir root INTERPOLATION-LINEAR)
        (ellogon-scale-bmp image  16 outDir root INTERPOLATION-LINEAR)

        (gimp-image-delete image)
      ); end let
      (set! filelist (cdr filelist))
    ); end while
  ); end let
); end define
