/*****************************************************************************
 *  testOCDM.cpp:                                                            *
 * ----------------------                                                    *
 *  This file tests the implementation of the object oriented CDM C++        *
 *  Public API.                                                              *
 *  CDM is the Collection and Document Manager and the core component of the *
 *  Ellogon Text Engineering Platform.                                       *
 *  CDM was designed and implemented by Georgios Petasis,                    *
 *  e-mail: petasis@iit.demokritos.gr                                        *
 *  URL:    http://www.iit.demokritos.gr/~petasis                            *
 *                                                                           *
 *  Copyright 1998-2003 by:                                                  *
 *  Georgios Petasis,                                                        *
 *  Software and Knowledge Engineering Laboratory,                           *
 *  Institute of Informatics and Telecommunications,                         *
 *  National Center for Scientific Research (N.C.S.R.) "Demokritos",         *
 *  Athens, Greece.                                                          *
 *  E-mail: petasis@iit.demokritos.gr                                        *
 *                                                                           *
 *  This file is part of the "Ellogon" Text Engineering Platform.            *
 *  For licencing information, please refer to the licence conditions of     *
 *  "Ellogon" Text Engineering Platform.                                     *
 *****************************************************************************/

#include "OCDM.h"

int main(int argc, char *argv[]) {
  /* Initialise CDM */
  CDM_GET_LIBRARY_FUNCTION_POINTERS;
  CDM_Initialise("test");
  /* Create a Document */
  try {
    OCDM_Document *Doc = new OCDM_Document("test");
  } catch (OCDM_Exception e) {
    printf("Exception caught:\n -> %s\n", e.what());
  }
  /* Finalise CDM */
  CDM_Finalise();
  return 0;
}; /* main */
