#!/bin/sh
# Next Line restarts using tclsh \
exec tclsh "$0" "$@"
############################################################################
## ExecServer.tcl:
##  The Execution Server for the Ellogon platform. (Version 0.1)
##  Written by George Petasis, 2/11/1998
## 
##    Ellogon opens a pipe on this executable, and sends commands to be executed
##    by this program. We want commands to be executed by this program instaed
##    by the Babel itself, in order to avoid forking Babel, which can be very
##    large, if it is proccessing a large document.

puts "Execution Server v 1.0 Started..."
flush stdout

## set Log [open ESLog w] 

set command {}
while { $command != "exit"} {
  set count [gets stdin command]
  if {$count == -1} {
#    puts "Execution Server Exiting..."
#    flush stdout
    exit 0
  }
  ## puts $Log "Executing Command: $command"
  if {[catch {eval $command} error]} {
    set error "$error\n$errorCode"
    set line_list [split $error "\n"]
    set lines [llength $line_list]
    if {$lines < 1} {set lines 1}
    puts stdout "Tcl_Error:$lines\n$error"
    ## puts $Log "Tcl_Error:$lines\n$error"
  } else {
    set line_list [split $error "\n"]
    set lines [llength $line_list]
    if {$lines < 1} {set lines 1}
    puts stdout "Tcl_Ok:$lines\n$error"
    ## puts $Log "Tcl_Ok:$lines\n$error"
  }
  flush stdout
  ## flush $Log
}
