##############################################################################
##  Abort.tcl:                                                              ##
## ---------------------                                                    ##
##  This file contains functions that are used in order to stop a tcl       ##
##  process that is running.                                                ##
##                                                                          ##
##  Copyright 1998-2004 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Software and Knowledge Engineering Laboratory,                          ##
##  Institute of Informatics and Telecommunications,                        ##
##  N.C.S.R. "Demokritos"                                                   ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Text Engineering Platform.                                    ##
##############################################################################

## GUI_AbortCurrentProcess
#   This function displays a dialog in order for the user to choose whether to
#   abort a running process or not...
proc GUI_AbortCurrentProcess {args} {
  global CDM_AbortCurrentProcess GUI_Text
  if {![info exists GUI_Text(AbortRunningTask?)]} {
    set GUI_Text(AbortRunningTask?) {Abort Running Task?}
  }
  set ans [gut_question $GUI_Text(AbortRunningTask?) {Abort?}]
  if {[string equal $ans yes]} {
    set CDM_AbortCurrentProcess 1
    catch {bgerror_clear}
  } else {
    set CDM_AbortCurrentProcess 0
  }
}; #GUI_AbortCurrentProcess

