##############################################################################
##  SOAP.tcl:                                                               ##
## ---------------------                                                    ##
##  This file implements a SOAP Deamon/Client for Ellogon.                  ##
##  Initial version date: 16/06/2001                                        ##
##                                                                          ##
##  Copyright 1998-2007 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Software and Knowledge Engineering Laboratory,                          ##
##  Institute of Informatics and Telecommunications,                        ##
##  N.C.S.R. "Demokritos"                                                   ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Text Engineering Platform.                                    ##
##############################################################################

proc GUI_SOAPStartServer {menu} {
  global GUI_Text GUI_SOAP GUI_HTTPD
  
  GUI_StartHttpd $menu
  if {![info exists GUI_HTTPD] || [llength [array names GUI_HTTPD]] == 0} {
    return
  }
  package require SOAP
  package require SOAP::Domain
  set GUI_SOAP(Menu) $menu
  $menu entryconfigure $GUI_Text(StartSOAP) -state disabled
  $menu entryconfigure $GUI_Text(StopSOAP)  -state normal
  Agent::Play stop RestPose DoMagic1 DoMagic2 RestPose
};# GUI_SOAPStartServer

proc GUI_SOAPStopServer {} {
  global GUI_Text GUI_SOAP
  if {![info exists GUI_SOAP]} {return}
  set menu $GUI_SOAP(Menu)
  unset -nocomplain GUI_SOAP
  $menu entryconfigure $GUI_Text(StartSOAP) -state normal
  $menu entryconfigure $GUI_Text(StopSOAP)  -state disabled
};# GUI_SOAPStopServer
