##############################################################################
##  Help.tcl:                                                               ##
## ---------------------                                                    ##
##  This file contains functions implementing the "Help" menu.              ##
##                                                                          ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Software and Knowledge Engineering Laboratory,                          ##
##  Institute of Informatics and Telecommunications,                        ##
##  N.C.S.R. "Demokritos"                                                   ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Text Engineering Platform.                                    ##
##############################################################################
##############################################################################
##  Ellogon Help Dialogs and Facilities
##   George Petasis, 5/11/1998
##############################################################################

## Help About Dialog...
proc GUI_Help_About {{win .winAboutApplication}} {
  if {[winfo exists $win]} {
    raise $win
    return
  }
  global GUI_Options GUI_Text ApplicationName ApplicationVersion HomeDir
  
  set AuthorsHTML {
    <HTML><BODY>
    <H1>Collection &amp; Document Manager (CDM)</H1>
    <TABLE BORDER=0 CELLSPACING=2 CELLPADDING=0 NOSAVE>
      <tr NOSAVE><td NOSAVE>Design:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Implementation:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>C++ Bindings (OCDM):</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Tcl Bindings:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Java Bindings:</td>
        <td>
          <a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a>,
          <a href="mailto:adais@iit.demokritos.gr">Alexandros Dais</a>
        </td>
      </tr>
      <tr NOSAVE><td NOSAVE>Perl Bindings:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Python Bindings:</td>
        <td>
          <a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a>,
          <a href="mailto:steven.bethard@colorado.edu">Steven Bethard</a>
        </td>
      </tr>
    </TABLE>
    <H1>Graphical User Interface</H1>
    <TABLE BORDER=0 CELLSPACING=2 CELLPADDING=0 NOSAVE>
      <tr NOSAVE><td NOSAVE>Design:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Implementation:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
    </TABLE>
    <H2>Graphical User Interface Localisation</H2>
    <TABLE BORDER=0 CELLSPACING=2 CELLPADDING=0 NOSAVE>
      <tr NOSAVE><td NOSAVE>English:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Hellenic (Greek):</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
    </TABLE>
    <H1>Sample Plug-in Modules</H1>
    <TABLE BORDER=0 CELLSPACING=2 CELLPADDING=0 NOSAVE>
      <tr NOSAVE><td NOSAVE>HTokenizer:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>HBrill:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>HMorph:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>HGazetteer:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>HLemmatiser:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>HMorph:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>HStemmer:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>HCFGParser:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>HNPChunker:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>HPcPatr:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>JavaTokeniserSplitter:</td>
        <td><a href="mailto:adais@iit.demokritos.gr">Alexandros Dais</a></td>
      </tr>
    </TABLE>
    <H1>Tools</H1><hr size=1>
    <TABLE BORDER=0 CELLSPACING=2 CELLPADDING=0 NOSAVE>
      <tr NOSAVE><td NOSAVE>Create Stand-Alone<br>Application Wizard:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Run Component Tool:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Tool for Editing Annotations:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Tool for Editing Annotations on HTML:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Tool for Editing Hierarchical<br>Related Annotations:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Tool for Editing Coreferences:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Tool For Editing Attributes:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Rename Annotations Tool:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Collection/Document Statistics Tool:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Remove Annotations/Attributes Tool:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Copy/Transfer Annotations<br>between Collections Tool:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Document Comparison Tool:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Collection Comparison Tool:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Create Vectors Tool:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Create Vectors Tool<br>(Bag of Words Representation):</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Export Annotation Attribute Tool:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Export SGML Tool:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Create Annotations form Vectors Tool:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>ARFF Vector Creation Tool (WEKA):</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>C4.5 Suite:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
    </TABLE>
    <H1>Documentation</H1>
    <TABLE BORDER=0 CELLSPACING=2 CELLPADDING=0 NOSAVE>
      <tr NOSAVE><td NOSAVE>C++ CDM:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Tcl CDM:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
      <tr NOSAVE><td NOSAVE>Java CDM:</td>
        <td>
          <a href="mailto:adais@iit.demokritos.gr">Alexandros Dais</a>,
          <a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a>
        </td>
      </tr>
      <tr NOSAVE><td valign=top NOSAVE>User Manual:</td>
        <td>
          <a href="mailto:stergos@iit.demokritos.gr">Stergos Afantenos</a>,
          <a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a>,<br>
          <a href="mailto:vangelis@iit.demokritos.gr">Vangelis Karkaletsis</a>
        </td>
      </tr>
      <tr NOSAVE><td valign=top NOSAVE>Developer Manual:</td>
        <td>
          <a href="mailto:stergos@iit.demokritos.gr">Stergos Afantenos</a>,
          <a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a>,<br>
          <a href="mailto:vangelis@iit.demokritos.gr">Vangelis Karkaletsis</a>
        </td>
      </tr>
      <tr NOSAVE><td NOSAVE>Help Organisation:</td>
        <td><a href="mailto:petasis@iit.demokritos.gr">Georgios Petasis</a></td>
      </tr>
    </TABLE>
    </BODY></HTML>
  }

  set CreditsHTML \
"<HTML><BODY>
<H1>$ApplicationName Development:</H1>
<p>$ApplicationName was designed and implemented by
  <a href=\"http://www.iit.demokritos.gr/~petasis\"><b>Georgios Petasis</b></a>
  (<a href=\"mailto:petasis@iit.demokritos.gr\">petasis@iit.demokritos.gr</a>)
</p>
<H1>$ApplicationName utilises the following packages:</H1>
<H2><a href=http://www.tcl.tk>Tcl/Tk</a></H2>
<p>We would like to thank the TCT and the Tcl community for developing such an
exceptional package, Tcl/Tk. Special thanks to the original author,
<a href=\"\">John Ousterhout</a> and the various posters at comp.lang.tcl
for their valuable help.
</p>
<H2><a href=http://tcllib.sourceforge.net>BWidgets</a></H2>
<H2><a href=http://mkwidgets.sourceforge.net>mkWidgets</a></H2>
<H2><a href=http://>Multicolumn Listbox Widget</a></H2>
<p>by Bryan Oakley (<a href=\"mailto:oakley@channelpoint.com\">oakley@channelpoint.com</a>)
</p>
<H2><a href=http://>Pane Widget</a></H2>
<p>by Jeffrey Hobbs (<a href=\"mailto:jeff.hobbs@acm.org\">jeff.hobbs@acm.org</a>)
</p>
<H2><a href=http://>Progress Widget</a></H2>
<p>by Donal K. Fellows (<a href=\"mailto:\">????</a>)
</p>
<H2><a href=http://>Tk Console Widget</a></H2>
<p>by Jeffrey Hobbs (<a href=\"mailto:jeff.hobbs@acm.org\">jeff.hobbs@acm.org</a>)
</p>
<H2><a href=http://>Tk Table Widget</a></H2>
<p>by Jeffrey Hobbs (<a href=\"mailto:jeff.hobbs@acm.org\">jeff.hobbs@acm.org</a>)
</p>
<H2><a href=http://www.hwaci.com/drh/>Tree Widget (Tcl)</a></H2>
<p>by D. Richard Hipp (<a href=\"mailto:drh@acm.org\">drh@acm.org</a>)
</p>
<H2><a href=ftp://ftp.archive.eso.org/pub/tree>Tree Widget (C)</a></H2>
<p>by Allan Brighton (<a href=\"\"></a>)
</p>
<H2><a href=http://tclhttpd.sourceforge.net>Tcl HTTPD</a></H2>
<p>by Stephen Uhler and Brent Welch (<a href=\"\"></a>)
</p>
<H2><a href=http://>Tcl SOAP</a></H2>
<p>by Pat Thoyts (<a href=\"Pat.Thoyts@bigfoot.com\">Pat.Thoyts@bigfoot.com</a>)
</p>
<H2><a href=http://>Tcl ODBC</a></H2>
<p>by Roy Nurmi (<a href=\"Roy.Nurmi@iki.fi\">Roy.Nurmi@iki.fi</a>)
</p>
<H2><a href=http://tclxml.sourceforge.net>Tcl XML</a></H2>
<p>by Steve Ball, Zveno Pty Ltd. (<a href=\"Steve.Ball@zveno.com\">Steve.Ball@zveno.com</a>)
</p>
<H2><a href=http://tclxml.sourceforge.net>tDOM - a XML/DOM/XPath implementation for Tcl</a></H2>
<p>by Jochen Loewer (<a href=\"loewerj@hotmail.com\">loewerj@hotmail.com</a>)
</p>
<H2><a href=http://www.sourceforge.net/projects/tkdnd>tkDND - Cross-platform Drag and Drop support</a></H2>
<p>by Georgios Petasis (<a href=\"petasis@iit.demokritos.gr\">petasis@iit.demokritos.gr</a>)
</p>
<H2><a href=http://installbase.sourceforge.net>Installbase - The Ellogon Installer</a></H2>
<p>by Damon Courtney (<a href=\"damon@unreality.com\">damon@unreality.com</a>)
</p>
</BODY></HTML>"
  
  ## Create Window
  set bg #969AAD
  set bg [.mw cget -background]
  set fg navy
  toplevel $win -bg $bg
  wm withdraw $win
  wm title $win "About $ApplicationName version $ApplicationVersion..."

  ## Label...
  GUI_LoadImage Install
  NoteBook $win.tabs -bg $bg -width 300 -bd 1
  set frame [$win.tabs insert end Copyright -text Copyright -background $bg]
    label $frame.image -image Install -highlightthickness 0 -bd 1 -bg $bg \
      -anchor ne -relief sunken
    label $frame.title -text "$ApplicationName version $ApplicationVersion..." \
      -font {Helvetica 13 bold} -fg black -bg $bg
    button $frame.ok -textvariable GUI_Text(Ok) -command "destroy $win" \
      -bg $bg -fg $fg -highlightthickness 0
    ::ScrolledWidgets::ScrolledHtml $frame.text -bg $bg -fg $fg \
      -width 380 -height 8 -bd 1 -relief flat -scrollhighlightthickness 0 \
      -hyperlinkcommand "puts kalo" -scrollbackground $bg
    ::HtmlInfoViewer::DefaultBingings $frame.text.html
    bind $frame.text.html.x <<MB_1>> \
      {if {[string length [%W href %x %y]]} {
         ::HtmlInfoViewer::InfoViewer [%W href %x %y]
       }}
    $frame.text.html parse \
   "<HTML>Copyright &copy; 1998-[clock format [clock seconds] -format %Y] by\
    <br><br>Georgios P. Petasis,\
    <br>Software and Knowledge Engineering Laboratory,<br>Institute of\
    Informatics and Telecomunications, <br>National Centre for Scientific\
    Research &quot;Demokritos&quot;,<br>Athens, Greece.
    <p><center><a href=http://www.ellogon.org>
    http://www.ellogon.org</a></center></p></HTML>"
    grid $frame.image -column 0 -row 0 -sticky snew -padx 0 -pady 0 -rowspan 3
    grid $frame.title -column 1 -row 0 -sticky  new -padx 10 -pady 0
    grid $frame.text  -column 1 -row 1 -sticky snew -padx 10 -pady 10
    grid $frame.ok    -column 1 -row 2 -sticky se   -padx 0 -pady 2
    grid columnconfigure $frame 1 -weight 1
    grid rowconfigure $frame 1 -weight 1
  set frame [$win.tabs insert end Version -text {CDM Version} -background $bg]
    label $frame.image -image Install -highlightthickness 0 -bd 1 -bg $bg \
      -anchor ne -relief sunken
    label $frame.title -text "$ApplicationName version $ApplicationVersion..." \
      -font {Helvetica 13 bold} -fg black -bg $bg
    button $frame.ok -textvariable GUI_Text(Ok) -command "destroy $win" \
      -bg $bg -fg $fg -highlightthickness 0
    ::ScrolledWidgets::ScrolledHtml $frame.text -bg $bg -fg $fg \
      -width 380 -height 8 -bd 1 -relief sunken -scrollbackground $bg \
      -scrollhighlightthickness 0
    ::HtmlInfoViewer::DefaultBingings $frame.text.html
    bind $frame.text.html.x <<MB_1>> \
      {if {[string length [%W href %x %y]]} {
         ::HtmlInfoViewer::InfoViewer [%W href %x %y]
       }}
    $frame.text.html parse \
     "<HTML><TABLE BORDER=0 CELLSPACING=2 CELLPADDING=0 NOSAVE>
      <tr NOSAVE><td NOSAVE>CDM Version:</td>
        <td>[CDM_Version]</td>
      </tr>
      <tr NOSAVE><td NOSAVE>CDM Major Version:</td>
        <td>[CDM_MajorVersion]</td>
      </tr>
      <tr NOSAVE><td NOSAVE>CDM Minor Version:</td>
        <td>[CDM_MinorVersion]</td>
      </tr>
      <tr NOSAVE><td NOSAVE>CDM Patch Level:</td>
        <td>[CDM_PatchLevel]</td>
      </tr>
      <tr NOSAVE><td NOSAVE>CDM Release Date:</td>
        <td>[CDM_ReleaseDate]</td>
      </tr>
      <tr NOSAVE><td NOSAVE NOWRAP>CDM Release Date<br>(Extented):</td>
        <td NOWRAP>[CDM_ExtendedReleaseDate]</td>
      </tr>
      <tr NOSAVE><td NOSAVE NOWRAP>Tcl Version:</td>
        <td NOWRAP>[info tclversion]</td>
      </tr>
      <tr NOSAVE><td NOSAVE NOWRAP>Tcl Patch Level:</td>
        <td NOWRAP>[info patchlevel]</td>
      </tr>
      </table></html>"
    grid $frame.image -column 0 -row 0 -sticky snew -padx 0 -pady 0 -rowspan 3
    grid $frame.title -column 1 -row 0 -sticky  new -padx 10 -pady 0
    grid $frame.text  -column 1 -row 1 -sticky snew -padx 3 -pady 10
    grid $frame.ok    -column 1 -row 2 -sticky se   -padx 0 -pady 2
    grid columnconfigure $frame 1 -weight 1
    grid rowconfigure $frame 1 -weight 1
  set frame [$win.tabs insert end Authors   -text Authors -background $bg]
    label $frame.image -image Install -highlightthickness 0 -bd 1 -bg $bg \
      -anchor ne -relief sunken
    label $frame.title -text "$ApplicationName version $ApplicationVersion..." \
      -font {Helvetica 13 bold} -fg black -bg $bg
    button $frame.ok -textvariable GUI_Text(Ok) -command "destroy $win" \
      -bg $bg -fg $fg -highlightthickness 0
    ::ScrolledWidgets::ScrolledHtml $frame.text -bg $bg -fg $fg \
      -width 380 -height 8 -bd 1 -relief sunken -scrollbackground $bg \
      -scrollhighlightthickness 0
    ::HtmlInfoViewer::DefaultBingings $frame.text.html
    bind $frame.text.html.x <<MB_1>> \
      {if {[string length [%W href %x %y]]} {
         ::HtmlInfoViewer::InfoViewer [%W href %x %y]
       }}
    $frame.text.html parse $AuthorsHTML
    grid $frame.image -column 0 -row 0 -sticky snew -padx 0 -pady 0 -rowspan 3
    grid $frame.title -column 1 -row 0 -sticky  new -padx 10 -pady 0
    grid $frame.text  -column 1 -row 1 -sticky snew -padx 3 -pady 10
    grid $frame.ok    -column 1 -row 2 -sticky se   -padx 0 -pady 2
    grid columnconfigure $frame 1 -weight 1
    grid rowconfigure $frame 1 -weight 1
  set frame [$win.tabs insert end Credits   -text Credits -background $bg]
    label $frame.image -image Install -highlightthickness 0 -bd 1 -bg $bg \
      -anchor ne -relief sunken
    label $frame.title -text "$ApplicationName version $ApplicationVersion..." \
      -font {Helvetica 13 bold} -fg black -bg $bg
    button $frame.ok -textvariable GUI_Text(Ok) -command "destroy $win" \
      -bg $bg -fg $fg -highlightthickness 0
    ::ScrolledWidgets::ScrolledHtml $frame.text -bg $bg -fg $fg \
      -width 380 -height 8 -bd 1 -relief sunken -scrollbackground $bg \
      -scrollhighlightthickness 0
    ::HtmlInfoViewer::DefaultBingings $frame.text.html
    bind $frame.text.html.x <<MB_1>> \
      {if {[string length [%W href %x %y]]} {
         ::HtmlInfoViewer::InfoViewer [%W href %x %y]
       }}
    $frame.text.html parse $CreditsHTML
    grid $frame.image -column 0 -row 0 -sticky snew -padx 0 -pady 0 -rowspan 3
    grid $frame.title -column 1 -row 0 -sticky  new -padx 10 -pady 0
    grid $frame.text  -column 1 -row 1 -sticky snew -padx 3 -pady 10
    grid $frame.ok    -column 1 -row 2 -sticky se   -padx 0 -pady 2
    grid columnconfigure $frame 1 -weight 1
    grid rowconfigure $frame 1 -weight 1
  $win.tabs raise Copyright
  pack $win.tabs -fill both -expand 1
  update
  $win.tabs compute_size
  update
  gut_ModalDlg $win
  wm deiconify $win
  return
  ## Copyright Notice
  if {[catch {image create photo LogoImage -file \
    [file join $HomeDir share Themes $GUI_Options(GUI_Theme) Logo.gif]}]} {
    image create photo LogoImage -file \
    [file join $HomeDir share Themes Default Logo.gif]
  }
  set iw [image width  LogoImage]; set ih [image height LogoImage]
  set frame $win.copyright 
  canvas $frame -relief groove -bd 2 -width $iw -height $ih
  $frame create image 3 3 -image LogoImage -anchor nw
  ## Shadow 2...
  $frame create text  [expr $iw/2] [expr $ih/2] -fill black \
         -text $Message  -anchor c -font {arial 16 bold italic}
  ## Shadow 1...
  $frame create text  [expr $iw/2+1] [expr $ih/2+1] -fill grey \
         -text $Message  -anchor c -font {arial 16 bold italic}
  ## Text foreground
  $frame create text  [expr $iw/2+2] [expr $ih/2+2] -fill white \
         -text $Message  -anchor c -font {arial 16 bold italic}
  pack $frame -padx 5 -pady 5 
  ## Ok button
  set frame $win.ok_frame
  frame $frame 
  button $frame.ok -textvariable GUI_Text(Ok) -command \
   "destroy $win; image delete LogoImage"
  pack $frame.ok
  pack $frame -fill x -expand 1
  gut_ModalDlg $win
  wm deiconify $win
}

## Help Copyright Dialog...
proc GUI_Help_Copyright {{win .infoViewerHTML}} {
  GUI_Help_About $win
}

## Help Contents
proc GUI_Help_Contents {{win .infoViewerHTML}} {
  ::HtmlInfoViewer::InfoViewer $::HomeDir/doc/Welcome.html $win
}

## Help Release Notes
proc GUI_Help_Release_Notes {{win .infoViewerHTML}} {
  ::HtmlInfoViewer::InfoViewer $::HomeDir/doc/ReleaseNotes.html $win
}

## Help Product-Info-Support
proc GUI_Help_Product_Info_Support {{win .infoViewerHTML}} {
}

## Help Software Update
proc GUI_Help_Software_Update {{win .infoViewerHTML}} {
  package require http
  global ApplicationVersionId ApplicationName
  set location http://www.iit.demokritos.gr/~petasis/$ApplicationName/Update

  ## Download the Current Application Version Id...
  set token [::http::geturl $location/VersionID.html]
  set Data [string trim [::http::data $token]]
  ::http::cleanup $token
  if {$Data > $ApplicationVersionId} {
    set win [::HtmlInfoViewer::InfoViewer $location/SoftwareUpdate.html $win]
  } else {
    set win [::HtmlInfoViewer::InfoViewer $location/NoSoftwareUpdate.html $win]
  }
  Widget_PaneSet $win.main 1 0
};# GUI_Help_Software_Update
