#!/usr/bin/wish
#
# Copyright (C) 1998-2004 George P. Petasis
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with this library; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA  02111-1307, USA.
#
# author contact information:
#   petasis@iit.demokritos.gr
#   http://www.edu.physics.uch.gr/~petasis
#
# $revision: 1.0 $
#

#
# This library creates a Menu, which can have both an image and a text string.
# The only limitation is that you cannot create a menu with many columns...
#

namespace eval ImageMenu {

  ## Use this procedure instead of "menu"
  proc Menu {pathName args} {
    variable ImageMenu
    eval menu $pathName $args
    set tear_off [$pathName cget -tearoff]
    set ImageMenu($pathName) 0
    if {$tear_off} {
      $pathName add command -columnbreak 1
      incr ImageMenu($pathName)
    }
    proc ::$pathName:cmd {cmd type args} \
         "return \[eval ImageMenu::ImageMenuCallback $pathName \$cmd \
                    \$type \$args\]"
    return ::$pathName:cmd
  }

  proc ImageMenuCallback {widget cmd type args} {
    variable ImageMenu
    set real_widget_cmd $widget
    if {[string equal $cmd add] || [string equal $cmd insert]} {
      foreach {image bmp text arg_list} {{} {} {} {}} break
      foreach {opt val} $args {
        switch -glob -- $opt {
          -bi* {set bmp   $val}
          -im* {set image $val}
          -l*  {set text  $val}
          default {lappend arg_list $opt $val}
        }
      }
      if {$ImageMenu($widget) == 0} {
        lappend arg_list -columnbreak 1
      } else {
        lappend arg_list -columnbreak 0
      }
      if {[string equal $type separator]} {
        $real_widget_cmd insert $ImageMenu($widget) $type
	incr ImageMenu($widget)
        return [$real_widget_cmd insert end $type]
      }
      if {[string length $bmp] == 0} {
        $real_widget_cmd insert $ImageMenu($widget) command \
	    -image $image -hidemargin 1
      } else {
        $real_widget_cmd insert $ImageMenu($widget) command \
	    -bitmap $bmp -hidemargin 1
      }
      incr ImageMenu($widget)
      return [eval $real_widget_cmd insert end $type \
              -label [list $text] $arg_list]
    } else {
      return [eval $real_widget_cmd $type $args]
    }
  }
};# namespace ImageMenu
