#!/bin/sh
# The next line is executed by /bin/sh, but not tcl \
exec wish "$0" ${1+"$@"}
##############################################################################
##  ByteCompile.tcl:                                                        ##
## --------------------------------                                         ##
##                                                                          ##
##  Copyright 1998-2007 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Software and Knowledge Engineering Laboratory,                          ##
##  Institute of Informatics and Telecommunications,                        ##
##  N.C.S.R. "Demokritos"                                                   ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Text Engineering Platform.                                    ##
##############################################################################
wm withdraw .
## Display our main window...
proc MainWindow {} {
  option add *borderWidth 1
  wm title . "Tcl Byte Compilation Tool..."

  image create photo Logo -data \
{R0lGODlhoAA7APcAAJwAMZwAOaUAOZwIOaUIOZwIQqUIQpwQOaUQOaUQQq0Q
QqUQSq0QSqUYQqUYSq0YSq0hQqUhSq0hSqUhUq0hUqUpSq0pSq0pUrUpUrUp
Wq0xUrUxUq0xWrUxWrUxYwAxnAgxnK05WrU5WrU5Y7U5awA5nAg5nBA5nAA5
pQg5pRA5pb1CUrVCWr1CWrVCY71CY7VCa71CawhCpRBCpRhCpb1KWrVKY71K
Y7VKaxBKpRhKpSFKpSlKpSFKrSlSpSlSrSlStSlatTFSrTFStTFarTFatTFa
vTFjrTlatUJjtUJjvUJrtUJrvUpjtUpjvUprtUprvVJrvVJztVJzvVJzxlJ7
vVpzvVpzxlp7vVqExmN7xmOExmOEzmOMxmuExmuEzrVac5xjhGuMxnOIxnOU
xnucxnOMznuMznuUzoSUzoSczoylznuU1nuc1oSc1oSl1oyc1oyl1pSl1pyt
1qWt1pyl3pyt3py13qWt3qW13qW93q213rW93rXG57XO57XG785SWr1aY71K
a71Sa71Kc71Sc8Zac8Zrc71Se8ZSe71ae8Zae8Zje8pjf85re85rhMhwjNZ7
e8ZrlNN1js57lNZzlNZ7lM57nNZ7nNaEjM6ElNaElM6EnNKMnN6MnN6UnNaM
pdaUpd6Mpd6Upd6cpd6lpdaMrdaUrd6Mrd6Urd6crd6lreetrd6Utd6ltd6t
teettd6lvd6tveelveetvee1ve+9vc6txt61xue1xue9xue9zu+9zu+91r29
3r295+/Gre/Gxu/Gzu/OzufG1u/G1r3G3r3G573O58bO58bO78rS787W78be
787e797O3u/O1u/O3u/W1u/W3u/e3vfOzvfO1vfO3vfW1vfW3vfW5/fe1vfe
3vfe5/fn5//n59bW79be797e797n7+fn7/fe7/fn7/fv7//n7//v79bW99be
997e997n9+fn9+fv9+/v9/fn9/fv9/f39//v9//39///997e/+fn/+fv/+/v
/+/3//f3//f////3/////ywAAAAAoAA7AAAI/gA/CBxIsKDBgwgTKlzIkOCJ
LeL+SZz4rxspGAMAaNzIsaPHjyBDigzZsKTJkygLlvACzh7Fl//mEXMxsqbN
mzYFltDJ88NOnz1/Cg1KFKjRoUeLIl1qAks4bjCj/qsXKoBGqwCwar3KNWvX
rV7Dgh37lWvKs2jPlojS7BykclKj9gOFs67dnD3z/tRLcO9eo4AB//Xbd+Dg
gUeM2YN2gVZcqfUQdZ2MlTLHypXDatacGfNGg38LHwxtGCHpvCpNDzyxBt6/
ZwkEzXssdVqByyAz4/6oe2PvyR5RFy0dOKno0EiJI0ddYomziSOsRqAEjfZL
fop4AxfbEazv7d4t/gNInbY82hNqZkvkl3HjABiuzlmXGOv73ft2ietfqry/
4OHJ8ceTDsa81E17HSWgiCzd0EZNAh55xl1ZFEroHVlegWbehiUdEQ5MxEzI
UQEcSPLKNOfUAxMH9uHn4kjCAeifcTLWSBhPR5Dj0kvBaPdRAyM0EkouxciX
XYTiiRjehfZJyJGGHBYX5Q7h7PhSLk5u19UAB1AQQXgvbnZXZfrxZdyNp6Fp
pppAFShROjzmtltvv1lIoYi7TWhnR6NteBpDJtAQqAkIibHjNlZKFE17YMqZ
Z5hi4ofVcDQe9t9xZhplBTnhkKMFajuQM1EtMHmDIJKb/dZkkkp2d+ee/puh
9adoJ2kx0RapqTGRPapE1QBwdc6ppaMiqWqXVfutSR6NzCn1ga0SeUGcCe9M
JA0wUY3gqm8uKOLtt9+CAUMFp3amJazAVtjiZwP5wE477sDLTrz0tjMvvPLW
yw4RCc06ELT/4FqQFBTJUh1MkKy7ES79SNSwwxPVI48ukETwqMI3GUssT0Tw
M19c/AhxJq2BASwtYHNQlAk1UbniIwC4fPyPOZzcdvGq6j6KrkYECcEMM33Q
AUcbYmxhtGsSxWE0GWy8QUcfyTDDb0mHASzwQCY8N5Ej3kRFjc2RxizzP8NM
4KPGGdc0KdaEIuTORE4g1HZxyelncmk7VCuR/j2HyAdTPdqiKvbY0BzQaItL
3vkqn3Qb9LZEUJj052lWF3SElfX0LRUlnHE0+NihvIw22jYhSzJgj/8Tt4B1
S0nc3UY9QVE9YPgNUzRyfi7zOWYPu/i6GOI5XkMlpB655OSRVjlBVlA0TyC2
w9QBmLpP9Eou6kXFOaqRFnsszyOjDnezMZa/F+xANR8xIF1LZUpI1f/TTwgB
DCKPVD0eniSY5nb+ZEnGW1byBEiQ5Q1EdhQRBMuk0g2bgSV+9mARADTxsJek
I1jAAVtIBlCAU9WkTDdKnRPSVBoTnMAHTXjCE35wgrkhBXY/IUKiFHEwqTwC
JPGbn0YmkCiK2EwR/qAAhSmCGMRKaCQCoXgGLzIClgHg4BTE6IY3ugGNUGAE
Z2s73UACWL4P+KAMybjf3v7Bj2aoYWoFMaBAdoA0iUSiFI8hRv8gKMEDwCkq
D9DIK6KiCwAUwhwSyYYHA6AIacRlGDjQWIyQIkIolYAGc5jNPJThhSUUAQpl
aElM5lAY9AnkBOOgyCooERdvEGJdOdSARhKQvZfkEQCvqOBEVCEI2wkyLAPg
RA9hMo9JOMl0ZSoIF0lDBHG4ZBxMMIgJzjAbTqbxVjzZCR8ososa1KYDADhA
uWAmlRBohBGQ2UgsYQKKBUrkGggKAAXnU4+EgSSYhBGhpYggqn8wQwcJ/sHC
PJSQF08KhAwUOccF7khNDRQiFuaAgUcgGIIBECJ6FJkGVsb5kmG8RJBYwcHY
5OFN70DJcRM5HmBO8CEyHmFGJhCD8qBZECK8hAW6eIk5YtGNHenigXIRBjRU
JJVTiFOWUkGnRgYQjbH9o48fMR9BGqkSMuxoDScRCgwJEsqJdIKUj6mHxTxn
1InYYKJAjcot6xfWf+SiEaSCSQRb9NHScJEnoJQIPH5Aq9b9i6Wl0ZW1OMBT
yNCPq12NxgF+ah2hAsAVUZmG4Q5QVJhsj3GNWyrcQiMFf0gkGV3E1LMmcjLA
CCF787CARePijwt8J360mUchuEJRmMgDGsLw/sY0DACAAbTvJZrYCCSiIoyy
9Ik4b/3JGiYCh+Vc6pkSuVpf+kCRSew2LubQDWrjYo/H6rGs53CBVRLwVQAk
oK8UWW1WYBAVb/SGUn9hKkGmGa1g/lYgUyXIEio4jAacY5cSoUtHphuVczBi
Mq2lCCc+ooGo1EMEWCkwTMzhgMmYZJgDAcdEpvBeEqoRMG6aSgs8IZVzUGAy
/KWIPFZhWo8EWCL0UOVkbBDWemBTIw6IyjwqEJxM7UWeBSnpP6jALAJutr3C
CZX1IgDRf9jDnfvFHzGE8YpOIGKwFDpxRWjbHRb/TYIAeEB/SxwWqgVXIMzA
6wBpdWHALGEeDZuH/gY4/BJcpHNhclGxTaRMjXUp+CUH3sidA/qrzCjLKOod
CHv/kYZMETC+BklCPUnRAHP+YxdQXmg307UZKUvUVQewLExWaxWNwuRAuHlw
SIlThh0Zo18ghK+Yi/IDZNhjHhFoxESE0eey0HFbrqJzngZgSJgMWCOa4G1S
ayQQHBOECJp+Bz6PqxD0TQ4EWxiHLGD5j1pACH5xBp6Jw3rpj5CivIN1wDS0
BxzifeCtQDFBmI3c2Y8mp8yum8EYwhAKSrwZxJP23nVhUmfL2EDTL9HFJGro
PDmb5VKhYepfrPAwdpygx6aJr6X2cmYkYxsm/VDxzqSsjQ3uwqi42I6o/iF3
EBDoYSJzmJtoTCCFfq66IWuohwSZhFpvjgSs/NaTRkIAcOuc48X2mdFQjA0Y
HSzDYWtwIUF24Is9hMbZMzLKCZohja3iMCprVRxHLF0sSOD3b0jWzcj/IVKD
0MAYmjZGElR+AimMwx9yeN3L3+uTHbijGAjAWSq7BxY6Z2mommiljN35mz9v
cXzDMYEXIiIRZswhDWqYw4fCsQUQGATRN9LPE/ZRi0gnOSo2992+XzKNl2kE
B6ONCi5YgCpgovoDe9gDHnyBBH994ARToAMz4AGPecBjHHmQggr6kwQ5rMEO
SrB9n7YwD13kfTOKoMQlKCF96lPiV63nCBiq/l/9SxCe0rV1QSh2McVp1IIS
GmAUSYjtXjYJZAY88IEOLMUQ1sWoDPPohdW7lzPu4YR0IeFR9ddWKUF/7kU1
A5EG/TANNME9o0MsOINrYvJ3jON+7WcjCDhmNmYQauAP8wAK6geBdKJtEEiC
ppdFCmFcKBEgdOdj7oYG/VAP0zAI2wR+/GeD/dM/EVhu7Ec+gWFXqvGD8EQp
BUEG6rELkqEqOig8OKg2ARhq5qZFSoVwLRhVQeEF6tENeWIsGCSBuPZ3FAg+
bOIvraN8Lmh/hlYQWFAtWnhzJngzrFKCEog8rvN6FniAKygaSDAOw6Bz/wd+
XBiHYDg8lZKChheFFRpIhVISGj5wC/q2M3DoP/pGLAEBAAA7}

  set f .title
  frame $f
    label $f.image -image Logo
    label $f.label -text "ByteCode Compilation Tool..." -font {Arial 17 bold}
    grid $f.image $f.label -sticky snew
    grid columnconfigure $f 1 -weight 1
  pack $f -padx 4 -pady 4 -fill x -expand 1

  frame .area -relief sunken -bd 1
  set f .area.dir
  frame $f
    global CompileDir OutputDir TclCompiler CompiledExtension
    ## Compile directory
    label  $f.dir    -text {Compile scripts in Directory:} -anchor w
    entry  $f.dirval -textvar CompileDir -width 65
    set CompileDir [pwd]
    button $f.dirsel -text Browse... -command "SelectDir $f.dirval"
    ## Output directory
    label  $f.outdir -text {Place compiled scripts in Directory:} -anchor w
    entry  $f.outval -textvar OutputDir
    set OutputDir [file join [pwd] Compiled]
    button $f.outsel -text Browse... -command "SelectDir $f.outval"
    ## Procomp executable
    label  $f.comexe -text {Tcl compiler executable:} -anchor w
    entry  $f.comval -textvar TclCompiler
    button $f.comsel -text Browse... -command "SelectFile $f.comval"
    ## Compiled file extension...
    label  $f.ext    -text {Compiled file extension:} -anchor w
    entry  $f.extval -textvar CompiledExtension
    set CompiledExtension .tbc
    grid $f.dir    $f.dirval $f.dirsel -sticky snew -padx 2 -pady 2
    grid $f.outdir $f.outval $f.outsel -sticky snew -padx 2 -pady 2
    grid $f.comexe $f.comval $f.comsel -sticky snew -padx 2 -pady 10
    grid $f.ext    $f.extval           -sticky snew -padx 2 -pady 10
    grid columnconfigure $f 1 -weight 1
  pack $f -padx 2 -pady 4 -fill x -expand 1
  pack .area -padx 6 -pady 4 -fill both -expand 1

  set f .buttons
  frame $f
    button $f.compile -text Compile -command Compile -bd 1
    button $f.close -text Close -command exit -bd 1
    grid $f.compile $f.close -sticky snew -padx 10
  pack $f -padx 2 -pady 4 -side top -expand 0
  gut_ModalDlg .
  update
  wm deiconify .
};# MainWindow

## Select Directory Utility...
proc SelectDir {entry} {
  set cwd [$entry get]
  set dir [tk_chooseDirectory -initialdir $cwd -title {Select Directory:}]
  if {[string length $dir]} {
    $entry delete 0 end
    $entry insert end $dir
  }
};# SelectDir

## Select File Utility...
proc SelectFile {entry} {
  set cwd [file dirname [$entry get]]
  set file [tk_getOpenFile -initialdir $cwd -title \
    {Please Locate "procomp" executable:}]
  if {[string length $file]} {
    $entry delete 0 end
    $entry insert end $file
  }
};# SelectFile

## The function that does the actual work...
proc Compile {} {
  global CompileDir OutputDir TclCompiler

  ## Check whether the output directory already exists...
  if {[file isdirectory $OutputDir]} {
    set ans [tk_dialog .msg {Output Directory already exists!} \
      "The output directory \"$OutputDir\" already exists!\
      Do you want to overwrite it?" info 0 Overwrite Cancel]
    if {$ans == 1} return
  }
  Log "Creating Directory: \"$OutputDir\"..." header
  catch {file mkdir $OutputDir}
  CompileDir $CompileDir
};# Compile

## This function compiles all tcl files in the specified dir and recursively
## continues to other dirs...
proc CompileDir {dir} {
  if {[catch {glob [file join $dir *] [file join $dir .*]} files_dirs]} return
  foreach file_dir $files_dirs {
    if {[string equal [file tail $file_dir] .] ||
        [string equal [file tail $file_dir] ..]} {
      continue
    }
    if {[file isfile $file_dir]} {
      CompileFile $file_dir
    } elseif {[file isdirectory $file_dir]} {
      CompileDir $file_dir
    }
  }
};# CompileDir

## This function compiles all tcl files in the specified dir and recursively
## continues to other dirs...
proc CompileFile {file} {
  global CompileDir OutputDir TclCompiler CompiledExtension
  set file_tail [file tail $file]
  set rel_file [string range $file [expr {[string length $CompileDir]+1}] end]
  set target_dir [file join $OutputDir [file dirname $rel_file]]
  if {![file exists $target_dir]} {
    Log "Creating directory: \"$target_dir\"" header
    if {[catch {file mkdir $target_dir} error]} {
      Log $error error
    }
  }
  switch -exact [string tolower [file extension $file_tail]] {
    .tcl {
      Log "Compiling file \"$file_tail\" to \"[file join $target_dir [file \
        rootname $file_tail]$CompiledExtension]\"..." compile
      if {[catch {exec $TclCompiler -nologo -out [file join $target_dir \
        [file rootname $file_tail]$CompiledExtension] $file} error]} {
        Log $error error
      }
    }
    default {
      ## Just copy the file...
      Log "Copying file \"$file_tail\" to directory \"$target_dir\""
      if {[catch {file copy -force $file [file join $target_dir $file_tail]} \
                                                 error]} {
        Log $error error
      }
    }
  }
}

## This command shows messages to the end user...
proc Log {message {type {}} args} {
  set win .logWindow
  set text $win.text.text
  if {![winfo exists $win]} {
    toplevel $win
    wm title $win {Log Window...}
    ::ScrolledWidgets::ScrolledText $win.text -width 65 -wrap none
    pack $win.text -fill both -expand 1
    button $win.close -text Close -command "destroy $win"
    pack $win.close -side top -pady 6
    $text tag configure header  -background black  -foreground white
    $text tag configure compile -background yellow -foreground black
    $text tag configure error   -background red    -foreground white
  }

  $text configure -state normal
  switch -exact $type {
    header  {$text insert end "\n$message\n \n" header}
    error   {$text insert end "\n$message\n \n" error}
    compile {$text insert end "$message\n" compile}
    default {$text insert end "$message\n"}
  }
  $text see end
  $text configure -state disabled
  update
};# Log

namespace eval ::ScrolledWidgets {
  variable ScrolledWidgets_ScrollbarStatus
  namespace export ScrollbarSet ScrolledText
}
#
# This function, automatically hides/shows the scrollbar
#
proc ::ScrolledWidgets::ScrollbarSet {widget args} {
  variable ScrolledWidgets_ScrollbarStatus
  set parent [winfo parent $widget]
  if {[winfo width $parent] == 1} {
    if {[winfo height $parent] == 1} {
      ## Parent has geometry 1x1 (is unmapped). Don't pack scrollbars
      return {}
    }
  }
  if {[string equal [lindex $args 0] set] && \
      [lindex $args end] == 1 && [lindex $args 1] == 0} {
    ## Hide scrollbar...
    if {$ScrolledWidgets_ScrollbarStatus($widget) == 1} {
      grid forget $widget
      set ScrolledWidgets_ScrollbarStatus($widget) 0
    }
  } else {
    if {$ScrolledWidgets_ScrollbarStatus($widget) == 0} {
      set grid_args $ScrolledWidgets_ScrollbarStatus(${widget}_args)
      set parent [winfo toplevel $widget]
      eval grid $widget $grid_args
      wm geometry $parent [wm geometry $parent ]
      set ScrolledWidgets_ScrollbarStatus($widget) 1
    }
    eval $widget $args
  }
};# ::ScrolledWidgets::ScrollbarSet

###############################################################################
###                                                                         ###
###     Scrolled Text Widget                                                ###
###                                                                         ###
###############################################################################

#
# Scrolled Text
#  Arguments: all these of the text widget, plus:
#   -widgetname : name of the internal widget
#   -scrollborderwidth (or -scrollbd) : the borderwidth of scrollbars
#   -scrollforeground  (or -scrollfg) : the foreground color of scrollbars
#   -scrollbackground  (or -scrollbg) : the background color of scrollbars
#
proc ::ScrolledWidgets::ScrolledText {w args} {
  variable ScrolledWidgets_ScrollbarStatus
  ## Process Arguments
  set text_args {}; set general_args {}; set grid_args {}; set scroll_args {}
  set frame_args {}; set widgetname text
  foreach {op arg} $args {
    switch -glob -- $op {
      -bd         -
      -bord*      {lappend general_args $op $arg}
      -scroll*    {lappend scroll_args "-[string range $op 7 end]" $arg}
      -xsc*       -
      -ysc*       {}
      -padx       -
      -pady       -
      -ipadx      -
      -ipady      {lappend grid_args  $op $arg}
      -widgetname {set     widgetname     $arg}
      default     {lappend text_args  $op $arg}
    }
  }
  ## Create the Widget
  if {[catch {
    eval frame  $w -borderwidth 0 -relief flat -highlightthickness 0 $frame_args
    eval text ${w}.$widgetname $general_args $text_args \
      -xscrollcommand \
        [list [list ::ScrolledWidgets::ScrollbarSet ${w}.horizontal set]] \
      -yscrollcommand \
        [list [list ::ScrolledWidgets::ScrollbarSet ${w}.vertical set]]
    eval scrollbar ${w}.horizontal $scroll_args \
      -command [list [list ${w}.$widgetname xview]] -orient horizontal  
    eval scrollbar ${w}.vertical   $scroll_args \
      -command [list [list ${w}.$widgetname yview]] -orient vertical  
    eval grid ${w}.$widgetname -sticky snew $grid_args
    grid rowconfigure    $w 0 -weight 1
    grid columnconfigure $w 0 -weight 1
    bind $w <Destroy> {catch {\
    unset ::ScrolledWidgets::ScrolledWidgets_ScrollbarStatus(%W.horizontal)
    unset ::ScrolledWidgets::ScrolledWidgets_ScrollbarStatus(%W.horizontal_args)
    unset ::ScrolledWidgets::ScrolledWidgets_ScrollbarStatus(%W.vertical)
    unset ::ScrolledWidgets::ScrolledWidgets_ScrollbarStatus(%W.vertical_args)}}
    set ScrolledWidgets_ScrollbarStatus(${w}.horizontal) 0
    set ScrolledWidgets_ScrollbarStatus(${w}.horizontal_args) \
      [eval list -sticky snew -column 0 -row 1 $grid_args]
    set ScrolledWidgets_ScrollbarStatus(${w}.vertical)   0
    set ScrolledWidgets_ScrollbarStatus(${w}.vertical_args) \
      [eval list -sticky snew -column 1 -row 0 $grid_args]
    catch {focus ${w}.$widgetname}
  } error]} {
    catch {destroy $w}
    error $error
  }
  return ${w}.$widgetname
};#::ScrolledWidgets::ScrolledText

## gut_ModalDlg
proc gut_ModalDlg {win {req_x 0} {req_y 0}} {
  update
  set sw [winfo screenwidth  .]
  set sh [winfo screenheight .]
  if {$req_x && $req_y} {
    set x [expr {($sw - $req_x)/2}]
    set y [expr {($sh - $req_y)/2}]
    wm geometry $win ${req_x}x$req_y+${x}+$y
  } else {
    set x [expr {($sw - [winfo reqwidth $win])/2}]
    set y [expr {($sh - [winfo reqheight $win])/2}]
    if {$x < 10 && $y < 10} {
      set x [expr {($sw - [winfo width $win])/2}]
      set y [expr {($sh - [winfo height $win])/2}]
    }
    if {$x < 10 && $y < 10} {
      set x [expr {$sw / 2}]
      set y [expr {$sh / 2}]
    }
    wm geometry $win +${x}+$y
  }
  update
  #bind $win <Visibility> "raise $win"
}

## Start utility...
MainWindow

## Under windows, perhaps we can take procomp location from registry...
if {![catch {package require registry}]} {
  ## The registry package was loaded. We are under windows :-)
  ##
  ## Step 1: Search for Tcl Dev Kit...
  ##
  set key     {HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows}
  append key  {\CurrentVersion\Uninstall}
  foreach keyname [registry keys $key *TclDevKit*] {
    set uninstall_location [string trim \
        [registry get $key\\$keyname UninstallString] \"]
    while {[string length $uninstall_location] > 5} {
      if {[file exists $uninstall_location/bin/tclcompiler.exe]} {
        set TclCompiler $uninstall_location/bin/tclcompiler.exe
	break
      } else {
        set uninstall_location [file dirname $uninstall_location]
      }
    }
  }

  ##
  ## Step 2: Is TclPro Installed?
  ##
  if {![string length TclCompiler]} {
    set installed 0
    set Keys [list {HKEY_LOCAL_MACHINE\SOFTWARE\Scriptics\TclPro\1.4.1}]
    foreach key $Keys {
      if {![catch {registry get $key PkgPath} TclProDir]} {
        ## We have found it!
        set installed 1
        break
      }
    }
    if {$installed} {
      set procomp [file attributes [file nativename [file join \
                                [lindex $TclProDir 1] procomp.exe]] -longname]
      if {[file executable $procomp]} {
        set TclCompiler $procomp
      }
    }
  }
} else {
  ## Possibly under Unix? Can we use which?
  if {![catch {exec which procomp} procomp]} {
    if {[file executable $procomp]} {
      set TclCompiler $procomp
    }
  }
}
