#!/bin/sh
# The next line is executed by /bin/sh, but not tcl \
exec tclsh "$0" ${1+"$@"}
##############################################################################
##  RenameMissingDocuments.tcl:                                             ##
## --------------------------------                                         ##
##                                                                          ##
##  Copyright 1998-2004 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Software and Knowledge Engineering Laboratory,                          ##
##  Institute of Informatics and Telecommunications,                        ##
##  N.C.S.R. "Demokritos"                                                   ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Text Engineering Platform.                                    ##
##############################################################################
if {$argc == 0} {
  puts stderr "$argv0: This script will ensure that missing Documents"
  puts stderr "\t\t\t     have the correct OD name, if they exist..."
  puts stderr "  Usage: $argv0 directory"
  exit -1
}

proc ProcessIndex {dir} {
  cd $dir
  foreach filename [glob -nocomplain -type f *] {
    if {$filename == ".CDM_CollectionIndex.txt"} {continue}
    puts "Examining Document: $filename"
    set file [open $filename]
    fconfigure $file -encoding utf-8 -translation lf
    while {[gets $file line] != -1} {
      switch -glob -- $line {
        ID::* {
          set ID [string range $line 4 end-1]
	  puts "  Document ID: \"$ID\""
	  break
        }
        default {}
      }
    }
    close $file
    if {$ID != $filename} {
      puts "  Document needs renaming: $filename -> $ID"
      file rename $filename $ID
      puts "  Document renamed successfully!"
    } else {
      puts "  Document does not need renaming..."
    }
  }
};# ProcessIndex

catch {console show}
puts "System Encoding: [encoding system]"
foreach dir $argv {
  if {[file isdirectory $dir]} {
    ProcessIndex [file normalize $dir]
  }
}
#exit 0
