##############################################################################
##  TestSystemManagement.tcl:                                               ##
## --------------------------------                                         ##
##                                                                          ##
##  Copyright 1998-2004 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Software and Knowledge Engineering Laboratory,                          ##
##  Institute of Informatics and Telecommunications,                        ##
##  N.C.S.R. "Demokritos"                                                   ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Text Engineering Platform.                                    ##
##############################################################################
::SystemManagement::ReadConfigurationFile ~/.gate.props
set id 0
foreach graph [info commands ::SystemManagement::Graph::*] {
  if {[llength [$graph nodes]] < 2} {continue}
  puts "**** Graph: $graph"
  set geometry [$graph get -key Geometry]
  catch {destroy .x$id}
  toplevel .x$id
  ::ScrolledWidgets::ScrolledCanvas .x$id.c -bg white
  pack .x$id.c -fill both -expand 1
  ::SystemManagement::SetDefaultSystemGraphKeys $graph
  ::SystemManagement::LayoutGraph $graph
  ::SystemManagement::DrawSystemGraph $graph .x$id.c.canvas
  ::ScrolledWidgets::CanvasSetScrollRegion .x$id.c.canvas
  wm geometry .x$id $geometry
  incr id
}
