##########################################################################
# 
#	CorpusStatistics.tcl - Tuesday December 05 16:16:30 (EET) 2006
#       This is a loosed coupled (Tcl) Component for use with 
#       Ellogon, version 1.8.0...
#
##########################################################################

## creole_CorpusStatistics
#  
proc creole_CorpusStatistics {doc col args} {
  package require ELEP::Statistics::CorpusStatistics
  package require ELEP::ToolBase::ToolToplevel
  set obj [ELEP::ToolBase::ToolToplevel \
      create [ELEP::Base::auto .creole_CorpusStatistics_] $col $doc 1]
  set win [$obj getTopLevel]
  bind $win <<onDocumentChange>> [list creole_CorpusStatistics_onDocumentChange $obj]
  set win [$obj getframe]
  ScrolledWindow $win.sw
  text $win.sw.display -height 20 -width 60 -font FixedTextFont
  $win.sw setwidget $win.sw.display
  grid $win.sw -sticky snew
  grid columnconfigure $win 0 -weight 1
  grid rowconfigure $win 0 -weight 1
  $obj show
  $obj title {Corpus Statistics Tool...}
};# creole_CorpusStatistics

proc creole_CorpusStatistics_onDocumentChange {obj} {
  set col [$obj getCollection]
  set doc [$obj getDocument]
  set win [$obj getframe]
  set processor [ELEP::Base::local ELEP::Statistics::CorpusStatistics #auto]
  if {$doc eq ""} {
    tip_ForeachDocumentInCollection $col {
      $processor processDocument $doc
      tip_Close $doc
    }
  } else {
    $processor processDocument $doc
  }
  $win.sw.display delete 1.0 end
  $win.sw.display insert end [$processor report]
};# creole_CorpusStatistics_onDocumentChange
#
# End of File CorpusStatistics.tcl
#
