##########################################################################
# 
#	MD5.tcl - Tuesday December 05 16:16:30 (EET) 2006
#       This is a loosed coupled (Tcl) Component for use with 
#       Ellogon, version 1.8.0...
#
##########################################################################

## creole_MD5
#  
proc creole_MD5 {doc col args} {
  package require md5
  package require tablelist_tile
  package require BWidget
  package require ELEP::ToolBase::ToolToplevel
  package require ELEP::DocumentUtilities::HTMLUtilities
  set obj [ELEP::ToolBase::ToolToplevel \
      create [ELEP::Base::auto .creole_MD5_] $col $doc]
  set win [$obj getTopLevel]
  bind $win <<onDocumentChange>> [list creole_MD5_onDocumentChange $obj]
  set win [$obj getframe]
  ScrolledWindow $win.sw
  tablelist::tablelist $win.sw.listbox \
    -columns {42 {MD5 Hash} 4 # 0 {Document Ids}} -selectmode extended \
    -stretch 2 -height 20
  $win.sw setwidget $win.sw.listbox
  grid $win.sw -sticky snew
  grid columnconfigure $win 0 -weight 1
  grid rowconfigure $win 0 -weight 1
  $obj show
  $obj title {Collection MD5 Hash Tool...}
};# creole_MD5

proc creole_MD5_onDocumentChange {obj} {
  set col [$obj getCollection]
  set win [$obj getframe]
  $win.sw.listbox delete 0 end
  set hd [ELEP::Base::local ELEP::DocumentUtilities::HTMLUtilities #auto]
  tip_ForeachDocumentInCollection $col {
    set md5 [creole_MD5_docHashWithHtmlObj $doc $hd]
    lappend IDS($md5)  [tip_GetId $doc]
    lappend XIDS($md5) [tip_GetExternalId $doc]
    tip_Close $doc
  }
  if {![info exists IDS]} {return}
  foreach {md5} [lsort [array names IDS]] {
    set ids $IDS($md5)
    $win.sw.listbox insert end [list $md5 [llength $ids] \
      [join $ids {, }]]
  }
};# creole_MD5_onDocumentChange

proc creole_MD5_docHash {doc} {
  set hd [ELEP::Base::local ELEP::DocumentUtilities::HTMLUtilities #auto]
  return [creole_MD5_docHashWithHtmlObj $doc $hd]
};# creole_MD5_docHash

proc creole_MD5_docHashWithHtmlObj {doc hd} {
  set text [string trim [tip_GetRawData $doc]]
  ## Is it an HTML document?
  $hd setHTML_no_checks $text
  if {[$hd isHTML]} {
    set text [$hd getText 1]
  }
  return [::md5::md5 -hex $text]
};# creole_MD5_docHash

#
# End of File MD5.tcl
#
