# ma che cazzo di demo e' ?? non c'e' scroll o scrollregion ???
# ora c'e, ma i punti che crei li devi traslare nella scrollregion!!
# (? usare canvasx ????

 ###
 ### DEMO for tcanvas ###
 ###
 set thisDir [file dirname [info script]]
 set bgDir [file join $thisDir backgrounds]

 lappend auto_path $thisDir
 package require tcanvas 1.0

 tcanvas .tc \
   -borderwidth 3 -relief groove -background #AAAAAA
  
 image create photo extImg1 -file [file join $bgDir bathroom.gif]
 image create photo extImg2 -file [file join $bgDir celtic.gif]
 image create photo extImg3 -file [file join $bgDir pave.gif]
 image create photo extImg4 -file [file join $bgDir birdsMCE59.gif]
 
 set f [frame .fimg]
 button $f.i1 -image extImg1 -command ".tc configure -bgimage extImg1" \
    -width 50 -height 50 -bd 8
 button $f.i2 -image extImg2 -command ".tc configure -bgimage extImg2" \
    -width 50 -height 50 -bd 8
 button $f.i3 -image extImg3 -command ".tc configure -bgimage extImg3" \
    -width 50 -height 50 -bd 8
 button $f.i4 -image extImg4 -command ".tc configure -bgimage extImg4" \
    -width 50 -height 50 -bd 8
 button $f.i5 -text "No background"    -command ".tc configure -bgimage {}" \
    -bd 8

 $f.i1 invoke
 
 pack $f -fill y -side left 
 pack $f.i1 $f.i2 $f.i3 $f.i4 $f.i5 -pady 5

 label $f.xypos -textvariable xyLabel -relief sunken -width 16
 scale $f.scale_zoom -orient horizontal -relief ridge \
        -label zoom \
        -from 1.0  -to 8.0 \
        -highlightthickness 0 \
        -sliderrelief groove \
        -command ".tc configure -bgzoom"  \
        -troughcolor black \
	-width 8

 scale $f.scale_margin -orient horizontal -relief ridge \
        -label margin \
        -from 0.0  -to 40.0 \
        -highlightthickness 0 \
        -sliderrelief groove \
        -command ".tc configure -bgimagemargin"  \
        -troughcolor black \
	-width 8

 pack $f.scale_margin $f.scale_zoom $f.xypos -side bottom -pady 5 -padx 5
 
 pack .tc -fill both -expand yes



 # more stuff for fun:
 # allow adding 'spots' to canvas, and manage their interactive positioning
 #  ...

  # change cursor when you are on a 'spot'
 .tc bind spot <Enter> "%W configure -cursor fleur"
 .tc bind spot <Leave> "%W configure -cursor {}"

  # allow 'click and drag' of spots.
 .tc bind spot <1> "plotDown %W %x %y"
 .tc bind spot <ButtonRelease-1> "%W dtag selected"
 .tc bind spot <B1-Motion> "plotMove %W %x %y"

  # trace the cursor position on canvas
 bind .tc <Motion> { set xyLabel "(x,y) : ([expr int([%W canvasx %x])] , [expr int([%W canvasy %y])])" }


  # few procs for handling the interactive positioning
 set plot(lastX) 0
 set plot(lastY) 0

 proc plotDown {w x y} {
    global plot
    $w dtag selected
    $w addtag selected withtag current
    $w raise current
    set plot(lastX) $x
    set plot(lastY) $y
 }

 proc plotMove {w x y} {
    global plot
    $w move selected [expr $x-$plot(lastX)] [expr $y-$plot(lastY)]
    set plot(lastX) $x
    set plot(lastY) $y
 }


 # add a random spot to canvas
proc addSpot { cvs } {
     # radius between 25 and 60
   set r [expr int(25+rand()*(60-25))]

     # current-view upper-left corner is
   set wx0 [$cvs canvasx 0]
   set wy0 [$cvs canvasy 0]
     # current-view dim is
   set W [winfo width $cvs]
   set H [winfo height $cvs]

     # xc between $r and $W-$r (plus $wx0)
     # yc between $r and $H-$r (plus $wy0)
   set xc [expr $wx0+$r+int(rand()*($W-2*$r))]
   set yc [expr $wy0+$r+int(rand()*($H-2*$r))]
   set color [format "#%06x" [expr int(rand()*pow(2,24))]]
   $cvs create oval [expr $xc-$r] [expr $yc-$r] [expr $xc+$r] [expr $yc+$r] -fill $color -tags spot
}
	
 # create a group of buttons for commands ..
frame  .buttons -pady 5 -borderwidth 3 -relief groove
button .buttons.add   -text "Add Spot" -command "addSpot .tc"
button .buttons.clean -text "Clean Canvas" -command ".tc clean"

pack .buttons -side bottom -fill x 
pack .buttons.add  .buttons.clean -side left -expand 1


 # wait for .tc (otherwise geometry is "wrong" )
tkwait visibility .tc

addSpot .tc
addSpot .tc
addSpot .tc
