###
### DEMO for tcanvas ###
###
 set thisDir [file dirname [info script]]
 lappend auto_path $thisDir

 package require tcanvas 1.0

 set demoImg1 [file join $thisDir backgrounds birdsMCE59.gif]
 image create photo extImg -file $demoImg1
 ::tcanvas .tc -bgimage extImg -bgimagemargin 20
 pack .tc -fill both -expand yes
 
 # more stuff for fun:
 #  raise spot when cursor is over
 # change cursor when you are on a 'spot'
 .tc bind spot <Enter> "%W raise current"

 # add a random spot to canvas
proc addSpot { cvs } {
     # radius between 25 and 60
   set r [expr int(25+rand()*(60-25))]
     # xc between $r and $W-$r
     # yc between $r and $H-$r
   set W [winfo width $cvs]
   set H [winfo height $cvs]
   set xc [expr $r+int(rand()*($W-2*$r))]
   set yc [expr $r+int(rand()*($H-2*$r))]
   set color [format "#%06x" [expr int(rand()*pow(2,24))]]
   $cvs create oval [expr $xc-$r] [expr $yc-$r] [expr $xc+$r] [expr $yc+$r] -fill $color -tags spot
}

 # wait for .tc (otherwise geometry is "wrong" )
tkwait visibility .tc

for { set i 0 } { $i < 20 } { incr i } {
   addSpot .tc
}