<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                              xmlns:xs="http://www.w3.org/2001/XMLSchema">

<!-- 
  Stylesheet for preprocessing schema file for xmledit 
  
  (c) Solagem Oy 2002
-->

<!-- this template localizes all typed elements so that it copies global type information to local element -->
<xsl:template match="xs:element[@type]|xs:complexType[@type]">
  <xsl:copy>
    <!-- copy all attributes -->
    <xsl:apply-templates select="@*"/>
    <xsl:choose>
      <!-- If there is type attribute localize global settings for easier reference -->
      <xsl:when test="@type and /xs:schema/xs:complexType[@name=current()/@type]">
        <xsl:apply-templates select="/xs:schema/xs:complexType[@name=current()/@type]/@*"/>
        <xsl:apply-templates select="/xs:schema/xs:complexType[@name=current()/@type]/xs:annotation"/>
        <xs:complexType>
          <xsl:apply-templates select="/xs:schema/xs:complexType[@name=current()/@type]/*"/>
        </xs:complexType>
      </xsl:when>
      <xsl:when test="@type and /xs:schema/xs:simpleType[@name=current()/@type]">
        <xsl:apply-templates select="/xs:schema/xs:simpleType[@name=current()/@type]/@*"/>
        <xsl:apply-templates select="/xs:schema/xs:simpleType[@name=current()/@type]/xs:annotation"/>
        <xs:simpleType>
          <xsl:apply-templates select="/xs:schema/xs:simpleType[@name=current()/@type]/*"/>
        </xs:simpleType>
      </xsl:when>
      <!-- No type, just copy the rest of the element -->
      <xsl:otherwise>
        <xsl:apply-templates select="node()"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:copy>
</xsl:template>

<!-- this template localizes all refereced attributes -->
<xsl:template match="xs:attribute[@ref]">
  <xsl:apply-templates select="/xs:schema/xs:attribute[@name=current()/@ref]"/>
</xsl:template>

<!-- copy everything else as it is -->
<xsl:template match="@*|node()">
  <xsl:copy>
    <xsl:apply-templates select="@*|node()"/>
  </xsl:copy>
</xsl:template>


</xsl:stylesheet>

