##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::Base library package.                  ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval Base {
    
    proc auto {prefix} {
      variable auto_cmd_count
      return ${prefix}[incr auto_cmd_count($prefix)]
    };# auto

    proc destroy_helper {object args} {$object destroy}
    proc local {class name args} {
      switch -glob $name {
        \#auto  {set ptr [uplevel [list $class new] $args]}
        *#auto* {
          set name [string map [list \#auto [incr auto_cmd_count($name)]] $name]
          set ptr  [uplevel [list $class create $name] $args]
        }
        default {
          set ptr [uplevel [list $class create $name] $args]
        }
      }
      uplevel [list set tcloo-local($ptr) $ptr]
      set cmd [uplevel namespace which -command $ptr]
      uplevel [list trace variable tcloo-local($ptr) u \
                    "::ELEP::Base::destroy_helper $cmd"]
      return $ptr
    };# local

  };# namespace  Base
};# namespace  ::ELEP

package ifneeded ELEP::Base::serialisable 1.0 \
        [list source [file join $dir Serialisable.tcl]]
package ifneeded ELEP::Base::Utilities 1.0 \
        [list source [file join $dir Utilities.tcl]]

catch {package require ELEP::Base::Utilities}
