##############################################################################
##  GraphNode.tcl:                                                          ##
## --------------------------------------------------                       ##
##  This class implements an item that can be filled with a gradient.       ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

package require ELEP::FlowControl::GradientItem

oo::class create ELEP::FlowControl::GraphNode {
  superclass ELEP::FlowControl::GradientItem

  constructor {c args} {
    chain $c
  } {
    set bgType oval
    set width   170
    set height  50
    set unlocked 0
    set gradientColourA #FFFFCC
    eval configure $args
  };# constructor

  ##########################################################################
  ## Method: DrawInputNode
  ##########################################################################
  method DrawInputNode  {_x _y _index} {
    set inputNodeCoords($_index) [list $_x $_y]
  };# DrawInputNode

  ##########################################################################
  ## Method: DrawOutputNode
  ##########################################################################
  method DrawOutputNode {_x _y _index} {
    set outputNodeCoords($_index) [list $_x $_y]
  };# DrawOutputNode

  ##########################################################################
  ## Method: DrawOutputNode
  ##########################################################################
  method onMouseClick {_x _y} {
    chain $_x $_y
    event generate $canvas <<onMouseClick:$this>>
  };# onMouseClick

};# class ELEP::FlowControl::GraphNode

package provide ELEP::FlowControl::GraphNode 1.0
