wm withdraw .
  set HomeDir [file dirname [file normalize [info script]]]
  set lib_elep [file dirname $HomeDir]
  set lib [file dirname $lib_elep]/lib
  lappend auto_path $lib_elep $lib

  package require ELEP::FlowControl::Canvas
  set toplevel .evolutionToolkit
  toplevel $toplevel
  bind $toplevel <Destroy> exit
  wm title $toplevel {Evolution Toolkit version 1.0}
  set canvas [ELEP::FlowControl::Canvas #auto $toplevel -background white]
  pack [$canvas getframe] -fill both -expand 1
  set c [$canvas canvas]
  wm geometry $toplevel 800x500
  package require ELEP::FlowControl::ComponentItem
  package require ELEP::FlowControl::ConnectionItem
  package require ELEP::FlowControl::GraphManager
  package require ELEP::FlowControl::GraphLayoutSpring

  set gm   [ELEP::FlowControl::GraphManager #auto]
  set n1   [ELEP::FlowControl::ComponentItem #auto $c -label "Node 1"]
  set sn1  [ELEP::FlowControl::ComponentItem #auto $c -label "Node 2"]
  set sn2  [ELEP::FlowControl::ComponentItem #auto $c -label "Node 3"]
  set sn3  [ELEP::FlowControl::ComponentItem #auto $c -label "Node 4"]
  set sn4  [ELEP::FlowControl::ComponentItem #auto $c -label "Node 5"]
  set sn5  [ELEP::FlowControl::ComponentItem #auto $c -label "Node 6"]
  set sn6  [ELEP::FlowControl::ComponentItem #auto $c -label \
              "Multi Line\nNode Label"]
  set ssn1 [ELEP::FlowControl::ComponentItem #auto $c -label "Node 7"]
  set ssn2 [ELEP::FlowControl::ComponentItem #auto $c -label "Node 8"]
    
  $gm addNode $n1
  $gm addNode $sn1
  $gm addNode $sn2
  $gm addNode $sn3
  $gm addNode $sn4
  $gm addNode $sn5
  $gm addNode $sn6
  $gm addNode $ssn1
  $gm addNode $ssn2
        
  $gm addEdge [ELEP::FlowControl::ConnectionItem #auto $c $n1 0 $sn1 0]
  $gm addEdge [ELEP::FlowControl::ConnectionItem #auto $c $n1 0 $sn2 0]
  $gm addEdge [ELEP::FlowControl::ConnectionItem #auto $c $n1 0 $sn3 0 -label "edge label"]
  $gm addEdge [ELEP::FlowControl::ConnectionItem #auto $c $n1 0 $sn4 0]
  #$gm addEdge [ELEP::FlowControl::ConnectionItem #auto $c $sn4]
  $gm addEdge [ELEP::FlowControl::ConnectionItem #auto $c $n1 0 $sn5 0]
  #$gm addEdge [ELEP::FlowControl::ConnectionItem #auto $c sn5]
  $gm addEdge [ELEP::FlowControl::ConnectionItem #auto $c $n1 0 $sn6 0]
  $gm addEdge [ELEP::FlowControl::ConnectionItem #auto $c $sn1 0 $ssn1 0]
  $gm addEdge [ELEP::FlowControl::ConnectionItem #auto $c $sn1 0 $ssn2 0]
  $gm Draw
  $canvas update

  set l [ELEP::FlowControl::GraphLayoutSpring #auto $gm]
  bind $c <<ItemMoved>> +[list $l onItemMove]
  $l runLayout
