##############################################################################
##  ImportHandlers.tcl:                                                     ##
## --------------------------------------------------                       ##
##  This file loads all packages that are parts of the                      ##
##  ELEP::ImportHandlers package.                                           ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

package require TclOO    ;# TclOO adds object-oriented facilities to Tcl.

## Load package: ELEP::ImportHandlers::Alignment_TradosWinAlign
package require  ELEP::ImportHandlers::Alignment_TradosWinAlign
## Load package: ELEP::ImportHandlers::CASAM
package require  ELEP::ImportHandlers::CASAM
## Load package: ELEP::ImportHandlers::SYNC3
package require  ELEP::ImportHandlers::SYNC3

package provide  ELEP::ImportHandlers 1.0
##
## Load legacy collection handlers...
##
catch {
  ::CollectionHandlers::Initialise
  CDM_RegisterCollectionHandler {Import HTML Metadata} \
              ::CollectionHandlers::ImportHTMLDocumentMetadataDirectory
  CDM_RegisterCollectionHandler {Import HTML Images...} \
              ::CollectionHandlers::ImportHTML&Images
  CDM_RegisterCollectionHandler {SGML tags to Annotations} \
              ::CollectionHandlers::ConvertSGMLTags2Anns
} error
puts "ELEP::ImportHandlers: $error"
