cd [file dirname [info script]]

lappend auto_path ../..
package require ELEP::Base::Utilities

source NFoldCrossValidation.tcl
source AbstractClusterer.tcl
source SimpleKMeans.tcl
catch {console show}

proc distance {instance1 instance2} {
  foreach {x1 y1} $instance1 {break}
  foreach {x2 y2} $instance2 {break}
  return [expr {sqrt(pow($x1-$x2,2)+pow($y1-$y2,2))}]
};# distance

proc centroid {cluster_instances} {
  set c_x 0.0; set c_y 0.0
  foreach instance $cluster_instances {
    foreach {x y} $instance {break}
    set c_x [expr {$c_x+$x}]
    set c_y [expr {$c_y+$y}]
  }
  set instance_nu [llength $cluster_instances]
  return [list [expr {$c_x/double($instance_nu)}] \
               [expr {$c_y/double($instance_nu)}]]
};# centroid

ELEP::MachineLearning::Clustering::SimpleKMeans create clusterer \
  -distance distance -centroid centroid -K 2 -debug 0 -verbose 1

foreach data { { {1.0 0.0} {1.0 0.1} {0.0 0.0} }
               { {1.0 0.0} {1.0 0.1} {0.0 0.0} {0.0 0.5} {0.01 0.5} } } {
  puts stderr "Performing clustering..."; update
  clusterer buildClusterer $data
  puts "Results:"; update
  foreach point $data cluster [clusterer getClusterAssignments] {
    puts "   Cluster $cluster : $point"
  }
  puts {}
  clusterer estimateClustersCV $data
  puts {}
}
