##############################################################################
##  JAPEParser.tcl:                                                         ##
## --------------------------------------------------                       ##
##  This class implements a parser for JAPE grammars.                       ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################


oo::class create ELEP::PatternEngine::JAPEParser {
  
  constructor {} {
  };# constructor

  ##########################################################################
  ## Method: loadGrammar
  ##########################################################################
  method loadGrammar {filename {encoding utf-8}} {
    set file [open $filename]
    fconfigure $file -encoding $encoding
    set data [read $file]
    close $file
    parse $data
  };# loadGrammar

  ##########################################################################
  ## Method: parse
  ##########################################################################
  method parse {grammar} {
    set grammar [string map {Rule: [string trim $grammar]
  };# parse

};# class ELEP::PatternEngine::JAPEParser

package provide ELEP::PatternEngine::JAPEParser 1.0
