##############################################################################
##  SystemExpose.tcl:                                                       ##
## --------------------------------------------------                       ##
##  This class implements an Ellogon System (Expose).                       ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

package require ELEP::WindowUtilities::WidgetBase

oo::class create ELEP::System::SystemExpose {
  superclass ELEP::WindowUtilities::WidgetBase

  constructor {name parent args} {
    my variable toplevel_object
    set toplevel_object $parent
    next ttk::frame $name
    my createWidgets
    my configure {*}$args
  };# constructor

  ##########################################################################
  ## Method: createWidgets
  ##########################################################################
  method createWidgets {} {
    pack [my createToolbarFrame] -side top -fill x
  };# createWidgets

  ##########################################################################
  ## Method: createToolbarFrame
  ##########################################################################
  method createToolbarFrame {} {
    my variable toolbarFrame widget
    set toolbarFrame [ttk::frame $widget.toolbarFrame -class ToolbarFrame]
    my createToolbars
    return $toolbarFrame
  };# createToolbarFrame

  ##########################################################################
  ## Method: createToolbars
  ##########################################################################
  method createToolbars {} {
  };# createToolbars

  ##########################################################################
  ## Event: onDocumentChange
  ##########################################################################
  method onDocumentChange {col doc} {
  };# onDocumentChange

  ##########################################################################
  ## Event: onHide
  ##########################################################################
  method onHide {} {
  };# onHide

  ##########################################################################
  ## Event: onExpose
  ##########################################################################
  method onExpose {} {
    my variable toplevel_object
    $toplevel_object setStatusText 
  };# onExpose

};# class ELEP::System::SystemExpose

package provide ELEP::System::SystemExpose 1.0
