##############################################################################
##  pkgIndex.tcl:                                                           ##
## --------------------------------------------------                       ##
##  Package index file for the ELEP::ViewerBase library package.            ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

namespace eval ::ELEP {
  namespace eval ViewerBase {
  };# namespace  ViewerBase
};# namespace  ::ELEP

## The following package (ColourPairs) will define the variable:
##     ::ELEP::ViewerBase::ColourPairs
package ifneeded ELEP::ViewerBase::ColourPairs 1.0 \
        [list source [file join $dir ColourPairs.tcl]]
package ifneeded ELEP::ViewerBase::ColourManager 1.0 \
        [list source [file join $dir ColourManager.tcl]]
package ifneeded ELEP::ViewerBase::AnnotatorSpecificationReader 1.0 \
        [list source [file join $dir AnnotatorSpecificationReader.tcl]]
package ifneeded ELEP::ViewerBase::AnnotationSpecificationSelector 1.0 \
        [list source [file join $dir AnnotationSpecificationSelector.tcl]]
package ifneeded ELEP::ViewerBase::TemplateSpecificationSelector 1.0 \
        [list source [file join $dir TemplateSpecificationSelector.tcl]]
package ifneeded ELEP::ViewerBase::MultiAttributedAnnotationSpecificationSelector 1.0 \
        [list source [file join $dir MultiAttributedAnnotationSpecificationSelector.tcl]]
package ifneeded ELEP::ViewerBase::AnnotationAndTemplateSpecificationSelector \
        1.0 [list source [file join $dir \
        AnnotationAndTemplateSpecificationSelector.tcl]]
package ifneeded ELEP::ViewerBase::CollectionSelector 1.0 \
        [list source [file join $dir CollectionSelector.tcl]]
package ifneeded ELEP::ViewerBase::DocumentSelector 1.0 \
        [list source [file join $dir DocumentSelector.tcl]]
package ifneeded ELEP::ViewerBase::HTMLTagBase 1.0 \
        [list source [file join $dir HTMLTagBase.tcl]]
package ifneeded ELEP::ViewerBase::TextWidgetDisplay 1.0 \
        [list source [file join $dir TextWidgetDisplay.tcl]]
package ifneeded ELEP::ViewerBase::TextWidgetDisplayAlignment 1.0 \
        [list source [file join $dir TextWidgetDisplayAlignment.tcl]]
package ifneeded ELEP::ViewerBase::HtmlWidgetDisplay 1.0 \
        [list source [file join $dir HtmlWidgetDisplay.tcl]]
package ifneeded ELEP::ViewerBase::1ClickSelector 1.0 \
        [list source [file join $dir 1ClickSelector.tcl]]
package ifneeded ELEP::ViewerBase::AutomaticTagger 1.0 \
        [list source [file join $dir AutomaticTagger.tcl]]
package ifneeded ELEP::ViewerBase::ButtonAnnotator 1.0 \
        [list source [file join $dir ButtonAnnotator.tcl]]
package ifneeded ELEP::ViewerBase::CoreferenceAnnotator 1.0 \
        [list source [file join $dir CoreferenceAnnotator.tcl]]
package ifneeded ELEP::ViewerBase::TemplateFiller 1.0 \
        [list source [file join $dir TemplateFiller.tcl]]
package ifneeded ELEP::ViewerBase::AnnotationSelector 1.0 \
        [list source [file join $dir AnnotationSelector.tcl]]
package ifneeded ELEP::ViewerBase::AnnotationHighlighter 1.0 \
        [list source [file join $dir AnnotationHighlighter.tcl]]
package ifneeded ELEP::ViewerBase::EventDefiner 1.0 \
        [list source [file join $dir EventDefiner.tcl]]
package ifneeded ELEP::ViewerBase::AttributesWidget 1.0 \
        [list source [file join $dir AttributesWidget.tcl]]
package ifneeded ELEP::ViewerBase 1.0 \
        [list source [file join $dir ViewerBase.tcl]]
