##############################################################################
##  HtmlAnnotator.tcl:                                                      ##
## --------------------------------------------------                       ##
##  This class implements a tool for editing Annotations on an HTML widget. ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

package require ELEP::ViewerBase::HtmlWidgetDisplay
package require ELEP::VisualAnnotators::TextAnnotator

oo::class create ELEP::VisualAnnotators::HtmlAnnotator {
  superclass ELEP::VisualAnnotators::TextAnnotator

  variable {*}[info class variables ELEP::VisualAnnotators::TextAnnotator]

  method createDisplayWidget {parent} {
    global GUI_Options
    set display_widget [html $parent.text]
    switch [package require Tkhtml] {
      2.* {
        $display_widget configure -borderwidth 0 -relief flat -exportselection 0
      }
      3.* {
      }
    }
    set display_object [ELEP::ViewerBase::HtmlWidgetDisplay create \
        [::ELEP::Base::auto ELEP::VisualAnnotators::] [self] $display_widget]
    return $display_widget
  };# createDisplayWidget

  method setTitle {} {
    my title {HTML Visual Annotation Editor...}
  };# setTitle

};# class ELEP::VisualAnnotators::HtmlAnnotator

package provide ELEP::VisualAnnotators::HtmlAnnotator 1.0
