##############################################################################
##  TextAnnotatorWithAnnotationSelector.tcl:                                ##
## --------------------------------------------------                       ##
##  This class implements a tool for editing Annotations on a text widget.  ##
##  In addition, a list of existing annotations is presented, which allows  ##
##  the user to click on any of them, to easily select text in the text     ##
##  widget.                                                                 ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

package require ELEP::VisualAnnotators::TextAnnotator
package require ELEP::ViewerBase::AnnotationSelector

oo::class create ELEP::VisualAnnotators::TextAnnotatorWithAnnotationSelector {
  superclass ELEP::VisualAnnotators::TextAnnotator

  variable {*}[info class variables ELEP::VisualAnnotators::TextAnnotator] \
           annotation_selector_object

  method createRightTopAreaWidgets {pane} {
    my createAnnotationSelectorObject $pane
    $pane add [$annotation_selector_object getframe] -weight 1
  };# createRightTopAreaWidgets

  method createAnnotationSelectorObject {parent} {
    set annotation_selector_object [ELEP::ViewerBase::AnnotationSelector create\
        [::ELEP::Base::auto ELEP::VisualAnnotators::] $parent $display_object]
    $selector_object registerListener $annotation_selector_object
  };# createAnnotationSelectorObject

  method setTitle {} {
    my title \
      {Text Visual Annotation Editor (with Annotation-based text selection)...}
  };# setTitle

};# class ELEP::VisualAnnotators::TextAnnotatorWithAnnotationSelector

package provide ELEP::VisualAnnotators::TextAnnotatorWithAnnotationSelector 1.0
