##############################################################################
##  TextAnnotatorWithEvents.tcl:                                            ##
## --------------------------------------------------                       ##
##  This class implements a tool for editing Annotations on a text widget.  ##
##  In addition, the user can define and associate a set of events.         ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

package require ELEP::VisualAnnotators::TextAnnotator
package require ELEP::ViewerBase::EventDefiner

oo::class create ELEP::VisualAnnotators::TextAnnotatorWithEvents {
  superclass ELEP::VisualAnnotators::TextAnnotator

  method createRightTopAreaWidgets {pane} {
    my variable event_definer_object
    my createEventDefinerObject $pane
    $pane add [$event_definer_object getframe] -weight 1
  };# createRightTopAreaWidgets

  method createEventDefinerObject {parent} {
    my variable event_definer_object selector_object
    set event_definer_object [ELEP::ViewerBase::EventDefiner create\
        [::ELEP::Base::auto ELEP::VisualAnnotators::] $parent]
    $selector_object registerListener $event_definer_object
  };# createEventDefinerObject

  method createAnnotatorObject {parent} {
    my variable annotator_object event_definer_object
    next $parent
    $annotator_object configure -event_definer_object $event_definer_object
  };# createAnnotatorObject

  method setTitle {} {
    my title {Text Visual Annotation Editor (with Events)...}
  };# setTitle

};# class ELEP::VisualAnnotators::TextAnnotatorWithEvents

package provide ELEP::VisualAnnotators::TextAnnotatorWithEvents 1.0
