##############################################################################
##  TextCoreferenceAnnotatorAlignment.tcl:                                  ##
## --------------------------------------------------                       ##
##  This class implements a tool for editing coreference Annotations        ##
##  on a text widget.                                                       ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

package require ELEP::ViewerBase::CoreferenceAnnotator
package require ELEP::VisualAnnotators::TextAnnotatorAlignment

oo::class create ELEP::VisualAnnotators::TextCoreferenceAnnotatorAlignment {
  superclass ELEP::VisualAnnotators::TextAnnotatorAlignment

  variable \
    {*}[info class variables ELEP::VisualAnnotators::TextAnnotatorAlignment]

  constructor {{col {}} {doc {}}} {
    next $col $doc
  };# constructor

  method createAnnotatorObject {parent} {
    set annotator_object [ELEP::ViewerBase::CoreferenceAnnotator create \
        [::ELEP::Base::auto ELEP::VisualAnnotators::] [self] \
        $parent $display_object]
  };# createAnnotatorObject

  method setTitle {} {
    my title {Aligned Text Visual Annotation Editor...}
  };# setTitle

};# class ELEP::VisualAnnotators::TextCoreferenceAnnotatorAlignment

package provide ELEP::VisualAnnotators::TextCoreferenceAnnotatorAlignment 1.0
