##############################################################################
##  TextTemplateFiller.tcl:                                                 ##
## --------------------------------------------------                       ##
##  This class implements a tool for filling templates on a text widget.    ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

package require ELEP::VisualAnnotators::TextAnnotator
package require ELEP::ViewerBase::TemplateFiller

oo::class create ELEP::VisualAnnotators::TextTemplateFiller {
  superclass ELEP::VisualAnnotators::TextAnnotator

  variable {*}[info class variables ELEP::VisualAnnotators::TextAnnotator] \
           template_filler_object display_notebook_widget

  method createAnnotatorObject {parent} {
    set annotator_object [ELEP::ViewerBase::TemplateFiller create \
        [::ELEP::Base::auto ELEP::VisualAnnotators::] [self] $parent \
                                $display_notebook_widget $display_object]
  };# createAnnotatorObject

  method createScrolledDisplayWidget {parent} {
    set display_notebook_widget [ttk::notebook $parent.pages]
    $display_notebook_widget add [next $parent.pages] \
      -text {Document Viewer}
    return $display_notebook_widget
  };# createScrolledDisplayWidget

};# class ELEP::VisualAnnotators::TextTemplateFiller

package provide ELEP::VisualAnnotators::TextTemplateFiller 1.0
