##############################################################################
##  ConsoleWindow.tcl:                                                      ##
## --------------------------------------------------                       ##
##  This class implements a console window.                                 ##
##                                                                          ##
##  This file is part of the Ellogon Language Engineering Platform.         ##
##  Copyright 1998-2010 by:                                                 ##
##  Georgios Petasis,                                                       ##
##  Athens, Greece.                                                         ##
##  E-mail: petasis@iit.demokritos.gr                                       ##
##          petasisg@yahoo.gr                                               ##
##          petasisg@gmail.com                                              ##
##                                                                          ##
##  For licensing information, please refer to the license conditions of    ##
##  "Ellogon" Language Engineering Platform.                                ##
##############################################################################

proc ELEP::WindowUtilities::LoadTkCon {} {
  foreach file [list \
    [file join $::tcl_library .. .. bin tkcon] \
    [file join $::tcl_library .. .. bin tkcon.tcl]
  ] {
    if {[file exists $file]} {
      uplevel #0 "source $file"
      package require tkcon
      return 
    }
  }
  error "Failed to load Tkcon"
  return ""
};# ELEP::WindowUtilities::LoadTkCon
# ELEP::WindowUtilities::LoadTkCon

package provide ELEP::WindowUtilities::ConsoleWindow 1.0
