/* Driver template for the LEMON parser generator.
** The author disclaims copyright to this source code.
*/
/* First off, code is include which follows the "include" declaration
** in the input file. */
#include <stdio.h>
#line 41 "cssparse.y"

#include "cssInt.h"
#include <string.h>
#include <ctype.h>
#line 14 "cssparse.c"
/* Next is all token values, in a form suitable for use by makeheaders.
** This section will be null unless lemon is run with the -m switch.
*/
/* 
** These constants (all generated automatically by the parser generator)
** specify the various kinds of tokens (terminals) that the parser
** understands. 
**
** Each symbol here is a terminal symbol in the grammar.
*/
/* Make sure the INTERFACE macro is defined.
*/
#ifndef INTERFACE
# define INTERFACE 1
#endif
/* The next thing included is series of defines which control
** various aspects of the generated parser.
**    YYCODETYPE         is the data type used for storing terminal
**                       and nonterminal numbers.  "unsigned char" is
**                       used if there are fewer than 250 terminals
**                       and nonterminals.  "int" is used otherwise.
**    YYNOCODE           is a number of type YYCODETYPE which corresponds
**                       to no legal terminal or nonterminal number.  This
**                       number is used to fill in empty slots of the hash 
**                       table.
**    YYFALLBACK         If defined, this indicates that one or more tokens
**                       have fall-back values which should be used if the
**                       original value of the token will not parse.
**    YYACTIONTYPE       is the data type used for storing terminal
**                       and nonterminal numbers.  "unsigned char" is
**                       used if there are fewer than 250 rules and
**                       states combined.  "int" is used otherwise.
**    tkhtmlCssParserTOKENTYPE     is the data type used for minor tokens given 
**                       directly to the parser from the tokenizer.
**    YYMINORTYPE        is the data type used for all minor tokens.
**                       This is typically a union of many types, one of
**                       which is tkhtmlCssParserTOKENTYPE.  The entry in the union
**                       for base tokens is called "yy0".
**    YYSTACKDEPTH       is the maximum depth of the parser's stack.
**    tkhtmlCssParserARG_SDECL     A static variable declaration for the %extra_argument
**    tkhtmlCssParserARG_PDECL     A parameter declaration for the %extra_argument
**    tkhtmlCssParserARG_STORE     Code to store %extra_argument into yypParser
**    tkhtmlCssParserARG_FETCH     Code to extract %extra_argument from yypParser
**    YYNSTATE           the combined number of states.
**    YYNRULE            the number of rules in the grammar
**    YYERRORSYMBOL      is the code number of the error symbol.  If not
**                       defined, then do no error processing.
*/
#define YYCODETYPE unsigned char
#define YYNOCODE 64
#define YYACTIONTYPE unsigned char
#define tkhtmlCssParserTOKENTYPE CssToken
typedef union {
  tkhtmlCssParserTOKENTYPE yy0;
  int yy4;
  int yy127;
} YYMINORTYPE;
#define YYSTACKDEPTH 100
#define tkhtmlCssParserARG_SDECL CssParse *pParse;
#define tkhtmlCssParserARG_PDECL ,CssParse *pParse
#define tkhtmlCssParserARG_FETCH CssParse *pParse = yypParser->pParse
#define tkhtmlCssParserARG_STORE yypParser->pParse = pParse
#define YYNSTATE 153
#define YYNRULE 79
#define YYERRORSYMBOL 28
#define YYERRSYMDT yy127
#define YY_NO_ACTION      (YYNSTATE+YYNRULE+2)
#define YY_ACCEPT_ACTION  (YYNSTATE+YYNRULE+1)
#define YY_ERROR_ACTION   (YYNSTATE+YYNRULE)

/* Next are that tables used to determine what action to take based on the
** current state and lookahead token.  These tables are used to implement
** functions that take a state number and lookahead value and return an
** action integer.  
**
** Suppose the action integer is N.  Then the action is determined as
** follows
**
**   0 <= N < YYNSTATE                  Shift N.  That is, push the lookahead
**                                      token onto the stack and goto state N.
**
**   YYNSTATE <= N < YYNSTATE+YYNRULE   Reduce by rule N-YYNSTATE.
**
**   N == YYNSTATE+YYNRULE              A syntax error has occurred.
**
**   N == YYNSTATE+YYNRULE+1            The parser accepts its input.
**
**   N == YYNSTATE+YYNRULE+2            No such action.  Denotes unused
**                                      slots in the yy_action[] table.
**
** The action table is constructed as a single large table named yy_action[].
** Given state S and lookahead X, the action is computed as
**
**      yy_action[ yy_shift_ofst[S] + X ]
**
** If the index value yy_shift_ofst[S]+X is out of range or if the value
** yy_lookahead[yy_shift_ofst[S]+X] is not equal to X or if yy_shift_ofst[S]
** is equal to YY_SHIFT_USE_DFLT, it means that the action is not in the table
** and that yy_default[S] should be used instead.  
**
** The formula above is for computing the action when the lookahead is
** a terminal symbol.  If the lookahead is a non-terminal (as occurs after
** a reduce action) then the yy_reduce_ofst[] array is used in place of
** the yy_shift_ofst[] array and YY_REDUCE_USE_DFLT is used in place of
** YY_SHIFT_USE_DFLT.
**
** The following are the tables generated in this section:
**
**  yy_action[]        A single table containing all actions.
**  yy_lookahead[]     A table containing the lookahead for each entry in
**                     yy_action.  Used to detect hash collisions.
**  yy_shift_ofst[]    For each state, the offset into yy_action for
**                     shifting terminals.
**  yy_reduce_ofst[]   For each state, the offset into yy_action for
**                     shifting non-terminals after a reduce.
**  yy_default[]       Default action for each state.
*/
static const YYACTIONTYPE yy_action[] = {
 /*     0 */   115,   65,  115,   24,  233,    1,   68,   49,   47,   29,
 /*    10 */   149,   96,   97,   98,   99,   11,  118,  144,   32,   91,
 /*    20 */   151,   25,  145,  115,   39,   19,  102,   47,   21,   20,
 /*    30 */    15,  139,   16,   95,   96,   97,   98,   99,   19,   40,
 /*    40 */   144,   32,  155,   36,   25,  145,  155,   29,  155,   11,
 /*    50 */   116,   21,  155,   15,  139,   16,  107,  142,   11,   30,
 /*    60 */    11,  115,  140,  155,   87,  121,   89,  128,   16,  147,
 /*    70 */   141,   79,   80,   81,   42,  118,   47,   66,   60,  144,
 /*    80 */    32,   74,  115,   25,  145,  115,   77,  153,   17,   29,
 /*    90 */    21,   76,   15,  139,   16,   42,  118,  134,  122,  117,
 /*   100 */   144,   32,   59,  135,   25,  145,  119,  146,   14,   20,
 /*   110 */   124,   21,   12,   15,  139,   16,   21,  142,   15,  139,
 /*   120 */    16,  142,  140,   10,   87,  121,  140,  101,   87,   38,
 /*   130 */   141,   79,   80,   81,  141,   79,   80,   81,  115,  129,
 /*   140 */    16,   87,   77,  115,   44,  127,   63,   77,   79,   80,
 /*   150 */    81,   21,  118,   15,  139,   16,    6,  118,   62,  143,
 /*   160 */    10,   82,  119,   64,  123,   20,    2,  119,  109,   84,
 /*   170 */    20,    9,   45,   46,   70,  132,   26,   83,   85,  155,
 /*   180 */    61,   10,  155,   72,   73,  148,   43,  155,  155,   86,
 /*   190 */    94,  110,   18,    3,   33,   78,   67,   69,   13,   37,
 /*   200 */   103,  104,   56,   52,  105,  106,  120,    4,  100,    8,
 /*   210 */    57,  125,  126,   88,   22,   31,    5,   35,   55,   23,
 /*   220 */   150,   92,   93,  152,   34,  108,   90,  111,  112,   71,
 /*   230 */    75,  113,  114,   41,  130,  131,   58,   50,  133,  138,
 /*   240 */     7,   48,   27,   28,   51,   53,  144,   54,  144,  136,
 /*   250 */   137,
};
static const YYCODETYPE yy_lookahead[] = {
 /*     0 */    28,   37,   28,   31,   29,   30,   32,   32,   44,    2,
 /*    10 */    38,   39,   40,   41,   42,    8,   42,   45,   46,   36,
 /*    20 */    37,   49,   50,   28,   11,   35,   52,   44,   56,   55,
 /*    30 */    58,   59,   60,   38,   39,   40,   41,   42,   35,   26,
 /*    40 */    45,   46,    5,   53,   49,   50,    9,    2,   11,    8,
 /*    50 */     9,   56,   15,   58,   59,   60,   53,    5,    8,    7,
 /*    60 */     8,   28,   10,   26,   12,   13,   14,   59,   60,   37,
 /*    70 */    18,   19,   20,   21,   40,   42,   44,   43,   32,   45,
 /*    80 */    46,   10,   28,   49,   50,   28,   32,    0,   55,    2,
 /*    90 */    56,   20,   58,   59,   60,   40,   42,    4,   43,   42,
 /*   100 */    45,   46,   48,   10,   49,   50,   52,   10,   62,   55,
 /*   110 */    50,   56,   35,   58,   59,   60,   56,    5,   58,   59,
 /*   120 */    60,    5,   10,    5,   12,   13,   10,    9,   12,    2,
 /*   130 */    18,   19,   20,   21,   18,   19,   20,   21,   28,   59,
 /*   140 */    60,   12,   32,   28,    2,   50,   32,   32,   19,   20,
 /*   150 */    21,   56,   42,   58,   59,   60,    8,   42,   48,   11,
 /*   160 */     5,   61,   52,   48,    9,   55,   32,   52,    4,   61,
 /*   170 */    55,   57,   16,   17,   10,   22,   23,   24,   25,    8,
 /*   180 */    16,    5,   11,   19,   20,    9,   51,   16,   17,   61,
 /*   190 */    32,   27,   32,   32,   32,   12,   47,   32,   32,   15,
 /*   200 */    54,   32,   32,    3,   32,   32,   32,   32,    9,   32,
 /*   210 */    32,   32,   32,   32,   32,    8,    8,   12,   33,   32,
 /*   220 */    32,   32,   32,   32,   10,   10,   34,   10,   10,   20,
 /*   230 */    20,   10,   10,   10,   10,   10,   10,    6,   22,   10,
 /*   240 */     8,   11,   23,   23,    5,    4,   63,    5,   63,   22,
 /*   250 */    22,
};
#define YY_SHIFT_USE_DFLT (-1)
#define YY_SHIFT_MAX 93
static const short yy_shift_ofst[] = {
 /*     0 */    45,   52,   52,  112,  112,    7,    7,    7,  116,  116,
 /*    10 */     7,   50,   97,  164,  164,  129,  129,   41,   97,  127,
 /*    20 */    50,  142,   97,  164,   87,  148,   93,   93,   93,   45,
 /*    30 */    45,   45,   45,  183,   45,   45,  184,   45,   45,   45,
 /*    40 */    45,   45,   45,   45,   45,   45,   45,   45,   45,  200,
 /*    50 */    45,   45,   45,   45,   45,   -1,   37,  171,  153,  118,
 /*    60 */    13,   71,  155,  156,  176,  207,  199,  208,  214,  205,
 /*    70 */   209,  215,  217,  218,  210,  221,  222,  214,  223,  224,
 /*    80 */   225,  226,  216,  219,  227,  220,  228,  229,  230,  232,
 /*    90 */   231,  239,  241,  242,
};
#define YY_REDUCE_USE_DFLT (-37)
#define YY_REDUCE_MAX 55
static const short yy_reduce_ofst[] = {
 /*     0 */   -25,  -28,   -5,   34,   55,   54,  110,  115,   60,   95,
 /*    10 */   -26,   33,  -17,  -10,    3,    8,   80,   57,  -36,   46,
 /*    20 */    57,  114,   32,   77,  134,  135,  100,  108,  128,  158,
 /*    30 */   160,  161,  162,  149,  165,  166,  146,  169,  170,  172,
 /*    40 */   173,  174,  175,  177,  178,  179,  180,  181,  182,  185,
 /*    50 */   187,  188,  189,  190,  191,  192,
};
static const YYACTIONTYPE yy_default[] = {
 /*     0 */   154,  232,  232,  232,  178,  154,  154,  154,  232,  232,
 /*    10 */   154,  232,  162,  232,  232,  203,  207,  232,  232,  154,
 /*    20 */   189,  154,  232,  232,  154,  232,  232,  232,  232,  154,
 /*    30 */   154,  154,  154,  175,  154,  154,  195,  154,  154,  154,
 /*    40 */   154,  154,  154,  154,  154,  154,  154,  154,  154,  158,
 /*    50 */   154,  154,  154,  154,  154,  160,  222,  200,  232,  232,
 /*    60 */   218,  232,  232,  196,  232,  232,  232,  232,  187,  232,
 /*    70 */   223,  232,  232,  232,  229,  232,  232,  232,  232,  232,
 /*    80 */   232,  232,  232,  232,  232,  232,  232,  232,  171,  232,
 /*    90 */   156,  232,  232,  232,  155,  164,  165,  166,  167,  168,
 /*   100 */   169,  173,  186,  188,  194,  220,  221,  219,  228,  224,
 /*   110 */   225,  226,  227,  231,  230,  190,  191,  193,  192,  185,
 /*   120 */   174,  176,  179,  180,  183,  198,  199,  197,  201,  208,
 /*   130 */   209,  210,  211,  212,  216,  217,  213,  214,  215,  202,
 /*   140 */   204,  205,  206,  184,  181,  182,  170,  172,  177,  163,
 /*   150 */   159,  161,  157,
};
#define YY_SZ_ACTTAB (sizeof(yy_action)/sizeof(yy_action[0]))

/* The next table maps tokens into fallback tokens.  If a construct
** like the following:
** 
**      %fallback ID X Y Z.
**
** appears in the grammer, then ID becomes a fallback token for X, Y,
** and Z.  Whenever one of the tokens X, Y, or Z is input to the parser
** but it does not parse, the type of the token is changed to ID and
** the parse is retried before an error is thrown.
*/
#ifdef YYFALLBACK
static const YYCODETYPE yyFallback[] = {
};
#endif /* YYFALLBACK */

/* The following structure represents a single element of the
** parser's stack.  Information stored includes:
**
**   +  The state number for the parser at this level of the stack.
**
**   +  The value of the token stored at this level of the stack.
**      (In other words, the "major" token.)
**
**   +  The semantic value stored at this level of the stack.  This is
**      the information used by the action routines in the grammar.
**      It is sometimes called the "minor" token.
*/
struct yyStackEntry {
  int stateno;       /* The state-number */
  int major;         /* The major token value.  This is the code
                     ** number for the token at this stack level */
  YYMINORTYPE minor; /* The user-supplied minor token value.  This
                     ** is the value of the token  */
};
typedef struct yyStackEntry yyStackEntry;

/* The state of the parser is completely contained in an instance of
** the following structure */
struct yyParser {
  int yyidx;                    /* Index of top element in stack */
  int yyerrcnt;                 /* Shifts left before out of the error */
  tkhtmlCssParserARG_SDECL                /* A place to hold %extra_argument */
  yyStackEntry yystack[YYSTACKDEPTH];  /* The parser's stack */
};
typedef struct yyParser yyParser;

#ifndef NDEBUG
#include <stdio.h>
static FILE *yyTraceFILE = 0;
static char *yyTracePrompt = 0;
#endif /* NDEBUG */

#ifndef NDEBUG
/* 
** Turn parser tracing on by giving a stream to which to write the trace
** and a prompt to preface each trace message.  Tracing is turned off
** by making either argument NULL 
**
** Inputs:
** <ul>
** <li> A FILE* to which trace output should be written.
**      If NULL, then tracing is turned off.
** <li> A prefix string written at the beginning of every
**      line of trace output.  If NULL, then tracing is
**      turned off.
** </ul>
**
** Outputs:
** None.
*/
void tkhtmlCssParserTrace(FILE *TraceFILE, char *zTracePrompt){
  yyTraceFILE = TraceFILE;
  yyTracePrompt = zTracePrompt;
  if( yyTraceFILE==0 ) yyTracePrompt = 0;
  else if( yyTracePrompt==0 ) yyTraceFILE = 0;
}
#endif /* NDEBUG */

#ifndef NDEBUG
/* For tracing shifts, the names of all terminals and nonterminals
** are required.  The following table supplies these names */
static const char *const yyTokenName[] = { 
  "$",             "RRP",           "SPACE",         "CHARSET_SYM", 
  "STRING",        "SEMICOLON",     "IMPORT_SYM",    "MEDIA_SYM",   
  "LP",            "RP",            "IDENT",         "COMMA",       
  "COLON",         "PAGE_SYM",      "FONT_SYM",      "IMPORTANT_SYM",
  "PLUS",          "GT",            "STAR",          "HASH",        
  "DOT",           "LSP",           "RSP",           "EQUALS",      
  "TILDE",         "PIPE",          "SLASH",         "FUNCTION",    
  "error",         "stylesheet",    "ss_header",     "ss_body",     
  "ws",            "charset_opt",   "imports_opt",   "term",        
  "medium_list_opt",  "medium_list",   "ss_body_item",  "media",       
  "ruleset",       "font_face",     "garbage_token",  "ruleset_list",
  "medium_list_item",  "page",          "page_sym",      "pseudo_opt",  
  "declaration_list",  "selector_list",  "selector",      "comma",       
  "declaration",   "expr",          "prio",          "garbage",     
  "simple_selector",  "combinator",    "tag",           "simple_selector_tail",
  "simple_selector_tail_component",  "string",        "operator",    
};
#endif /* NDEBUG */

#ifndef NDEBUG
/* For tracing reduce actions, the names of all rules are required.
*/
static const char *const yyRuleName[] = {
 /*   0 */ "stylesheet ::= ss_header ss_body",
 /*   1 */ "ws ::=",
 /*   2 */ "ws ::= SPACE ws",
 /*   3 */ "ss_header ::= ws charset_opt imports_opt",
 /*   4 */ "charset_opt ::= CHARSET_SYM ws STRING ws SEMICOLON ws",
 /*   5 */ "charset_opt ::=",
 /*   6 */ "imports_opt ::= imports_opt IMPORT_SYM ws term medium_list_opt SEMICOLON ws",
 /*   7 */ "imports_opt ::=",
 /*   8 */ "medium_list_opt ::= medium_list",
 /*   9 */ "medium_list_opt ::=",
 /*  10 */ "ss_body ::= ss_body_item",
 /*  11 */ "ss_body ::= ss_body ws ss_body_item",
 /*  12 */ "ss_body_item ::= media",
 /*  13 */ "ss_body_item ::= ruleset",
 /*  14 */ "ss_body_item ::= font_face",
 /*  15 */ "ss_body_item ::= garbage_token",
 /*  16 */ "media ::= MEDIA_SYM ws medium_list LP ws ruleset_list RP",
 /*  17 */ "medium_list_item ::= IDENT",
 /*  18 */ "medium_list ::= medium_list_item ws",
 /*  19 */ "medium_list ::= medium_list_item ws COMMA ws medium_list",
 /*  20 */ "page ::= page_sym ws pseudo_opt LP declaration_list RP",
 /*  21 */ "pseudo_opt ::= COLON IDENT ws",
 /*  22 */ "pseudo_opt ::=",
 /*  23 */ "page_sym ::= PAGE_SYM",
 /*  24 */ "font_face ::= FONT_SYM LP declaration_list RP",
 /*  25 */ "ruleset_list ::= ruleset ws",
 /*  26 */ "ruleset_list ::= ruleset ws ruleset_list",
 /*  27 */ "ruleset ::= selector_list LP declaration_list RP",
 /*  28 */ "ruleset ::= page",
 /*  29 */ "selector_list ::= selector",
 /*  30 */ "selector_list ::= selector_list comma ws selector",
 /*  31 */ "comma ::= COMMA",
 /*  32 */ "declaration_list ::= declaration",
 /*  33 */ "declaration_list ::= declaration_list SEMICOLON declaration",
 /*  34 */ "declaration_list ::= declaration_list SEMICOLON ws",
 /*  35 */ "declaration ::= ws IDENT ws COLON ws expr prio",
 /*  36 */ "declaration ::= garbage",
 /*  37 */ "garbage_token ::= error",
 /*  38 */ "garbage_token ::= LP garbage RP",
 /*  39 */ "garbage ::= garbage_token",
 /*  40 */ "garbage ::= garbage garbage_token",
 /*  41 */ "prio ::= IMPORTANT_SYM ws",
 /*  42 */ "prio ::=",
 /*  43 */ "selector ::= simple_selector ws",
 /*  44 */ "selector ::= simple_selector combinator selector",
 /*  45 */ "combinator ::= ws PLUS ws",
 /*  46 */ "combinator ::= ws GT ws",
 /*  47 */ "combinator ::= SPACE ws",
 /*  48 */ "simple_selector ::= tag simple_selector_tail",
 /*  49 */ "simple_selector ::= simple_selector_tail",
 /*  50 */ "simple_selector ::= tag",
 /*  51 */ "tag ::= IDENT",
 /*  52 */ "tag ::= STAR",
 /*  53 */ "tag ::= SEMICOLON",
 /*  54 */ "simple_selector_tail ::= simple_selector_tail_component",
 /*  55 */ "simple_selector_tail ::= simple_selector_tail_component simple_selector_tail",
 /*  56 */ "simple_selector_tail_component ::= HASH IDENT",
 /*  57 */ "simple_selector_tail_component ::= DOT IDENT",
 /*  58 */ "simple_selector_tail_component ::= LSP IDENT RSP",
 /*  59 */ "simple_selector_tail_component ::= LSP IDENT EQUALS string RSP",
 /*  60 */ "simple_selector_tail_component ::= LSP IDENT TILDE EQUALS string RSP",
 /*  61 */ "simple_selector_tail_component ::= LSP IDENT PIPE EQUALS string RSP",
 /*  62 */ "simple_selector_tail_component ::= COLON IDENT",
 /*  63 */ "string ::= STRING",
 /*  64 */ "string ::= IDENT",
 /*  65 */ "expr ::= term ws",
 /*  66 */ "expr ::= term operator expr",
 /*  67 */ "operator ::= ws COMMA ws",
 /*  68 */ "operator ::= ws SLASH ws",
 /*  69 */ "operator ::= SPACE ws",
 /*  70 */ "term ::= IDENT",
 /*  71 */ "term ::= STRING",
 /*  72 */ "term ::= FUNCTION",
 /*  73 */ "term ::= HASH IDENT",
 /*  74 */ "term ::= DOT IDENT",
 /*  75 */ "term ::= IDENT DOT IDENT",
 /*  76 */ "term ::= PLUS IDENT",
 /*  77 */ "term ::= PLUS DOT IDENT",
 /*  78 */ "term ::= PLUS IDENT DOT IDENT",
};
#endif /* NDEBUG */

/*
** This function returns the symbolic name associated with a token
** value.
*/
const char *tkhtmlCssParserTokenName(int tokenType){
#ifndef NDEBUG
  if( tokenType>0 && tokenType<(sizeof(yyTokenName)/sizeof(yyTokenName[0])) ){
    return yyTokenName[tokenType];
  }else{
    return "Unknown";
  }
#else
  return "";
#endif
}

/* 
** This function allocates a new parser.
** The only argument is a pointer to a function which works like
** malloc.
**
** Inputs:
** A pointer to the function used to allocate memory.
**
** Outputs:
** A pointer to a parser.  This pointer is used in subsequent calls
** to tkhtmlCssParser and tkhtmlCssParserFree.
*/
void *tkhtmlCssParserAlloc(void *(*mallocProc)(size_t)){
  yyParser *pParser;
  pParser = (yyParser*)(*mallocProc)( (size_t)sizeof(yyParser) );
  if( pParser ){
    pParser->yyidx = -1;
  }
  return pParser;
}

/* The following function deletes the value associated with a
** symbol.  The symbol can be either a terminal or nonterminal.
** "yymajor" is the symbol code, and "yypminor" is a pointer to
** the value.
*/
static void yy_destructor(YYCODETYPE yymajor, YYMINORTYPE *yypminor){
  switch( yymajor ){
    /* Here is inserted the actions which take place when a
    ** terminal or non-terminal is destroyed.  This can happen
    ** when the symbol is popped from the stack during a
    ** reduce or during error processing or when a parser is 
    ** being destroyed before it is finished parsing.
    **
    ** Note: during a reduce, the only symbols destroyed are those
    ** which appear on the RHS of the rule, but which are not used
    ** inside the C code.
    */
    default:  break;   /* If no destructor action specified: do nothing */
  }
}

/*
** Pop the parser's stack once.
**
** If there is a destructor routine associated with the token which
** is popped from the stack, then call it.
**
** Return the major token number for the symbol popped.
*/
static int yy_pop_parser_stack(yyParser *pParser){
  YYCODETYPE yymajor;
  yyStackEntry *yytos = &pParser->yystack[pParser->yyidx];

  if( pParser->yyidx<0 ) return 0;
#ifndef NDEBUG
  if( yyTraceFILE && pParser->yyidx>=0 ){
    fprintf(yyTraceFILE,"%sPopping %s\n",
      yyTracePrompt,
      yyTokenName[yytos->major]);
  }
#endif
  yymajor = yytos->major;
  yy_destructor( yymajor, &yytos->minor);
  pParser->yyidx--;
  return yymajor;
}

/* 
** Deallocate and destroy a parser.  Destructors are all called for
** all stack elements before shutting the parser down.
**
** Inputs:
** <ul>
** <li>  A pointer to the parser.  This should be a pointer
**       obtained from tkhtmlCssParserAlloc.
** <li>  A pointer to a function used to reclaim memory obtained
**       from malloc.
** </ul>
*/
void tkhtmlCssParserFree(
  void *p,                    /* The parser to be deleted */
  void (*freeProc)(void*)     /* Function used to reclaim memory */
){
  yyParser *pParser = (yyParser*)p;
  if( pParser==0 ) return;
  while( pParser->yyidx>=0 ) yy_pop_parser_stack(pParser);
  (*freeProc)((void*)pParser);
}

/*
** Find the appropriate action for a parser given the terminal
** look-ahead token iLookAhead.
**
** If the look-ahead token is YYNOCODE, then check to see if the action is
** independent of the look-ahead.  If it is, return the action, otherwise
** return YY_NO_ACTION.
*/
static int yy_find_shift_action(
  yyParser *pParser,        /* The parser */
  int iLookAhead            /* The look-ahead token */
){
  int i;
  int stateno = pParser->yystack[pParser->yyidx].stateno;
 
  if( stateno>YY_SHIFT_MAX || (i = yy_shift_ofst[stateno])==YY_SHIFT_USE_DFLT ){
    return yy_default[stateno];
  }
  if( iLookAhead==YYNOCODE ){
    return YY_NO_ACTION;
  }
  i += iLookAhead;
  if( i<0 || i>=YY_SZ_ACTTAB || yy_lookahead[i]!=iLookAhead ){
#ifdef YYFALLBACK
    int iFallback;            /* Fallback token */
    if( iLookAhead<sizeof(yyFallback)/sizeof(yyFallback[0])
           && (iFallback = yyFallback[iLookAhead])!=0 ){
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE, "%sFALLBACK %s => %s\n",
           yyTracePrompt, yyTokenName[iLookAhead], yyTokenName[iFallback]);
      }
#endif
      return yy_find_shift_action(pParser, iFallback);
    }
#endif
    return yy_default[stateno];
  }else{
    return yy_action[i];
  }
}

/*
** Find the appropriate action for a parser given the non-terminal
** look-ahead token iLookAhead.
**
** If the look-ahead token is YYNOCODE, then check to see if the action is
** independent of the look-ahead.  If it is, return the action, otherwise
** return YY_NO_ACTION.
*/
static int yy_find_reduce_action(
  int stateno,              /* Current state number */
  int iLookAhead            /* The look-ahead token */
){
  int i;
  /* int stateno = pParser->yystack[pParser->yyidx].stateno; */
 
  if( stateno>YY_REDUCE_MAX ||
      (i = yy_reduce_ofst[stateno])==YY_REDUCE_USE_DFLT ){
    return yy_default[stateno];
  }
  if( iLookAhead==YYNOCODE ){
    return YY_NO_ACTION;
  }
  i += iLookAhead;
  if( i<0 || i>=YY_SZ_ACTTAB || yy_lookahead[i]!=iLookAhead ){
    return yy_default[stateno];
  }else{
    return yy_action[i];
  }
}

/*
** Perform a shift action.
*/
static void yy_shift(
  yyParser *yypParser,          /* The parser to be shifted */
  int yyNewState,               /* The new state to shift in */
  int yyMajor,                  /* The major token to shift in */
  YYMINORTYPE *yypMinor         /* Pointer ot the minor token to shift in */
){
  yyStackEntry *yytos;
  yypParser->yyidx++;
  if( yypParser->yyidx>=YYSTACKDEPTH ){
     tkhtmlCssParserARG_FETCH;
     yypParser->yyidx--;
#ifndef NDEBUG
     if( yyTraceFILE ){
       fprintf(yyTraceFILE,"%sStack Overflow!\n",yyTracePrompt);
     }
#endif
     while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
     /* Here code is inserted which will execute if the parser
     ** stack every overflows */
     tkhtmlCssParserARG_STORE; /* Suppress warning about unused %extra_argument var */
     return;
  }
  yytos = &yypParser->yystack[yypParser->yyidx];
  yytos->stateno = yyNewState;
  yytos->major = yyMajor;
  yytos->minor = *yypMinor;
#ifndef NDEBUG
  if( yyTraceFILE && yypParser->yyidx>0 ){
    int i;
    fprintf(yyTraceFILE,"%sShift %d\n",yyTracePrompt,yyNewState);
    fprintf(yyTraceFILE,"%sStack:",yyTracePrompt);
    for(i=1; i<=yypParser->yyidx; i++)
      fprintf(yyTraceFILE," %s",yyTokenName[yypParser->yystack[i].major]);
    fprintf(yyTraceFILE,"\n");
  }
#endif
}

/* The following table contains information about every rule that
** is used during the reduce.
*/
static const struct {
  YYCODETYPE lhs;         /* Symbol on the left-hand side of the rule */
  unsigned char nrhs;     /* Number of right-hand side symbols in the rule */
} yyRuleInfo[] = {
  { 29, 2 },
  { 32, 0 },
  { 32, 2 },
  { 30, 3 },
  { 33, 6 },
  { 33, 0 },
  { 34, 7 },
  { 34, 0 },
  { 36, 1 },
  { 36, 0 },
  { 31, 1 },
  { 31, 3 },
  { 38, 1 },
  { 38, 1 },
  { 38, 1 },
  { 38, 1 },
  { 39, 7 },
  { 44, 1 },
  { 37, 2 },
  { 37, 5 },
  { 45, 6 },
  { 47, 3 },
  { 47, 0 },
  { 46, 1 },
  { 41, 4 },
  { 43, 2 },
  { 43, 3 },
  { 40, 4 },
  { 40, 1 },
  { 49, 1 },
  { 49, 4 },
  { 51, 1 },
  { 48, 1 },
  { 48, 3 },
  { 48, 3 },
  { 52, 7 },
  { 52, 1 },
  { 42, 1 },
  { 42, 3 },
  { 55, 1 },
  { 55, 2 },
  { 54, 2 },
  { 54, 0 },
  { 50, 2 },
  { 50, 3 },
  { 57, 3 },
  { 57, 3 },
  { 57, 2 },
  { 56, 2 },
  { 56, 1 },
  { 56, 1 },
  { 58, 1 },
  { 58, 1 },
  { 58, 1 },
  { 59, 1 },
  { 59, 2 },
  { 60, 2 },
  { 60, 2 },
  { 60, 3 },
  { 60, 5 },
  { 60, 6 },
  { 60, 6 },
  { 60, 2 },
  { 61, 1 },
  { 61, 1 },
  { 53, 2 },
  { 53, 3 },
  { 62, 3 },
  { 62, 3 },
  { 62, 2 },
  { 35, 1 },
  { 35, 1 },
  { 35, 1 },
  { 35, 2 },
  { 35, 2 },
  { 35, 3 },
  { 35, 2 },
  { 35, 3 },
  { 35, 4 },
};

static void yy_accept(yyParser*);  /* Forward Declaration */

/*
** Perform a reduce action and the shift that must immediately
** follow the reduce.
*/
static void yy_reduce(
  yyParser *yypParser,         /* The parser */
  int yyruleno                 /* Number of the rule by which to reduce */
){
  int yygoto;                     /* The next state */
  int yyact;                      /* The next action */
  YYMINORTYPE yygotominor;        /* The LHS of the rule reduced */
  yyStackEntry *yymsp;            /* The top of the parser's stack */
  int yysize;                     /* Amount to pop the stack */
  tkhtmlCssParserARG_FETCH;
  yymsp = &yypParser->yystack[yypParser->yyidx];
#ifndef NDEBUG
  if( yyTraceFILE && yyruleno>=0 
        && yyruleno<sizeof(yyRuleName)/sizeof(yyRuleName[0]) ){
    fprintf(yyTraceFILE, "%sReduce [%s].\n", yyTracePrompt,
      yyRuleName[yyruleno]);
  }
#endif /* NDEBUG */

#ifndef NDEBUG
  /* Silence complaints from purify about yygotominor being uninitialized
  ** in some cases when it is copied into the stack after the following
  ** switch.  yygotominor is uninitialized when a rule reduces that does
  ** not set the value of its left-hand side nonterminal.  Leaving the
  ** value of the nonterminal uninitialized is utterly harmless as long
  ** as the value is never used.  So really the only thing this code
  ** accomplishes is to quieten purify.  
  */
  memset(&yygotominor, 0, sizeof(yygotominor));
#endif

  switch( yyruleno ){
  /* Beginning here are the reduction cases.  A typical example
  ** follows:
  **   case 0:
  **  #line <lineno> <grammarfile>
  **     { ... }           // User supplied code
  **  #line <lineno> <thisfile>
  **     break;
  */
      case 6:
#line 76 "cssparse.y"
{
    HtmlCssImport(pParse, &yymsp[-3].minor.yy0);
}
#line 777 "cssparse.c"
        break;
      case 15:
#line 98 "cssparse.y"
{
    /* If a parse error is encountered at this level, call HtmlCssRule()
     * to discard any half-parsed selector. For example, the following 
     * two fragments are equivalent (although the first contains a parse
     * error and will not validate): 
     *
     *     "div ] span {color:red}"
     *     "span {color:red}"
     *
     * Specifically, the first fragment is not equivalent to:
     *
     *     "div span {color:red}"
     */
    HtmlCssRule(pParse, 0);
}
#line 796 "cssparse.c"
        break;
      case 16:
#line 118 "cssparse.y"
{
    pParse->isIgnore = 0;
}
#line 803 "cssparse.c"
        break;
      case 17:
#line 125 "cssparse.y"
{
    if (
        (yymsp[0].minor.yy0.n == 3 && 0 == strncasecmp(yymsp[0].minor.yy0.z, "all", 3)) ||
        (yymsp[0].minor.yy0.n == 6 && 0 == strncasecmp(yymsp[0].minor.yy0.z, "screen", 6))
    ) {
        yygotominor.yy4 = 0;
    } else {
        yygotominor.yy4 = 1;
    }
}
#line 817 "cssparse.c"
        break;
      case 18:
#line 136 "cssparse.y"
{
    yygotominor.yy4 = yymsp[-1].minor.yy4;
    pParse->isIgnore = yygotominor.yy4;
}
#line 825 "cssparse.c"
        break;
      case 19:
#line 141 "cssparse.y"
{
    yygotominor.yy4 = (yymsp[-4].minor.yy4 && yymsp[0].minor.yy4) ? 1 : 0;
    pParse->isIgnore = yygotominor.yy4;
}
#line 833 "cssparse.c"
        break;
      case 20:
#line 149 "cssparse.y"
{
  pParse->isIgnore = 0;
}
#line 840 "cssparse.c"
        break;
      case 23:
#line 156 "cssparse.y"
{
  pParse->isIgnore = 1;
}
#line 847 "cssparse.c"
        break;
      case 27:
#line 171 "cssparse.y"
{
    HtmlCssRule(pParse, 1);
}
#line 854 "cssparse.c"
        break;
      case 31:
#line 178 "cssparse.y"
{
    HtmlCssSelectorComma(pParse);
}
#line 861 "cssparse.c"
        break;
      case 35:
#line 186 "cssparse.y"
{
    HtmlCssDeclaration(pParse, &yymsp[-5].minor.yy0, &yymsp[-1].minor.yy0, yymsp[0].minor.yy4);
}
#line 868 "cssparse.c"
        break;
      case 41:
#line 198 "cssparse.y"
{yygotominor.yy4 = (pParse->pStyleId) ? 1 : 0;}
#line 873 "cssparse.c"
        break;
      case 42:
#line 199 "cssparse.y"
{yygotominor.yy4 = 0;}
#line 878 "cssparse.c"
        break;
      case 45:
#line 219 "cssparse.y"
{
    HtmlCssSelector(pParse, CSS_SELECTORCHAIN_ADJACENT, 0, 0);
}
#line 885 "cssparse.c"
        break;
      case 46:
#line 222 "cssparse.y"
{
    HtmlCssSelector(pParse, CSS_SELECTORCHAIN_CHILD, 0, 0);
}
#line 892 "cssparse.c"
        break;
      case 47:
#line 225 "cssparse.y"
{
    HtmlCssSelector(pParse, CSS_SELECTORCHAIN_DESCENDANT, 0, 0);
}
#line 899 "cssparse.c"
        break;
      case 51:
      case 53:
#line 233 "cssparse.y"
{ HtmlCssSelector(pParse, CSS_SELECTOR_TYPE, 0, &yymsp[0].minor.yy0); }
#line 905 "cssparse.c"
        break;
      case 52:
#line 234 "cssparse.y"
{ HtmlCssSelector(pParse, CSS_SELECTOR_UNIVERSAL, 0, 0); }
#line 910 "cssparse.c"
        break;
      case 56:
#line 240 "cssparse.y"
{
    HtmlCssSelector(pParse, CSS_SELECTOR_ID, 0, &yymsp[0].minor.yy0);
}
#line 917 "cssparse.c"
        break;
      case 57:
#line 243 "cssparse.y"
{
    /* A CSS class selector may not begin with a digit. Presumably this is
     * because they expect to use this syntax for something else in a
     * future version. For now, just insert a "never-match" condition into
     * the rule to prevent it from having any affect. A bit lazy, this.
     */
    if (yymsp[0].minor.yy0.n > 0 && !isdigit((int)(*yymsp[0].minor.yy0.z))) {
        HtmlCssSelector(pParse, CSS_SELECTOR_CLASS, 0, &yymsp[0].minor.yy0);
    } else {
        HtmlCssSelector(pParse, CSS_SELECTOR_NEVERMATCH, 0, 0);
    }
}
#line 933 "cssparse.c"
        break;
      case 58:
#line 255 "cssparse.y"
{
    HtmlCssSelector(pParse, CSS_SELECTOR_ATTR, &yymsp[-1].minor.yy0, 0);
}
#line 940 "cssparse.c"
        break;
      case 59:
#line 258 "cssparse.y"
{
    HtmlCssSelector(pParse, CSS_SELECTOR_ATTRVALUE, &yymsp[-3].minor.yy0, &yymsp[-1].minor.yy0);
}
#line 947 "cssparse.c"
        break;
      case 60:
#line 261 "cssparse.y"
{
    HtmlCssSelector(pParse, CSS_SELECTOR_ATTRLISTVALUE, &yymsp[-4].minor.yy0, &yymsp[-1].minor.yy0);
}
#line 954 "cssparse.c"
        break;
      case 61:
#line 264 "cssparse.y"
{
    HtmlCssSelector(pParse, CSS_SELECTOR_ATTRHYPHEN, &yymsp[-4].minor.yy0, &yymsp[-1].minor.yy0);
}
#line 961 "cssparse.c"
        break;
      case 62:
#line 268 "cssparse.y"
{
    HtmlCssSelector(pParse, HtmlCssPseudo(&yymsp[0].minor.yy0), 0, 0);
}
#line 968 "cssparse.c"
        break;
      case 63:
      case 64:
#line 272 "cssparse.y"
{yygotominor.yy0 = yymsp[0].minor.yy0;}
#line 974 "cssparse.c"
        break;
      case 65:
#line 281 "cssparse.y"
{ yygotominor.yy0 = yymsp[-1].minor.yy0; }
#line 979 "cssparse.c"
        break;
      case 66:
      case 75:
      case 77:
#line 282 "cssparse.y"
{ yygotominor.yy0.z = yymsp[-2].minor.yy0.z; yygotominor.yy0.n = (yymsp[0].minor.yy0.z+yymsp[0].minor.yy0.n - yymsp[-2].minor.yy0.z); }
#line 986 "cssparse.c"
        break;
      case 70:
      case 71:
      case 72:
#line 288 "cssparse.y"
{ yygotominor.yy0 = yymsp[0].minor.yy0; }
#line 993 "cssparse.c"
        break;
      case 73:
      case 74:
      case 76:
#line 291 "cssparse.y"
{ yygotominor.yy0.z = yymsp[-1].minor.yy0.z; yygotominor.yy0.n = (yymsp[0].minor.yy0.z+yymsp[0].minor.yy0.n - yymsp[-1].minor.yy0.z); }
#line 1000 "cssparse.c"
        break;
      case 78:
#line 297 "cssparse.y"
{ yygotominor.yy0.z = yymsp[-3].minor.yy0.z; yygotominor.yy0.n = (yymsp[0].minor.yy0.z+yymsp[0].minor.yy0.n - yymsp[-3].minor.yy0.z); }
#line 1005 "cssparse.c"
        break;
  };
  yygoto = yyRuleInfo[yyruleno].lhs;
  yysize = yyRuleInfo[yyruleno].nrhs;
  yypParser->yyidx -= yysize;
  yyact = yy_find_reduce_action(yymsp[-yysize].stateno,yygoto);
  if( yyact < YYNSTATE ){
#ifdef NDEBUG
    /* If we are not debugging and the reduce action popped at least
    ** one element off the stack, then we can push the new element back
    ** onto the stack here, and skip the stack overflow test in yy_shift().
    ** That gives a significant speed improvement. */
    if( yysize ){
      yypParser->yyidx++;
      yymsp -= yysize-1;
      yymsp->stateno = yyact;
      yymsp->major = yygoto;
      yymsp->minor = yygotominor;
    }else
#endif
    {
      yy_shift(yypParser,yyact,yygoto,&yygotominor);
    }
  }else if( yyact == YYNSTATE + YYNRULE + 1 ){
    yy_accept(yypParser);
  }
}

/*
** The following code executes when the parse fails
*/
static void yy_parse_failed(
  yyParser *yypParser           /* The parser */
){
  tkhtmlCssParserARG_FETCH;
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sFail!\n",yyTracePrompt);
  }
#endif
  while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser fails */
  tkhtmlCssParserARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/*
** The following code executes when a syntax error first occurs.
*/
static void yy_syntax_error(
  yyParser *yypParser,           /* The parser */
  int yymajor,                   /* The major type of the error token */
  YYMINORTYPE yyminor            /* The minor type of the error token */
){
  tkhtmlCssParserARG_FETCH;
#define TOKEN (yyminor.yy0)
#line 54 "cssparse.y"

    pParse->pStyle->nSyntaxErr++;
    pParse->isIgnore = 0;
#line 1067 "cssparse.c"
  tkhtmlCssParserARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/*
** The following is executed when the parser accepts
*/
static void yy_accept(
  yyParser *yypParser           /* The parser */
){
  tkhtmlCssParserARG_FETCH;
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sAccept!\n",yyTracePrompt);
  }
#endif
  while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser accepts */
  tkhtmlCssParserARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/* The main parser program.
** The first argument is a pointer to a structure obtained from
** "tkhtmlCssParserAlloc" which describes the current state of the parser.
** The second argument is the major token number.  The third is
** the minor token.  The fourth optional argument is whatever the
** user wants (and specified in the grammar) and is available for
** use by the action routines.
**
** Inputs:
** <ul>
** <li> A pointer to the parser (an opaque structure.)
** <li> The major token number.
** <li> The minor token number.
** <li> An option argument of a grammar-specified type.
** </ul>
**
** Outputs:
** None.
*/
void tkhtmlCssParser(
  void *yyp,                   /* The parser */
  int yymajor,                 /* The major token code number */
  tkhtmlCssParserTOKENTYPE yyminor       /* The value for the token */
  tkhtmlCssParserARG_PDECL               /* Optional %extra_argument parameter */
){
  YYMINORTYPE yyminorunion;
  int yyact;            /* The parser action. */
  int yyendofinput;     /* True if we are at the end of input */
  int yyerrorhit = 0;   /* True if yymajor has invoked an error */
  yyParser *yypParser;  /* The parser */

  /* (re)initialize the parser, if necessary */
  yypParser = (yyParser*)yyp;
  if( yypParser->yyidx<0 ){
    /* if( yymajor==0 ) return; // not sure why this was here... */
    yypParser->yyidx = 0;
    yypParser->yyerrcnt = -1;
    yypParser->yystack[0].stateno = 0;
    yypParser->yystack[0].major = 0;
  }
  yyminorunion.yy0 = yyminor;
  yyendofinput = (yymajor==0);
  tkhtmlCssParserARG_STORE;

#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sInput %s\n",yyTracePrompt,yyTokenName[yymajor]);
  }
#endif

  do{
    yyact = yy_find_shift_action(yypParser,yymajor);
    if( yyact<YYNSTATE ){
      yy_shift(yypParser,yyact,yymajor,&yyminorunion);
      yypParser->yyerrcnt--;
      if( yyendofinput && yypParser->yyidx>=0 ){
        yymajor = 0;
      }else{
        yymajor = YYNOCODE;
      }
    }else if( yyact < YYNSTATE + YYNRULE ){
      yy_reduce(yypParser,yyact-YYNSTATE);
    }else if( yyact == YY_ERROR_ACTION ){
      int yymx;
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE,"%sSyntax Error!\n",yyTracePrompt);
      }
#endif
#ifdef YYERRORSYMBOL
      /* A syntax error has occurred.
      ** The response to an error depends upon whether or not the
      ** grammar defines an error token "ERROR".  
      **
      ** This is what we do if the grammar does define ERROR:
      **
      **  * Call the %syntax_error function.
      **
      **  * Begin popping the stack until we enter a state where
      **    it is legal to shift the error symbol, then shift
      **    the error symbol.
      **
      **  * Set the error count to three.
      **
      **  * Begin accepting and shifting new tokens.  No new error
      **    processing will occur until three tokens have been
      **    shifted successfully.
      **
      */
      if( yypParser->yyerrcnt<0 ){
        yy_syntax_error(yypParser,yymajor,yyminorunion);
      }
      yymx = yypParser->yystack[yypParser->yyidx].major;
      if( yymx==YYERRORSYMBOL || yyerrorhit ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE,"%sDiscard input token %s\n",
             yyTracePrompt,yyTokenName[yymajor]);
        }
#endif
        yy_destructor(yymajor,&yyminorunion);
        yymajor = YYNOCODE;
      }else{
         while(
          yypParser->yyidx >= 0 &&
          yymx != YYERRORSYMBOL &&
          (yyact = yy_find_reduce_action(
                        yypParser->yystack[yypParser->yyidx].stateno,
                        YYERRORSYMBOL)) >= YYNSTATE
        ){
          yy_pop_parser_stack(yypParser);
        }
        if( yypParser->yyidx < 0 || yymajor==0 ){
          yy_destructor(yymajor,&yyminorunion);
          yy_parse_failed(yypParser);
          yymajor = YYNOCODE;
        }else if( yymx!=YYERRORSYMBOL ){
          YYMINORTYPE u2;
          u2.YYERRSYMDT = 0;
          yy_shift(yypParser,yyact,YYERRORSYMBOL,&u2);
        }
      }
      yypParser->yyerrcnt = 3;
      yyerrorhit = 1;
#else  /* YYERRORSYMBOL is not defined */
      /* This is what we do if the grammar does not define ERROR:
      **
      **  * Report an error message, and throw away the input token.
      **
      **  * If the input token is $, then fail the parse.
      **
      ** As before, subsequent error messages are suppressed until
      ** three input tokens have been successfully shifted.
      */
      if( yypParser->yyerrcnt<=0 ){
        yy_syntax_error(yypParser,yymajor,yyminorunion);
      }
      yypParser->yyerrcnt = 3;
      yy_destructor(yymajor,&yyminorunion);
      if( yyendofinput ){
        yy_parse_failed(yypParser);
      }
      yymajor = YYNOCODE;
#endif
    }else{
      yy_accept(yypParser);
      yymajor = YYNOCODE;
    }
  }while( yymajor!=YYNOCODE && yypParser->yyidx>=0 );
  return;
}
