#include "EmbedAPI.hpp"
#include <iostream>

#include <boost/thread.hpp>

using namespace std;
using namespace ELLOGON;
using namespace boost;

class processCallable {
  Ellogon &elg;
  int argc;
  const char **argv;
  const char *path;
public:
  processCallable(Ellogon &e, const char *p, int ac, const char **av) :
    elg(e), path(p), argc(ac), argv(av) {};

  void operator() () {
    elg.init(path, argc, argv);
    /* Wait until the main window is closed! */
    elg.eval("tkwait visibility .mw");
    elg.destroy();
  };
};

int main(int argc, char **argv) {
  const char *arguments[2];
  const char *path_to_ellogon = "../../../ellogon";
  /* Add two additional arguments: -gui true */
  arguments[0] = "-gui";
  arguments[1] = "true";
  Ellogon::debug(true);
  /* Create two ellogon objects, through the empty constructor.
     This means that Ellogon will not start, until init() is called on
     each object... */
  Ellogon e1, e2;

  processCallable c1(e1, path_to_ellogon, 2, arguments),
                  c2(e2, path_to_ellogon, 2, arguments);

  /* Create two threads! */
  cout << " + Starting two threads!" << endl << flush;
  boost::thread t1(c1), t2(c2);
  /* Wait both of them to finish! */
  t1.join();
  t2.join();
  return 0;
}; /* main */
