// TclControl.h : Declaration of the CTclControl

#ifndef __TCLCONTROL_H_
#define __TCLCONTROL_H_

#include "resource.h"       // main symbols
#include <atlctl.h>
#include "TclControlPrj2CP.h"
#include <string>

#define TK_CLAIMFOCUS		(WM_USER)
#define TK_GEOMETRYREQ		(WM_USER+1)
#define TK_ATTACHWINDOW		(WM_USER+2)
#define TK_DETACHWINDOW		(WM_USER+3)




class CTclClassFactory : public CComClassFactory  
{
public:
	CTclClassFactory();
	virtual ~CTclClassFactory();

	// override
	STDMETHOD(CreateInstance) (LPUNKNOWN pUnkOuter, REFIID riid, void ** ppvObject);
protected:
	static DWORD WINAPI TclThreadProc (LPVOID lpstruct);
	HANDLE		m_hT1Ready;
	HANDLE		m_hT2Ready;
	IStream	*	m_pMarshallStm;
	LPUNKNOWN	m_pUnkOuter;
	IID			m_iid;
	HRESULT		m_hres;
	void *		m_pu;
};


/////////////////////////////////////////////////////////////////////////////
// CTclControl
class ATL_NO_VTABLE CTclControl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<ITclControl, &IID_ITclControl, &LIBID_TCLCONTROLPRJ2Lib>,
	public CComControl<CTclControl>,
	public IPersistStreamInitImpl<CTclControl>,
	public IOleControlImpl<CTclControl>,
	public IOleObjectImpl<CTclControl>,
	public IOleInPlaceActiveObjectImpl<CTclControl>,
	public IViewObjectExImpl<CTclControl>,
	public IOleInPlaceObjectWindowlessImpl<CTclControl>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CTclControl>,
	public IPersistStorageImpl<CTclControl>,
	public ISpecifyPropertyPagesImpl<CTclControl>,
	public IQuickActivateImpl<CTclControl>,
	public IDataObjectImpl<CTclControl>,
	public IProvideClassInfo2Impl<&CLSID_TclControl, &DIID__ITclControlEvents, &LIBID_TCLCONTROLPRJ2Lib>,
	public IPropertyNotifySinkCP<CTclControl>,
	public CComCoClass<CTclControl, &CLSID_TclControl>,
	public CProxy_ITclControlEvents< CTclControl >
{
public:
	CTclControl();
	virtual ~CTclControl ();
	virtual HWND CreateControlWindow( HWND hWndParent, RECT& rcPos );

DECLARE_REGISTRY_RESOURCEID(IDR_TCLCONTROL)

DECLARE_PROTECT_FINAL_CONSTRUCT()

// the following line implements the use of the multithreaded class factory
// DECLARE_CLASSFACTORY_EX(CTclClassFactory)


BEGIN_COM_MAP(CTclControl)
	COM_INTERFACE_ENTRY(ITclControl)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_PROP_MAP(CTclControl)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(CTclControl)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
	CONNECTION_POINT_ENTRY(DIID__ITclControlEvents)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CTclControl)
	MESSAGE_HANDLER(TK_ATTACHWINDOW, OnTkAttach)
	MESSAGE_HANDLER(TK_GEOMETRYREQ, OnTkGeomReq)
	MESSAGE_HANDLER(TK_CLAIMFOCUS, OnTkClaimFocus)
	MESSAGE_HANDLER(WM_PARENTNOTIFY, OnParentNotify)
	MESSAGE_HANDLER(WM_SIZE, OnSize)
	CHAIN_MSG_MAP(CComControl<CTclControl>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] = 
		{
			&IID_ITclControl,
		};
		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// overrides
public:
	STDMETHOD(InPlaceDeactivate)();

// ITclControl
public:
	STDMETHOD(put_MyProp)(long index, float value);
	STDMETHOD(TraceVar2)(/*[in]*/ BSTR name1, /*[in]*/ BSTR name2, /*[in]*/ long flags, /*[out, retval]*/ VARIANT_BOOL *pbOk);
	STDMETHOD(TraceVar)(/*[in]*/ BSTR name, /*[in]*/ long flags, /*[out, retval]*/ VARIANT_BOOL *pbOk);
	STDMETHOD(get_Result)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(Eval)(/*[in]*/ BSTR command, /*[out, retval]*/ VARIANT_BOOL *pbOk);
    STDMETHOD(LoadTk)(void);
	// message handlers
	LRESULT OnTkClaimFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnParentNotify(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnTkAttach(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnTkGeomReq(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	HRESULT OnDraw(ATL_DRAWINFO& di);


protected:
	Tcl_Interp * m_pInterp;	// the interpreter for this control
	HWND		m_hWndTk;	// the windows handle to the tk toplevel
	Tk_Window	m_tkWnd;	// the Tk_Window handle for the toplevel
	std::string	m_error;

public: // static members
	STDMETHOD(UnsetVar2)(/*[in]*/ BSTR name1, /*[in]*/ BSTR name2, /*[in]*/ long flags);
	STDMETHOD(UnsetVar)(/*[in]*/ BSTR name, /*[in]*/ long flags);
	STDMETHOD(GetVar2)(/*[in]*/ BSTR name1, /*[in]*/ BSTR name2, /*[in]*/ long flags,/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(SetVar2)(/*[in]*/ BSTR name1, /*[in]*/ BSTR name2, /*[in]*/ BSTR value, /*[in]*/ long flags, /*[out, retval]*/ VARIANT_BOOL *pbOk);
	STDMETHOD(GetVar)(/*[in]*/ BSTR name, /*[in]*/ long flags, /*[out, retval]*/ BSTR *pValue);
	STDMETHOD(SetVar)(/*[in]*/ BSTR name, /*[in]*/ BSTR value, /*[in]*/ long flags, /*[out, retval]*/ VARIANT_BOOL *pbOk);
	STDMETHOD(UntraceVar2)(/*[in]*/ BSTR name1, /*[in]*/ BSTR name2, /*[in]*/ long flags);
	STDMETHOD(UntraceVar)(/*[in]*/ BSTR name, /*[in]*/ long flags);
	static char* VarCallback (ClientData cd, Tcl_Interp *pInterp, char *name1, char *name2, int flags);
	
};

#endif //__TCLCONTROL_H_
