// TclControlPrj2.cpp : Implementation of DLL Exports.


// Note: Proxy/Stub Information
//      To merge the proxy/stub code into the object DLL, add the file 
//      dlldatax.c to the project.  Make sure precompiled headers 
//      are turned off for this file, and add _MERGE_PROXYSTUB to the 
//      defines for the project.  
//
//      If you are not running WinNT4.0 or Win95 with DCOM, then you
//      need to remove the following define from dlldatax.c
//      #define _WIN32_WINNT 0x0400
//
//      Further, if you are running MIDL without /Oicf switch, you also 
//      need to remove the following define from dlldatax.c.
//      #define USE_STUBLESS_PROXY
//
//      Modify the custom build rule for TclControlPrj2.idl by adding the following 
//      files to the Outputs.
//          TclControlPrj2_p.c
//          dlldata.c
//      To build a separate proxy/stub DLL, 
//      run nmake -f TclControlPrj2ps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "TclControlPrj2.h"
#include "dlldatax.h"

#include "TclControlPrj2_i.c"
#include "TclControl.h"

#ifdef _MERGE_PROXYSTUB
extern "C" HINSTANCE hProxyDll;
#endif

CComModule _Module;
HHOOK hHook = NULL;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_TclControl, CTclControl)
END_OBJECT_MAP()


// main --
// used to make the minimum dependancy build work
void main (void)
{

}

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	USES_CONVERSION;
	Tcl_Time timeout;
	TCHAR location[MAX_PATH];

	// initialise the Tcl and Tk stub table
#ifdef _MERGE_PROXYSTUB
    if (!PrxDllMain(hInstance, dwReason, lpReserved))
        return FALSE;
#endif
	switch (dwReason) {
	case DLL_PROCESS_ATTACH:
        _Module.Init(ObjectMap, hInstance, &LIBID_TCLCONTROLPRJ2Lib);
		if (GetModuleFileName (_Module.m_hInst, location, MAX_PATH) > 0)
			Tcl_FindExecutable (location);

		Tcl_SetServiceMode(TCL_SERVICE_ALL);
		timeout.sec = 0;
		timeout.usec = 25000;
		Tcl_SetTimer (&timeout);
		break;
	case DLL_PROCESS_DETACH:
		Tcl_Finalize();
        _Module.Term();
		break;
	default:
		break;
	}	
    return TRUE;    // ok
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
#ifdef _MERGE_PROXYSTUB
    if (PrxDllCanUnloadNow() != S_OK)
        return S_FALSE;
#endif
    return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
#ifdef _MERGE_PROXYSTUB
    if (PrxDllGetClassObject(rclsid, riid, ppv) == S_OK)
        return S_OK;
#endif
    return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
#ifdef _MERGE_PROXYSTUB
    HRESULT hRes = PrxDllRegisterServer();
    if (FAILED(hRes))
        return hRes;
#endif
    // registers object, typelib and all interfaces in typelib
    return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
#ifdef _MERGE_PROXYSTUB
    PrxDllUnregisterServer();
#endif
    return _Module.UnregisterServer(TRUE);
}






// ------------------------------------------

