set TkTableDir TkTable
set Home [pwd]
## Locate the configure script...
cd lib/$TkTableDir
if {![file exists configure]} {
  cd unix
}
puts "+++ Running 'configure' in directory [pwd]..."
set libpath [file dirname [info library]]
catch {file delete -force config.cache}
set env(TCLTK_ROOT) $libpath
set env(TCL_CONFIG_DIR) $libpath
catch {exec ./configure --enable-gcc --prefix=[file dirname $libpath]\
       >@ stdout} error
puts $error
puts "    +++ 'configure' completed successfully..."
puts "+++ Running 'make' in directory [pwd]..."
if {[catch {exec make >@ stdout} error]} {
  puts "    +++ 'make' failed:$error"
} else {
  puts "    +++ 'make' completed successfully..."
}
puts "*** Saving libraries..."
catch {
file mkdir $Home/lib/Tktable2.8
}
## Get the name of the library object...
foreach libFile [glob -nocomplain -type f \
                      libTktable*[info sharedlibextension] \
                      library/*] {
  catch {
    file copy -force $libFile \
                       $Home/lib/Tktable2.8/[file tail $libFile]
    puts "   Saving file $libFile to $Home/lib/Tktable2.8"
  }
}
puts "+++ Removing unwanted files..."
catch {exec make distclean >@ stdout}
exit 0
