##############################################################################
## build.tcl --
##
## This Tcl script can be used to build the "%pkgName%" Tcl package
## (extension) if the package tBuild is present.
##
## Automatically generated by the tBuild package.
##
## Usage:
##   tclsh build.tcl
#############################################################################

## Load the tBuild package.
package require tBuild

## We want the build process to look like a standart one, instrumented by a
## makefile. Thus, we define an execution callback that uses out stdout/stderr.
proc ExecCallback {args} {
  puts $args
  if {[catch {eval exec $args 2>@stderr >@stdout} error]} {
    puts stderr $error; exit -1
  }
};# ExecCallback
::tBuild::Configure -execCallback ExecCallback

## Compile all our C files.
set OBJS [::tBuild::CompileSharedObject -define BUILD_%pkgNameUpper% \
                                        -includedir generic \
                                         generic/tcl%pkgName%.c \
                                         generic/%pkgName%.c]

## Link the returned objects to build the shared library.
if {[string equal $::tcl_platform(platform) windows]} {
  set binDir Windows
} else {
  set binDir $::tcl_platform(os)
}
eval ::tBuild::LinkSharedLibrary \
  -output lib/$binDir/lib%pkgName%[info \
   sharedlibextension] $OBJS

## Remove the object files.
foreach obj $OBJS {catch {file delete -force -- $obj} error}
