/*
 * tcl%pkgName%.c --
 *
 *	This file implements a Tcl interface to the functions in pkgName.c
 *
 * Copyright (c) %year% %author%.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include "%pkgName%.h"

/*
 * Forward declarations of functions used later in the file.
 */
%callbacksproto%

%callbacks%

/*
 *----------------------------------------------------------------------
 *
 * %pkgNameTitle%_Init --
 *
 *	Initialize the package under a trusted (not safe) interpreter.
 *
 * Results:
 *	A standard Tcl result
 *
 * Side effects:
 *	The %pkgName% package is initialised.
 *	One or more new commands may be added to the Tcl interpreter.
 *
 *----------------------------------------------------------------------
 */
EXTERN int
%pkgNameTitle%_Init(Tcl_Interp *interp)
{
    /*
     * Initialise the stubs interface. Stubs require at least Tcl version 8.1.
     */
    if (Tcl_InitStubs(interp, "8.1", 0) == NULL) {
	return TCL_ERROR;
    }
    if (Tcl_PkgRequire(interp, "Tcl", "8.1", 0) == NULL) {
	return TCL_ERROR;
    }
    if (Tcl_PkgProvide(interp, PACKAGE_NAME, PACKAGE_VERSION) != TCL_OK) {
	return TCL_ERROR;
    }
    /*
     * Register any new commands.
     */
    %registration%

    return TCL_OK;
} /* %pkgNameTitle%_Init */

/*
 *----------------------------------------------------------------------
 *
 * %pkgNameTitle%_SafeInit --
 *
 *	Initialize the package under a safe interpreter.
 *
 * Results:
 *	A standard Tcl result
 *
 * Side effects:
 *	The %pkgName% package is initialised.
 *	One or more new commands may be added to the Tcl interpreter.
 *
 *----------------------------------------------------------------------
 */
EXTERN int
%pkgNameTitle%_SafeInit(Tcl_Interp *interp)
{
    return %pkgNameTitle%_Init(interp);
} /* %pkgNameTitle%_Init */

/*
 * End of file tcl%pkgName%.c
 */
