#############################################################################
## Test script for the tBuild package.
## This script creates a new Tcl package at the current directory,
## and then tries to compile and load the package.
#############################################################################

## Ensure that the tBuild extension can be found.
lappend auto_path [file dirname [file normalize [info script]]]

###
##  Test 1: Create a new extension.
###
puts "Test 1: Creating a new extension..."
package require tBuild::Extension
::tBuild::tExtension::CreateTclExtension \
          -pkgName testExtension \
          -pkgDir  [pwd] \
          -cmdSpec {tBuildTest Test}

###
##  Test 2: Build the extension.
###
puts "Test 2: Building the extension..."
set CWD [pwd]
cd testExtension
source build.tcl
cd $CWD

###
##  Test 3: Load the extension.
###
puts "Test 3: Loading the extension..."
lappend auto_path [pwd]/testExtension
package require testExtension

###
##  Test 4: Call the "tBuildTest" command.
###
puts "Test 4: Calling the \"tBuildTest\" command..."
set result [tBuildTest]
puts "Result: \"$result\""

puts "All tests completed succesfully!\n"
###
##  Clean-up all created files...
### 
#file delete -force -- ./testExtension
exit 0
