set Home       [pwd]
set prefix     [file dirname [file dirname $Home]]
set TclHome    /disk2b/local/sources/tcl/tcl
set ThreadHome [file normalize [lindex [glob -directory .. thread26*] 0]]
set ThreadHome /opt/ActiveTcl-8.5/lib/tcl8.5/thread2.6.5/
set JDKHome    /usr/java/j2sdk_nb/j2sdk1.4.2
set Version    1.4.0

## Try to locate the Java Home directory...
if {![catch {exec which javah} java]} {
  set JDKHome [file dirname [file dirname $java]]
}
set JDKHome    /usr/lib/jvm/java-6-sun-1.6.0.03/

#cd tclBlend${Version}
cd tclBlend1.4.0

if {$Version == "1.2.6"} {cd unix}

puts "+++ Running 'configure' in directory [pwd]..."
set libpath [file dirname [info library]]
catch {file delete -force config.cache}
puts "./configure --with-build=tclblend --with-thread=$ThreadHome \
	    --with-tcl=$TclHome --prefix=$prefix --exec_prefix=$prefix \
            --with-jdk=$JDKHome"
if {[catch {exec sh ./configure --with-build=tclblend --with-thread=$ThreadHome\
	    --with-tcl=$TclHome --prefix=$prefix --exec_prefix=$prefix \
            --with-jdk=$JDKHome >@ stdout} error]} {
  puts "    +++ 'configure' failed:$error"
} else {
  puts "    +++ 'configure' completed successfully..."
}
puts "+++ Running 'make' in directory [pwd]..."
if {[catch {exec make >@ stdout} error]} {
  puts "    +++ 'make' failed:$error"
} else {
  puts "    +++ 'make' completed successfully..."
}
puts "+++ Running 'make install' in directory [pwd]..."
# if {[catch {exec make install >@ stdout} error]} {
#   puts "    +++ 'make install' failed:$error"
# } else {
#   puts "    +++ 'make install' completed successfully..."
# }
file mkdir $prefix/lib/tcljava${Version}
file copy -force -- libtclblend[info sharedlib] $prefix/lib/tcljava${Version}
foreach file {pkgIndex.tcl tclblend.jar tcljava.jar} {
  file copy -force -- $file $prefix/lib/tcjava${Version}
}
## Try to copy the xputils package
if {[file exists src/xputils]} {
  catch {file delete -force -- $prefix/lib/xputils}
  file copy -force -- src/xputils $prefix/lib
}
puts "+++ Running 'make clean' in directory [pwd]..."
if {[catch {exec make distclean >@ stdout} error]} {
  puts "    +++ 'make clean' failed:$error"
} else {
  puts "    +++ 'make clean' completed successfully..."
}

#foreach dir [glob -directory lib -type d *] {
#  puts "$dir -> $prefix"
#  file rename -force -- $dir $prefix
#}

## Generate the Java Configuration file, that will be used by Ellogon for
## loading the java package...
#foreach name [array names env] {
#  #puts "Defining: $name"
#  set $name $env($name)
#}
#set file [open bin/jtclsh]
#while {[gets $file line] != -1} {
#  set line [string trim $line]
#  switch -regexp -- $line {
#    {^[_A-Za-z]+=.*$} {
#      set index [string first = $line]
#      set name  [string range $line 0 [expr {$index-1}]]
#      set value [string range $line [expr {$index+1}] end]
#      ## Is name an environmental valiable?
#      if {![info exists $name]} {
#        set $name {}
#      }
#      set $name [subst $value]
#      #puts "\"$name\" = \"[set $name]\""
#    }
#    export.* {
#      set name [lindex $line end]
#      if {[info exists $name]} {
#        puts "$name = [set $name]"
#      }
#    }
#    default {}
#  }
#}
#close $file
