set ScriptDir [file dirname [info script]]
cd $ScriptDir
proc compile_windows {} {
  global ScriptDir
  set TCL [file dirname [file dirname [info nameofexe]]]
  package require registry
  set current_version [registry get \
      {HKEY_LOCAL_MACHINE\SOFTWARE\ActiveState\ActivePerl} CurrentVersion]
  set install_dir [registry get \
      "HKEY_LOCAL_MACHINE\\SOFTWARE\\ActiveState\\ActivePerl\\$current_version"\
      {}]
  set PERL $install_dir
  set PERL_DEFINES   [exec $PERL/bin/perl -X -MExtUtils::Embed -e ccopts]
  set PERL_LINK_OPTS [exec perl -MExtUtils::Embed -e ldopts]
  set PerlVersion    [regexp -inline {\d+\.\d+\.\d+} [exec perl -v]]

  set file [open Makefile.vc]
  set data [read $file]
  close $file

  ## Perform the substitutions...
  regsub {(\nPERL_DEFINES\s+=)[^\n]*} $data "\\1 $PERL_DEFINES" data
  regsub {(\nPERL_LINK_OPTS\s+=)[^\n]*} $data "\\1 $PERL_LINK_OPTS" data
  regsub {(\nPERL\s+=)[^\n]*} $data "\\1 [file native $PERL]" data
  regsub {(\nTCL\s+=)[^\n]*} $data "\\1 [file native $TCL]" data
  regsub {(\nPerlVersion\s+=)[^\n]*} $data "\\1 $PerlVersion" data

  set file [open Makefile.vc w]
  puts $file $data
  close $file

  exec nmake -f Makefile.vc >@stdout 2>@stderr
  foreach file [concat [glob *.dll] [glob *.dll.mani*]] {
    file rename -force $file Windows
  }

  lappend ::auto_path [file dirname $ScriptDir]
  package require tclperl

};# compile_windows

switch -- $::tcl_platform(platform) {
  unix    {
    compile_unix
  }
  windows {
    compile_windows
  }
  default {error "Unsupported platform: \"$::tcl_platform(platform)\""}
}
