package ifneeded tclpython 4.1 \
        [list ::python::tclpython_load [file normalize $dir]]

namespace eval ::python {
  proc tclpython_load {dir} {
    package require platform
    switch -glob [platform::generic] {
      *_64    {set bits x86_64}
      default {set bits x86_32}
    }
    switch -- $::tcl_platform(platform) {
      unix    {tclpython_load_unix    $dir $bits}
      windows {tclpython_load_windows $dir $bits}
      default {error "Unsupported platform: \"$::tcl_platform(platform)\""}
    }
  }

  proc tclpython_load_unix {dir bits} {
    set os $::tcl_platform(os)
    set lib [info sharedlibextension]
    foreach dll [lsort -dictionary -decreasing [concat \
       [glob -nocomplain $dir/$os/$bits/libtclpython-4.1-*$lib] \
       [glob -nocomplain $dir/$os/libtclpython-4.1-*$lib] \
       [glob -nocomplain $dir/libtclpython-4.1-*$lib]]]  {
      if {![catch {load $dll Tclpython} error]} {
        break
      }
    }
  };# tclpython_load_unix

  proc tclpython_load_windows {dir bits} {
    foreach dll [lsort -dictionary -decreasing [concat \
       [glob -nocomplain $dir/Windows/$bits/libtclpython-4.1-*.dll] \
       [glob -nocomplain $dir/Windows/libtclpython-4.1-*.dll] \
       [glob -nocomplain $dir/libtclpython-4.1-*.dll]]]  {
      if {![catch {load $dll Tclpython} error]} {
        break
      }
    }
  };# tclpython_load_windows
};# namespace ::python
