set Home [pwd]
catch {cd [file join lib tree-8.0.4.1]}
puts "+++ Running 'configure' in directory [pwd]..."
set libpath [file dirname [info library]]
catch {file delete -force config.cache}
set env(TCLTK_ROOT) $libpath
set env(TCL_CONFIG_DIR) $libpath
catch {exec ./configure --enable-gcc --prefix=[file dirname $libpath] --enable-shared\
       >@ stdout} error
puts $error
puts "    +++ 'configure' completed successfully..."
puts "+++ Running 'make' in directory [pwd]..."
if {[catch {exec make >@stdout 2>@stderr} error]} {
  puts "    +++ 'make' failed:$error"
} else {
  puts "    +++ 'make' completed successfully..."
}
puts "*** Saving libraries..."
catch {
file rename -force libTkTree[info sharedlibextension] \
                   library/libTkTree[info sharedlibextension]
}
puts "+++ Removing unwanted files..."
catch {exec make clean >@ stdout}
exit 0
