# treeConfig.sh --
#
# This shell script (for sh) is generated automatically by tree's
# configure script.  It will create shell variables for most of
# the configuration options discovered by the configure script.
# This script is intended to be included by other configure scripts
# so that they don't have to figure this all out for themselves.
#
# The information in this file is specific to a single platform.
#

# version of the Tree library
TREE_VERSION='8.0.4'

# C Compiler used for TREE
TREE_CC='gcc -pipe -fwritable-strings'

# C++ Compiler used for TREE
TREE_CXX='g++'

# -I option for make depend with C++ sources
TREE_CXX_INCLUDE='-I/usr/lib/gcc/i386-redhat-linux/3.4.2/../../../../include/c++/3.4.2/backward'

# OS version
TREE_OSVERSION='Linux-2.6.9-1.724_FC3'

# target to use for make depend
TREE_DEPEND_TARGET='dep'

# Flags to pass to cc when compiling the components of a shared library:
TREE_SHLIB_CFLAGS='-fPIC'

# Base command to use for combining object files into a shared library:
TREE_SHLIB_LD='gcc -pipe -shared'

# Suffix to use for the name of a shared library.
TREE_SHLIB_SUFFIX='.so'

# Either '$LIBS' (if dependent libraries should be included when linking
# shared libraries) or an empty string.  See Tcl's configure.in for more
# explanation.
TREE_SHLIB_LD_LIBS='${LIBS}'

# Library file(s) to include in tclsh and other base applications
# in order to provide facilities needed by DLOBJ above.
TREE_DL_LIBS='-ldl'

# Flags to pass to the compiler when linking object files into
# an executable tclsh or tcltest binary.
TREE_LD_FLAGS=' -Wl,--export-dynamic'

# Flags to pass to cc, such as "-Wl,-R,/usr/local/tcl/lib", that tell the
# run-time dynamic linker where to look for shared libraries such as
# libtcl.so.  Used when linking applications.  Only works if there
# is a variable "LIB_RUNTIME_DIR" defined in the Makefile.
TREE_LD_SEARCH_FLAGS='-Wl,-rpath,${LIB_RUNTIME_DIR}'

# root of tree source tree
TREE_SRC_ROOT='/disk2a/users/petasis/Ellogon/lib/tree-8.0.4.1'

# -I flag for X include files
TREE_XINCSW='-I/usr/X11R6/include'

# -L and -l flags for X libs
TREE_XLIBSW='-L/usr/X11R6/lib -lX11 -lXext'

# flags for linking tcl and ext libs
TREE_TCL_LIB_SPEC='-L/disk2b/local/lib -ltcl8.5${TCL_DBGX}'
TREE_TK_LIB_SPEC='-L/disk2b/local/lib -ltk8.5'
TREE_TCLX_LIB_SPEC=''
TREE_ITCL_LIB_SPEC=''
TREE_ITK_LIB_SPEC=''
TREE_BLT_LIB_SPEC=''

# include flags
TREE_TCLINCSW='-I/disk2b/local/include -I/disk2b/local/include/itcl'
TREE_TKINCSW='-I/disk2b/local/include -I/disk2b/local/include/itcl'

# other package versions used by TREE
TREE_TCL_VERSION='8.5'
TREE_TK_VERSION='8.5'
TREE_ITCL_VERSION=''
TREE_ITK_VERSION=''
TREE_TCLX_VERSION=''
TREE_BLT_VERSION='2.4f'

# system libs to link
TREE_LIBS=' -lnsl -lresolv -ldl'

# TREE install dirs
TREE_DESTDIR='/disk2b/local'
TREE_BINDIR='/disk2b/local/bin'
TREE_LIBDIR='/disk2b/local/lib'
TREE_INCDIR='/disk2b/local/include/tree'
TREE_MANDIR='/disk2b/local/man'
TREE_DIR='/disk2b/local/lib/tree'

# Tcl/Tk defines
TREE_DEFS='-DPACKAGE_NAME=\"\" -DPACKAGE_TARNAME=\"\" -DPACKAGE_VERSION=\"\" -DPACKAGE_STRING=\"\" -DPACKAGE_BUGREPORT=\"\" -DSTDC_HEADERS=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_MEMORY_H=1 -DHAVE_STRINGS_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_UNISTD_H=1 -DHAVE_LIMITS_H=1 -DHAVE_SYS_PARAM_H=1 -DTCL_CFGVAL_ENCODING=\"iso8859-1\" -DPEEK_XCLOSEIM=1 -DTCL_CFG_OPTIMIZED=1 -DTCL_CFG_DEBUG=1 -D_LARGEFILE64_SOURCE=1 -DTCL_WIDE_INT_TYPE=long\ long -DHAVE_STRUCT_STAT64=1 -DHAVE_TYPE_OFF64_T=1 -DHAVE_GETCWD=1 -DHAVE_OPENDIR=1 -DHAVE_STRSTR=1 -DHAVE_STRTOL=1 -DHAVE_STRTOLL=1 -DHAVE_STRTOULL=1 -DHAVE_TMPNAM=1 -DHAVE_WAITPID=1 -DUSE_TERMIOS=1 -DHAVE_SYS_TIME_H=1 -DTIME_WITH_SYS_TIME=1 -DHAVE_STRUCT_TM_TM_ZONE=1 -DHAVE_TM_ZONE=1 -DHAVE_GMTIME_R=1 -DHAVE_LOCALTIME_R=1 -DHAVE_MKTIME=1 -DHAVE_TM_GMTOFF=1 -DHAVE_TIMEZONE_VAR=1 -DHAVE_STRUCT_STAT_ST_BLKSIZE=1 -DHAVE_ST_BLKSIZE=1 -DHAVE_SIGNED_CHAR=1 -DHAVE_LANGINFO=1 -DHAVE_SYS_IOCTL_H=1  -DPACKAGE_NAME=\"tk\" -DPACKAGE_TARNAME=\"tk\" -DPACKAGE_VERSION=\"8.5\" -DPACKAGE_STRING=\"tk\ 8.5\" -DPACKAGE_BUGREPORT=\"\" -DSTDC_HEADERS=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_MEMORY_H=1 -DHAVE_STRINGS_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_UNISTD_H=1 -DHAVE_LIMITS_H=1 -DPEEK_XCLOSEIM=1 -DTCL_SHLIB_EXT=\".so\" -DTCL_CFG_OPTIMIZED=1 -DTCL_CFG_DEBUG=1 -D_LARGEFILE64_SOURCE=1 -DTCL_WIDE_INT_TYPE=long\ long -DHAVE_STRUCT_STAT64=1 -DHAVE_OPEN64=1 -DHAVE_LSEEK64=1 -DHAVE_TYPE_OFF64_T=1 -DHAVE_SYS_TIME_H=1 -DTIME_WITH_SYS_TIME=1 -DHAVE_PW_GECOS=1 -DHAVE_XFT=1 '

# default location of Tree library files
TREE_LIBRARY='/disk2b/local/lib/tree'

# String to pass to linker to pick up the Tree library from its
# build directory.
TREE_BUILD_LIB_SPEC='-L/disk2a/users/petasis/Ellogon/lib/tree-8.0.4.1 -lTkTree'

# static version of above
TREE_BUILD_LIB_SPEC_STATIC='/disk2a/users/petasis/Ellogon/lib/tree-8.0.4.1/libTkTree.a'

# String to pass to linker to pick up the Tree library from its
# installed directory.
TREE_LIB_SPEC='-L/disk2b/local/lib -ltree'

# static version of above
TREE_LIB_SPEC='/disk2b/local/lib/libtree.a'

# Flags to pass to cc, such as "-Wl,-R,/usr/local/tcl/lib", that tell the
# run-time dynamic linker where to look for shared libraries such as
# libtcl.so.  Used when linking applications.  Only works if there
# is a variable "LIB_RUNTIME_DIR" defined in the Makefile.
TREE_LIB_RUNTIME_DIR='/disk2b/local/lib:/disk2b/local/lib'

# The environment variable TCLTK_ROOT may be set before running configure
# to help locate the correct Tcl/Tk installation
TREE_TCLTK_ROOT='/disk2b/local/lib'
