#!/bin/sh
# The next line is executed by /bin/sh, but not tcl \
exec wish "$0" ${1+"$@"}

set HomeDir [pwd]
## Load the Options file...
source Options.tcl

## Parse the encodings variable...
set Encodings [encoding names]
set Obsolete  {}

foreach encoding $GUI_Options(Encodings) {
  set enc   [lindex $encoding 0]
  set label [lindex $encoding 1]
  if {[string equal $enc -]} {
    continue
  } else {
    ## Remove encoding from our list...
    set index [lsearch -exact $Encodings $enc]
    if {$index >= 0} {
      set Encodings [lreplace $Encodings $index $index]
    } else {
      lappend Obsolete $enc
    }
  }
}

puts "New Encodings:      \"[join $Encodings {", "}]\""
puts "Obsolete Encodings: \"[join $Obsolete {", "}]\""
exit
