## Add entries to the Option database

## Create Fonts...
eval font create TextFont -family [list $GUI_Options(TextFont)] -size \
     $GUI_Options(TextFontSize) $GUI_Options(TextFontStyles)
eval font create FixedTextFont -family [list $GUI_Options(FixedTextFont)] \
     -size $GUI_Options(FixedTextFontSize) $GUI_Options(FixedTextFontStyles)
eval font create ModuleTextFont -family [list $GUI_Options(ModuleTextFont)] \
     -size $GUI_Options(ModuleTextFontSize) $GUI_Options(ModuleTextFontStyles)
eval font create ExplorerFont -family [list $GUI_Options(ExplorerFont)] -size \
     $GUI_Options(ExplorerFontSize) $GUI_Options(ExplorerFontStyles)
eval font create ExplorerFontUnderline -family \
     [list $GUI_Options(ExplorerFont)] -underline 1 -size \
     $GUI_Options(ExplorerFontSize) $GUI_Options(ExplorerFontStyles)
eval font create ExplorerFontItalic -family [list \
     $GUI_Options(ExplorerFontItalic)] -size \
     $GUI_Options(ExplorerFontItalicSize) $GUI_Options(ExplorerFontItalicStyles)
eval font create ExplorerLargeFont -family [list \
     $GUI_Options(ExplorerLargeFont)] -size $GUI_Options(ExplorerLargeFontSize)\
     $GUI_Options(ExplorerLargeFontStyles)
eval font create ListBoxFont -family [list $GUI_Options(ListBoxFont)] -size \
     $GUI_Options(ListBoxFontSize) $GUI_Options(ListBoxFontStyles)

## General Widget Section
option add *highlightBackground $GUI_Options(Background)
bind all <F1> ::HtmlInfoViewer::InfoViewer

## Under Windows XP activate some styled widgets...
if {[string equal "windows" $tcl_platform(platform)] && \
    $::tcl_platform(osVersion) >= 5.1} {
  option add *Button.StyleXp      1
  option add *Toolbar*StyleXp     0
 #option add *Button.Width      -11
  option add *Entry.StyleXp       1
  option add *Spinbox.StyleXp     1
  option add *Checkbutton.StyleXp 1
  option add *Radiobutton.StyleXp 1
}

## (BWidget) ArrowButton Widget Section
option add *ArrowButton*borderWidth $GUI_Options(BorderWidth)
option add *ArrowButton*Foreground  $GUI_Options(InputForeground)
option add *ArrowButton*Background  $GUI_Options(InputBackground)
option add *ArrowButton*selectForeground $GUI_Options(SelectForeground)
option add *ArrowButton*selectBackground $GUI_Options(SelectBackground)
option add *ArrowButton*highlightBackground $GUI_Options(InputBackground)
option add *ArrowButton*entryBackground     $GUI_Options(InputBackground)

## Button Widget Section
option add *Button.borderWidth $GUI_Options(BorderWidth)

## Canvas Widget Section
option add *Canvas.font ExplorerFont
option add *Canvas.borderWidth $GUI_Options(ExplorerBorderWidth)
#bind Canvas <<MB_2>> {GUI_CanvasSensitivePopup %W}
#option add *Canvas.Foreground $GUI_Options(InputForeground)
#option add *Canvas.Background $GUI_Options(InputBackground)
#bind Canvas <ButtonPress> {focus %W}
## Support for Wheel Mouse (not only under windows :-))
bind Canvas <MouseWheel> {
  %W yview scroll [expr {- (%D / 120) * 4}] units
}
if {[string equal "unix" $tcl_platform(platform)]} {
  # Support for mousewheels on Linux/Unix commonly comes through mapping
  # the wheel to the extended buttons.  If you have a mousewheel, find
  # Linux configuration info at:
  #    http://www.inria.fr/koala/colas/mouse-wheel-scroll/
  bind Canvas <4> {
    if {!$tk_strictMotif} {
      %W yview scroll -5 units
    }
  }
  bind Canvas <5> {
    if {!$tk_strictMotif} {
      %W yview scroll 5 units
    }
  }
}

## CheckButton Widget Section
option add *Checkbutton.borderWidth $GUI_Options(BorderWidth)

## (BWidget) ComboBox Widget Section
option add *ComboBox*borderWidth $GUI_Options(BorderWidth)
option add *ComboBox*Foreground  $GUI_Options(InputForeground)
option add *ComboBox*Background  $GUI_Options(InputBackground)
option add *ComboBox*selectForeground $GUI_Options(SelectForeground)
option add *ComboBox*selectBackground $GUI_Options(SelectBackground)
option add *ComboBox*highlightBackground $GUI_Options(InputBackground)
option add *ComboBox*entryBackground     $GUI_Options(InputBackground)

## Entry Widget Section
option add *Entry.borderWidth $GUI_Options(BorderWidth)
option add *Entry.Foreground  $GUI_Options(InputForeground)
option add *Entry.Background  $GUI_Options(InputBackground)
option add *Entry.selectForeground $GUI_Options(SelectForeground)
option add *Entry.selectBackground $GUI_Options(SelectBackground)
bind Entry <<MB_2>> {GUI_EntrySensitivePopup %W}
bind TEntry <<MB_2>> {GUI_EntrySensitivePopup %W}

## Frame Widget Section
option add *Frame.borderWidth 0
option add *Frame.relief flat
option add *Frame.highlightThickness 0

## HTML Widget Section
option add *Html.fontFamily arial
option add *Html.Foreground       $GUI_Options(HtmlFg) 
option add *Html.Background       $GUI_Options(HtmlBg)
option add *Html.selectForeground $GUI_Options(SelectForeground)
option add *Html.selectBackground $GUI_Options(SelectBackground)
bind Html <Key-Next>          {%W yview scroll  1 pages}
bind Html <Key-Down>          {%W yview scroll  1 units}
bind Html <Key-Prior>         {%W yview scroll -1 pages}
bind Html <Key-Up>            {%W yview scroll -1 units}
bind Html <Key-Right>         {%W xview scroll  1 units}
bind Html <Key-Left>          {%W xview scroll -1 units}
bind Html <Key-Home>          {%W yview moveto 0.0}
bind Html <Key-End>           {%W yview moveto 1.0}
bind Html <MouseWheel>        {%W yview scroll [expr {-(%D/120)*4}] units}
bind Html <Control-slash>     {%W selection set 1.0 end}
bind Html <Control-backslash> {%W selection clear}
bind Html <ButtonPress>       {focus %W}
bind Html <Control-Key-f>     {::GUI_TextSearchFacilities::HtmlFindDialog %W}
## Support for Wheel Mouse (not only under windows :-))
bind HtmlClip <MouseWheel> {
  %W yview scroll [expr {- (%D / 120) * 4}] units
}
if {[string equal "unix" $tcl_platform(platform)]} {
  # Support for mousewheels on Linux/Unix commonly comes through mapping
  # the wheel to the extended buttons.  If you have a mousewheel, find
  # Linux configuration info at:
  #    http://www.inria.fr/koala/colas/mouse-wheel-scroll/
  bind HtmlClip <4> {
    if {!$tk_strictMotif} {
      %W yview scroll -5 units
    }
  }
  bind HtmlClip <5> {
    if {!$tk_strictMotif} {
      %W yview scroll 5 units
    }
  }
}

## Label Widget Section
option add *Label.borderWidth $GUI_Options(BorderWidth)
option add *Label.highlightThickness 0

## Listbox Widget Section
option add *Listbox.borderWidth $GUI_Options(BorderWidth)
option add *Listbox.Foreground  $GUI_Options(InputForeground)
option add *Listbox.Background  $GUI_Options(InputBackground)
option add *Listbox.relief      $GUI_Options(TextRelief)
option add *Listbox.selectForeground $GUI_Options(SelectForeground)
option add *Listbox.selectBackground $GUI_Options(SelectBackground)
option add *Listbox.font ListBoxFont
bind Listbox <<MB_2>> {GUI_ListBoxSensitivePopup %W}
bind Listbox <Control-a> {event generate %W <Control-slash>}

## Menu Widget Section
option add *Menu.relief $GUI_Options(MenuRelief)
option add *Menu.borderWidth $GUI_Options(MenuReliefBorderWidth)
option add *Menu.activeForeground $GUI_Options(MenuSelectFg)
option add *Menu.activeBackground $GUI_Options(MenuSelectBg)
option add *Menu.activeBorderWidth $GUI_Options(MenuReliefBorderWidth)
option add *Menu.TearOff $GUI_Options(MenuTearOff)

## MenuButton Widget Section
option add *Menubutton.borderWidth $GUI_Options(BorderWidth)

## (BWidget) NoteBook Widget Section
#bind NoteBook <<MB_2>> {GUI_NoteBookSensitivePopup %W}

## RadioButton Widget Section
option add *Radiobutton.borderWidth $GUI_Options(BorderWidth) 

## ScrollBar Widget Section
option add *Scrollbar.borderWidth $GUI_Options(BorderWidth)
if {[string length $GUI_Options(ScrollBarWidth)]} {
  option add *Scrollbar.width    $GUI_Options(ScrollBarWidth)
}

## Scale Widget Section
option add *Scale.borderWidth  $GUI_Options(BorderWidth)

## Spinbox Widget Section
option add *Spinbox.borderWidth $GUI_Options(BorderWidth)
option add *Spinbox.Foreground  $GUI_Options(InputForeground)
option add *Spinbox.Background  $GUI_Options(InputBackground)
option add *Spinbox.selectForeground $GUI_Options(SelectForeground)
option add *Spinbox.selectBackground $GUI_Options(SelectBackground)

## Tablelist Widget Section
option add *Tablelist.labelCommand tablelist::sortByColumn
option add *Tablelist.setFocus     1
option add *Tablelist.borderWidth  $GUI_Options(BorderWidth)
option add *Tablelist.Foreground   $GUI_Options(InputForeground)
option add *Tablelist.Background   $GUI_Options(InputBackground)
option add *Tablelist.relief       $GUI_Options(TextRelief)
option add *Tablelist.selectForeground $GUI_Options(SelectForeground)
option add *Tablelist.selectBackground $GUI_Options(SelectBackground)
option add *Tablelist.font        ListBoxFont
bind Tablelist <<MB_2>> {GUI_ListBoxSensitivePopup %W}
bind Tablelist <Control-a> {event generate %W <Control-slash>}

## Text Widget Section
option add *Text.borderWidth   $GUI_Options(TextBorderWidth)
option add *Text.relief        $GUI_Options(TextRelief)
option add *Text.font          TextFont
option add *Text.width         $GUI_Options(TextWidth)
option add *Text.height        $GUI_Options(TextHeight)
option add *Text.Foreground    $GUI_Options(TextFg) 
option add *Text.Background    $GUI_Options(TextBg) 
option add *Text.selectForeground    $GUI_Options(SelectForeground)
option add *Text.selectBackground    $GUI_Options(SelectBackground)
option add *Text.wrap          word
option add *Text.setGrid       true
bind Text <Control-Key-f> {::GUI_TextSearchFacilities::TextFindDialog %W}
bind Text <<MB_2>> {GUI_TextSensitivePopup %W}

## TkTable Widget Section
bind Table <MouseWheel> {
  %W yview scroll [expr {- (%D / 120) * 4}] units
}
bind Table <4> {%W yview scroll -5 units}
bind Table <5> {%W yview scroll  5 units}

## (BWidget) TitleFrame Widget Section
option add *TitleFrame.background     $GUI_Options(Background)

## Progress Widget Section
option add *Progress.undoneForeground black                        
option add *Progress.undoneBackground white                        
option add *Progress.doneForeground   $GUI_Options(SelectForeground) 
option add *Progress.doneBackground   $GUI_Options(SelectBackground) 
option add *Progress.borderWidth      0
option add *Progress.relief           flat                       

## Virtual Events
event add <<Motion_1>>     <Button1-Motion>
event add <<Release_1>>    <Button1-ButtonRelease>
event add <<CMotion_1>>    <Control-Button1-Motion>
event add <<CRelease_1>>   <Control-ButtonRelease-1>
event add <<Press_1>>      <Button1-ButtonPress-1>
event add <<Motion_1>>     <Button1-Motion>
event add <<Release_1>>    <Button1-ButtonRelease-1>
event add <<MB_1>>         <ButtonPress-1>
event add <<DMB_1>>        <Double-ButtonPress-1>
event add <<MBR_1>>        <ButtonRelease-1>
event add <<MB_2>>         <ButtonRelease-3>
event add <<MB_M>>         <ButtonRelease-2>
