## This file describe all User Defined Options of this application.
## Modify with care...
global GUI_Options PANE ApplicationInfo
if {$ApplicationInfo(TkPresent)} {
  text .t
  array set GUI_Options [list\
    Background       [.  cget -background]\
    SelectBackground [.t cget -selectbackground]\
    SelectForeground [.t cget -selectforeground]]
  destroy .t
  ## Under OS X, SelectForeground can be empty...
  if {$GUI_Options(SelectForeground) eq ""} {
    set GUI_Options(SelectForeground) white
  }
} else {
  array set GUI_Options {
    Background white SelectBackground black SelectForeground white}
}

array set GUI_Options {BorderWidth 1 ProgressStep 5
  FullGateCompatibility 0 EmulateGateGetValue 1 FancyStartup 0
  ExitDefaultNo 1 EnableJava 0 JavaLinkStreams 0 JavaRunTimePath {}
  EnablePerl 0 EnablePython 0 DragEnterBackgound #8fbc8f
  GUI_Theme Crystal_SVG TooltipForeground black TooltipBackground #ffffaa
  EnableExecutionServer 1 OpenStartupConsole 0
  NewCollectionFileSearchPathRecursively 0 NewCollectionAutodetectEncoding 0
}

# if {$::tcl_platform(os) == "Darwin"} {
#   set GUI_Options(GUI_Theme) DefaultNoAlphaChannel
# }

## Pane Options...
array set PANE [list BorderWidth $GUI_Options(BorderWidth) \
  Relief raised Color $GUI_Options(Background)]

## The following two options are for "input" widgets, like text, entry,
## listbox, etc.
switch $tcl_platform(platform) {
  windows {
    array set GUI_Options [list InputForeground SystemWindowText \
    InputBackground SystemWindow SystemFont Arial SystemFontFixed {Courier New}\
    LargeFontSize 14 NormalFontSize 10 SmallFontSize 8\
    Editor notepad.exe]
  }
  unix -
  default {
    array set GUI_Options [list InputForeground black InputBackground #cccccc \
    SystemFont helvetica SystemFontFixed courier \
    LargeFontSize 16 NormalFontSize 12 SmallFontSize 10 \
    Editor gvim]
  }
}

## Font Stuff
array set GUI_Options [list \
  TextFont                 $GUI_Options(SystemFont)\
  TextFontSize             $GUI_Options(NormalFontSize)\
  TextFontStyles           {}\
  FixedTextFont            $GUI_Options(SystemFontFixed)\
  FixedTextFontSize        $GUI_Options(NormalFontSize)\
  FixedTextFontStyles      {}\
  ModuleTextFont           $GUI_Options(SystemFont)\
  ModuleTextFontSize       $GUI_Options(NormalFontSize)\
  ModuleTextFontStyles     {-weight bold}\
  ExplorerFont             $GUI_Options(SystemFont)\
  ExplorerFontSize         $GUI_Options(SmallFontSize)\
  ExplorerFontStyles       {}\
  ExplorerFontItalic       $GUI_Options(SystemFont)\
  ExplorerFontItalicSize   $GUI_Options(SmallFontSize)\
  ExplorerFontItalicStyles {-slant italic}\
  ExplorerLargeFont        $GUI_Options(SystemFont)\
  ExplorerLargeFontSize    $GUI_Options(SmallFontSize)\
  ExplorerLargeFontStyles  {}\
  ListBoxFont              $GUI_Options(SystemFont)\
  ListBoxFontSize          $GUI_Options(NormalFontSize)\
  ListBoxFontStyles        {}\
  HTMLVariableFont         helvetica\
  HTMLFixedFont            courier\
  HTMLFontSize1  5 HTMLFontSize2  6 HTMLFontSize3  7 HTMLFontSize4 9\
  HTMLFontSize5 10 HTMLFontSize6 11 HTMLFontSize7 12\
  HTMLUseDefaultFonts 1
]
  
## General Preferences
array set GUI_Options [list MenuRelief raised MenuImageLocation left \
  MenuReliefBorderWidth $GUI_Options(BorderWidth) \
  MenuSelectBg $GUI_Options(SelectBackground) \
  MenuSelectFg $GUI_Options(SelectForeground) MenuTearOff 0]
switch $tcl_platform(platform) {
  windows {array set GUI_Options [list ToolbarFrameRelief flat \
                ToolbarFrameReliefBorderWidth 0 ToolbarRelief groove \
                ToolbarReliefBorderWidth 0 ToolbarHandleRelief flat \
                ToolbarHandleReliefBorderWidth 1 ToolbarDecorate 1 \
                ToolbarImageHandle 0 \
                ToolbarBackground $GUI_Options(Background) \
                ToolbarHandleBackground $GUI_Options(Background)]}
  default {array set GUI_Options [list ToolbarFrameRelief raised \
                ToolbarFrameReliefBorderWidth 1 ToolbarRelief flat \
                ToolbarReliefBorderWidth 0 ToolbarHandleRelief raised \
                ToolbarHandleReliefBorderWidth 1 ToolbarDecorate 0 \
                ToolbarImageHandle 0 \
                ToolbarBackground $GUI_Options(Background) \
                ToolbarHandleBackground $GUI_Options(Background)]}
}

## ScrollBar Objects
if {[string equal $tcl_platform(platform) windows]} {
  set GUI_Options(ScrollBarWidth) {}
} else {
  set GUI_Options(ScrollBarWidth) 12
}

## Text Objects
array set GUI_Options [list TextBg $GUI_Options(InputBackground) \
  TextFg $GUI_Options(InputForeground) HtmlBg $GUI_Options(InputBackground) \
  HtmlFg $GUI_Options(InputForeground) TextRelief ridge \
  TextWidth 65 TextHeight 18 TextBorderWidth $GUI_Options(BorderWidth)]

## Canvas Objects

## System Options
array set GUI_Options [list SystemBg $GUI_Options(Background) SystemFg navy\
  SystemRelief flat SystemBorderWidth 2 SystemPadX 20 SystemPadY 20\
  SystemExprToolbarCollectionWidth 20\
  SystemExprToolbarDocumentWidth   20\
  SystemScrollbarBorderWidth $GUI_Options(BorderWidth)]

## System Window's Arc Options
array set GUI_Options {ArcColor blue ArcActiveColor #1e90ff ArcWidth 1
  ArcActiveWidth 6 ArcSmooth 1}

## Module Options
array set GUI_Options [list ModuleShape rectangle ModuleEnabled lightgray \
  ModuleActive #aea2a4 ModuleRun red ModuleInactive orange \
  ModuleTextActive white ModuleTextEnabled green ModuleTextRun white \
  ModuleTextInactive yellow ModuleTextPadX 0 ModuleTextPadY 0 \
  ModuleImagePadX -24 ModuleImagePadY -18 ModuleImageInactive {} \
  ModuleImageEnabled  \
    "$HomeDir/share/Themes/$GUI_Options(GUI_Theme)/IModuleEnabled.gif" \
  ModuleImageActive   \
    "$HomeDir/share/Themes/$GUI_Options(GUI_Theme)/IModuleActive.gif" \
  ModuleImageRun      \
    "$HomeDir/share/Themes/$GUI_Options(GUI_Theme)/IModuleRun.gif" \
  ModuleImageInactive \
    "$HomeDir/share/Themes/$GUI_Options(GUI_Theme)/IModuleInactive.gif" \
  ModuleBorderColor {} ModuleBorderWidth 1 \
  ModuleBorderColorSelected $GUI_Options(SelectBackground) \
  ModuleBorderWidthSelected 2 ModuleWidth 75 ModuleHeight 60 \
  ModuleTextJustify center ModuleTextAnchor center ModuleImageAnchor center]
array set GUI_Options [list ModuleTextWidth $GUI_Options(ModuleWidth) \
  ModuleTextFg $GUI_Options(ModuleTextInactive)]

## Explorer Options
array set GUI_Options [list ExplorerFg $GUI_Options(InputForeground) \
  ExplorerActiveFg #1e90ff \
  ExplorerBg $GUI_Options(InputBackground) \
  ExplorerStandout navy ExplorerStandoutBg $GUI_Options(Background) \
  ExplorerRelief flat ExplorerBorderWidth 0 ExplorerPadX 6 ExplorerPadY 4 \
  ExplorerHilightFg $GUI_Options(SelectForeground) \
  ExplorerHilightBg $GUI_Options(SelectBackground)]
array set GUI_Options [list \
  ExplorerLineFg gray50 ExplorerLineBg $GUI_Options(ExplorerBg) \
  ExplorerVPadX 45 ExplorerVPadY 30 ExplorerColPadX 55 ExplorerColPadY 30 \
  ExplorerTreeWidth 200 ExplorerTreeHeigth 300 ExplorerViewWidth 400 \
  ExplorerViewHeigth 300 ExplorerShowTipsDlg 0 ExplorerPaneWidth 8 \
  ExplorerPaneRedrawWhileDragging 1 MainWindowPanePercent 35 \
  CollectionWindowPanePercent 40 OverImageGamma 2.0]

## Agent Options
array set GUI_Options [list \
  AgentID {} AgentFile [file join $HomeDir TclAgent Agents Merlin.acs] \
  AgentVisible 0 AgentUse 0]

## Collection/Document Options
array set GUI_Options [list EnableGateCollectionManagement 0 \
  EnableXMLCollectionManagement 0]

## Encodings
set GUI_Options(Encodings) {
{- {ISO Encodings}}
  {iso8859-1  {West European (Latin 1)}}
  {iso8859-2  {East European (Latin 2)}}
  {iso8859-3  {South European (Latin 3)}}
  {iso8859-4  {North European (Latin 4)}}
  {iso8859-5  Cyrillic}
  {iso8859-6  Arabic}
  {iso8859-7  Greek}
  {iso8859-8  Hebrew}
  {iso8859-9  {Turkish (Latin 5)}}
  {iso8859-10 {Nordic (Latin 6)}}
  {iso8859-13 {North European}}
  {iso8859-14 {}}
  {iso8859-15 {West European}}
  {iso8859-16 {}}
  {iso2022-jp Japanese}
  {iso2022-kr Korean}
  {iso2022    {}}
{- {Windows Encodings}}
  {cp1250 {Windows Central European}}
  {cp1251 {Windows Cyrillic}}
  {cp1252 {Windows West European}}
  {cp1253 {Windows Greek}}
  {cp1254 {Windows Turkish}}
  {cp1255 {Windows Hebrew}}
  {cp1256 {Windows Arabic}}
  {cp1257 {Windows North European}}
  {cp1258 {Windows Vietnamise}}
{- {Dos Encodings}}
  {cp437  {Dos Greek}}
  {cp737  {Dos Greek}}
  {cp775  {Dos BaltRim}}
  {cp850  {Dos Latin-1}}
  {cp852  {Dos Latin-2}}
  {cp855  {Dos Cyrillic}}
  {cp857  {Dos Turkish}}
  {cp860  {Dos Portuguese}}
  {cp861  {Dos Icelandic}}
  {cp862  {Dos Hebrew}}
{- -}
  {cp863  {Dos CanadaF}}
  {cp864  {Dos Arabic}}
  {cp865  {Dos Nordic}}
  {cp866  {Dos Cyrillic Russian}}
  {cp869  {Dos Greek 2}}
  {cp874  {}}
  {cp932  {}}
  {cp936  {}}
  {cp949  {}}
  {cp950  {}}
{- {Macintosh Encodings}}
  {macCentEuro {Mac Central European}}
  {macCroatian {Mac Croatian}}
  {macCyrillic {Mac Cyrillic}}
  {macDingbats {Mac Dingbats}}
  {macGreek    {Mac Greek}}
  {macIceland  {Mac Icelandic}}
  {macJapan    {Mac Japanese}}
  {macRoman    {Mac Roman}}
  {macRomania  {Mac Romanian}}
  {macThai     {Mac Thai}}
  {macTurkish  {Mac Turkish}}
  {macUkraine  {Mac Ukraine}}
{- {Other Encodings}}
  {ascii    ASCII}
  {big5     {Traditional Chinese}}
  {dingbats {ITC Dingbats}}
  {ebcdic   {}}
  {euc-cn   {}}
  {euc-jp   Japanese}
  {euc-kr   Korean}
  {gb12345  {GB12345-80}}
  {gb1988   {}}
  {gb2312   {Simplified Chinese}}
  {jis0201  {JIS X 0201 (1976)}}
  {jis0208  {JIS X 0208 (1990)}}
  {jis0212  {JIS X 0212 (1990)}}
{- -}
  {koi8-r   Cyrillic}
  {koi8-u   Cyrillic}
  {ksc5601  {KS C 5601-1987}}
  {shiftjis Japanese}
  {symbol   Symbol}
  {tis-620  Thai}
  {ucs-2be  {}}
  {unicode  Unicode}
  {utf-8    UTF-8}
  {binary   {Binary Data}}
}
