/***************************************************************************
*
* %%ModuleName%%.cpp - %%Date%%
* This is a dynamic/tight coupled (C/C++) Component for use with 
* %%Program%%, version %%Version%%...
*
***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "CDM.h"
/* If you want to use the object oriented interface, uncomment the following
   include definition: */
/* #include "OCDM.h" */
   

/* Prototype Definitions */
extern "C" CDM_EXPORT int Creole_%%ModuleNameLowerCase%%_Init(
                                 Tcl_Interp *interp);
extern "C" CDM_EXPORT int Creole_%%ModuleNameLowerCase%%_SafeInit(
                                 Tcl_Interp *interp);
extern "C" CDM_EXPORT int Creole_%%ModuleNameLowerCase%%_Unload(
                                 Tcl_Interp *interp, int flags);
extern "C" CDM_EXPORT int Creole_%%ModuleNameLowerCase%%_SafeUnload(
                                 Tcl_Interp *interp, int flags);
int creole_%%ModuleName%%(
      ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *objv[]);
int creole_%%ModuleName%%_Initialize(
      ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *objv[]);
int creole_%%ModuleName%%_Finish(
      ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *objv[]);

CDM_BEGIN_GLOBAL_VARIABLE_BLOCK(%%ModuleName%%)
/* 
 * Component's Home Path: Its value will be updated when the component will be
 * loaded... 
 */
char *creole_%%ModuleName%%_home;
/* 
 * Add any other variables needed to be accessed globally. In order to access
 * these variables, call CDM_ACCESS_GLOBAL_DATA(%%ModuleName%%) at the top of
 * the function that needs to access the variable, and then call
 * CDM_GLOBAL(<variable name>) to access it.
 */
CDM_END_GLOBAL_VARIABLE_BLOCK(%%ModuleName%%)
/*
 * Make global variables available everywhere, without using
 * CDM_GLOBAL(<variable name>)...
 */
#define creole_%%ModuleName%%_home (tsdPtr->creole_%%ModuleName%%_home)

/* Function: creole_%%ModuleName%% */
int creole_%%ModuleName%%(
      ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *objv[]) {
#ifdef OCDM_PRESENT
  OCDM_Document Doc;
#else  /* OCDM_PRESENT */
  CDM_Document Doc;
#endif /* OCDM_PRESENT */
  /* CDM_ACCESS_GLOBAL_DATA(%%ModuleName%%); */
  
  CDM_SetActiveInterpreter(interp); /* Do not remove this command... */
  /*
   * %%Program%% Components require at least one argument. If more are
   * required by the component, please update the following three lines of
   * code accordingly...
   */
  if (objc < 2) {
    Tcl_WrongNumArgs(interp, 1, objv, "Document ?args?");
    return TCL_ERROR;
  }
  /* Retrieve the Document from the first argument... */
#ifdef OCDM_PRESENT
  try {
    Doc = OCDM_Document(objv[1]);
  } catch (OCDM_Exception e) {
    return CDM_ReportError("creole_%%ModuleName%%: "
                           "Invalid Document Pointer");
  }
  Doc.SetProcessStatus(0);
#else  /* OCDM_PRESENT */
  Doc = CDM_GetDocumentPointer(objv[1]);
  if (Doc == NULL) 
    return CDM_ReportError("creole_%%ModuleName%%: "
                           "Invalid Document Pointer");
  CDM_SetProcessStatus(Doc, 0);
#endif /* OCDM_PRESENT */

  /* try { */

  /* Put your code here... */
  
  /* } catch (OCDM_Exception e) {
       return CDM_ReportError(e.what());
     } */

  /* Report Succesful Completion */
#ifdef OCDM_PRESENT
  Doc.SetProcessStatus(100);
  Doc.PutAttribute(OCDM_Attribute("%%ModuleName%%",
                        OCDM_AttributeValue(CDM_STRING, "")));
#else  /* OCDM_PRESENT */
  CDM_SetProcessStatus(Doc, 100);
  CDM_PutAttribute(Doc, CDM_CreateAttribute("%%ModuleName%%",
                        CDM_CreateAttributeValue(CDM_STRING, "")));
#endif /* OCDM_PRESENT */
  return TCL_OK;
error:
  return TCL_ERROR;
} /* creole_%%ModuleName%% */


/* Function: creole_%%ModuleName%%_Initialize
    Use this function in order to do some initialisation. This function will
    be called just before creole_%%ModuleName%% in the following situations:
     *) If the user has opened a whole Collection, this function will be 
        called just before the first document in Collection gets proccessed 
        with creole_%%ModuleName%%
     *) If the user has opened a single Document, this function will be called
        just before calling creole_%%ModuleName%%
    Please, refer to the %%Program%%'s Programming Manual for more 
    information on this function... */
int creole_%%ModuleName%%_Initialize(
      ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *objv[]) {
  /* CDM_ACCESS_GLOBAL_DATA(%%ModuleName%%); */
  /*
  if (objc < 3) {
    Tcl_WrongNumArgs(interp, 1, objv, "Collection Document ?args?");
    return TCL_ERROR;
  }
  CDM_Collection Col = CDM_GetCollectionPointer(objv[1]);
  CDM_Document   Doc = CDM_GetDocumentPointer(objv[2]);
  if (Col == NULL) 
    return CDM_ReportError("creole_%%ModuleName%%: "
                           "Invalid Collection Pointer");
  if (Doc == NULL) 
    return CDM_ReportError("creole_%%ModuleName%%: "
                           "Invalid Document Pointer");
  */

  /* Do some initilization here... */
  
  return TCL_OK;
} /* creole_%%ModuleName%%_Initialize */


/*  Function: creole_%%ModuleName%%_Finish
    Use this function in order to do some Clean-Up. This function will
    be called after all calls to creole_%%ModuleName%% in the following 
    situations:
     *) If the user has opened a whole Collection, this function will be 
        called just after the last document in Collection gets proccessed with 
        creole_%%ModuleName%%
     *) If the user has opened a single Document, this function will be called
        just after calling creole_%%ModuleName%%
    Please, refer to the %%Program%%'s Programming Manual for more 
    information on this function... */
int creole_%%ModuleName%%_Finish(
      ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *objv[]) {
  /* CDM_ACCESS_GLOBAL_DATA(%%ModuleName%%); */
  /*
  if (objc < 3) {
    Tcl_WrongNumArgs(interp, 1, objv, "Collection Document ?args?");
    return TCL_ERROR;
  }
  CDM_Collection Col = CDM_GetCollectionPointer(objv[1]);
  CDM_Document   Doc = CDM_GetDocumentPointer(objv[2]);
  if (Col == NULL) 
    return CDM_ReportError("creole_%%ModuleName%%: "
                           "Invalid Collection Pointer");
  if (Doc == NULL) 
    return CDM_ReportError("creole_%%ModuleName%%: "
                           "Invalid Document Pointer");
  */
  
  /* Clean-Up... */
  
  return TCL_OK;
} /* creole_%%ModuleName%%_Finish */


/**********************************************************************
 **               -->>   Ignore the Following Code   <<--              
 **  The following C++ code takes care the interfaces to the %%Program%%
 **  platform. Please modify with care...
 **********************************************************************/

/* 
 * This command registers the Component commands with the tcl interpreter in
 * which the Component is loaded. Please modify with care...
 */
int Creole_%%ModuleNameLowerCase%%_Init(Tcl_Interp *interp) {
  /*
   * Use the stubs mechanism so as not to depend on the specific Tcl version.
   * Doing so will enable the binaries compiled under one system to run on
   * other systems, even if a different version of Tcl is installed.
   * Note that we pose a limit of the lowest version that can be used.
   * In order to run, we require a Tcl version >= 8.4...
   */
#if defined(USE_TCL_STUBS) || defined(CDM_USE_STUBS)
  if (Tcl_InitStubs(interp, "8.4", 0) == NULL) {
    return TCL_ERROR;
  }
#endif /* USE_TCL_STUBS || CDM_USE_STUBS */

  /* Enable access to the global variables of this component... */
  CDM_ACCESS_GLOBAL_DATA(%%ModuleName%%);
  /* Initialise global variables... */
  creole_%%ModuleName%%_home = NULL;

  /*
   * Link our location var with the Tcl interpreter.
   * The correct value will be set by Tcl, when the module is actually
   * loaded...
   */
  CDM_LinkVar(interp, "creole_%%ModuleName%%_home",
                      &creole_%%ModuleName%%_home);

  /* 
   * Register the Module Main Command 
   */
  if (Tcl_CreateObjCommand(interp, "creole_%%ModuleName%%", 
          (Tcl_ObjCmdProc*) creole_%%ModuleName%%,
          (ClientData) NULL,
          (Tcl_CmdDeleteProc *) NULL)  == NULL ) return TCL_ERROR;

  if (Tcl_CreateObjCommand(interp, "creole_%%ModuleName%%_Initialize", 
          (Tcl_ObjCmdProc*) creole_%%ModuleName%%_Initialize,
          (ClientData) NULL,
          (Tcl_CmdDeleteProc *) NULL)  == NULL ) return TCL_ERROR;

  if (Tcl_CreateObjCommand(interp, "creole_%%ModuleName%%_Finish", 
          (Tcl_ObjCmdProc*) creole_%%ModuleName%%_Finish,
          (ClientData) NULL,
          (Tcl_CmdDeleteProc *) NULL)  == NULL ) return TCL_ERROR;

  /*
   * Report Loading Success...
   */
  return TCL_OK;
} /* Creole_%%ModuleNameLowerCase%%_Init */

int Creole_%%ModuleNameLowerCase%%_SafeInit(Tcl_Interp *interp) {
  return Creole_%%ModuleNameLowerCase%%_Init(interp);
} /* Creole_%%ModuleNameLowerCase%%_SafeInit */

/* 
 * This command unloads a Component. Its job is to reverse the effect
 * of Creole_%%ModuleNameLowerCase%%_Init, by unregistering the registered
 * commands. Please modify with care...
 */
int Creole_%%ModuleNameLowerCase%%_Unload(Tcl_Interp *interp, int flags) {
  int code;
  /*
   * Unlink any associated variables...
   */
  CDM_UnlinkVar(interp, "creole_%%ModuleName%%_home");

  /* 
   * Unregister the Component's registered commands... 
   */
  code = Tcl_DeleteCommand(interp, "creole_%%ModuleName%%");
  if (code != TCL_OK) return code;
  code = Tcl_DeleteCommand(interp, "creole_%%ModuleName%%_Initialize");
  if (code != TCL_OK) return code;
  code = Tcl_DeleteCommand(interp, "creole_%%ModuleName%%_Finish");
  if (code != TCL_OK) return code;
  return TCL_OK;
} /* Creole_%%ModuleNameLowerCase%%_Init */

int Creole_%%ModuleNameLowerCase%%_SafeUnload(Tcl_Interp *interp, int flags) {
  return Creole_%%ModuleNameLowerCase%%_Unload(interp, flags);
} /* Creole_%%ModuleNameLowerCase%%_SafeUnload */

/* 
 * End of %%ModuleName%%.cpp
 */
