##############################################################################
## ------------------------------------------------------------------------ ##
##  Automatically generated by the @AppName@ Text Engineering Platform.     ##
##  Modify with care.                                                       ##
## ------------------------------------------------------------------------ ##
##  This file implements a Graphical Script based on the @AppName@          ##
##  technology.                                                             ##
##                                                                          ##
##  @AppName@ is Copyrighted 1998-2004 by:                                  ##
##  Software and Knowledge Engineering Laboratory,                          ##
##  Institute of Informatics and Telecommunications,                        ##
##  N.C.S.R. "Demokritos"                                                   ##
##  Athens, Greece.                                                         ##
##  URL: www.iit.demokritos.gr/~petasis/@AppName@                           ##
##                                                                          ##
##############################################################################

##
## This is a Script Application, based on @AppName@ technology.
## As a result, an @AppName@ installation will be required in order to
## execute this script.
## In order to execute this Script Application, either:
##  1) Source this file from inside an @AppName@ Console, using the "source" Tcl
##     command.
##  2) Invoke @AppName@ in batch mode, with a graphical interface (but without
##     displaying the Main Window) to execute this script:
##       
##     wish <path_to_@AppName@>/ellogon -gui 1 -showMainWindow 0 \
##               -script <this_file> ?-args <arguments>? \
##              ?-script <another_script> ?-args <argument> ...? ?
##
##
namespace eval ::GUI_MainWindow {}
set Locale English
set KeyboardLocale [encoding system]

##############################################################################
##
##  Parameters specified through the @AppName@ Wizard...
##
##############################################################################

##
## The name of the Application.
##
set ApplicationName      @ApplicationName@
set ApplicationVersion   1.0
set ApplicationVersionId 0

##
## The list of Components to execute...
##
set Components @Components@

##
## Under a Graphical Application, the user must specify either a directory
## containing the files (as well as their extension), or some file(s) directly.
##
## FileSelectionMode: one of "directory", "files"
set ::GUI_MainWindow::FileSelectionMode @FileSelectionMode@

##
## OutputSelectionMode: one of file, directory, none
##
set ::GUI_MainWindow::OutputSelectionMode @OutputSelectionMode@

##
## DirectorySelectionExtensions: a list containing the extensions to be
## considered when searcing a directory for files (i.e. "*.* *.htm*")
##
set ::GUI_MainWindow::DirectorySelectionExtensions @DirectorySelectionExtension@

##
## The encoding of the files (can be overwriiten by user, if
## EncodingSelectableByUser is true)...
##
set Encoding @Encoding@
## Let the user select the proper encoding for opening the files...
set ::GUI_MainWindow::EncodingSelectableByUser @EncodingSelectableByUser@

##
## Collection related parameters are located at the end of this file...
##

##
## Graphical User Interface specific parameters
##

##
## The title of the Application main window (window manager decoration)...
##
set ::GUI_MainWindow::Title @GUI_MainWindow::Title@

##
## The message, font, background & foreground colour of the title
##
set ::GUI_MainWindow::TitleText           @GUI_MainWindow::TitleText@
set ::GUI_MainWindow::TitleTextFont       @GUI_MainWindow::TitleTextFont@
set ::GUI_MainWindow::TitleTextBackground @GUI_MainWindow::TitleTextBackground@
set ::GUI_MainWindow::TitleTextForeground @GUI_MainWindow::TitleTextForeground@
## For the image data for the Title, look at the end of the file...

##
## The message to be displayed next to input file(s)/directory selection
set ::GUI_MainWindow::InputMessage        @GUI_MainWindow::InputMessage@
##
## The message to be displayed next to input file encoding selection
set ::GUI_MainWindow::EncodingMessage     @GUI_MainWindow::EncodingMessage@
##
## The message to be displayed next to outpu file/directory selection
set ::GUI_MainWindow::OutputMessage       @GUI_MainWindow::OutputMessage@
##
## The message prompting the user to execute the Application
set ::GUI_MainWindow::ExecMessage         @GUI_MainWindow::ExecMessage@
##
## The message prompting the user to exit the Application
set ::GUI_MainWindow::ExitMessage         @GUI_MainWindow::ExitMessage@

##
## Actually, this code-base is exactly the same as the GUI version. We simply
## provide the -gui 0 argument...
##
set args [linsert $args -gui 0]
incr argc 2

## The default Logging procedure...
proc Log {message} {
  ## If you don't want messages to be printed, comment the following lines...
  catch {puts $message;flush stdout}
  catch {
    set file [open $::GUI_MainWindow::ProcessingLog a]
    puts $file $message; close $file
  }
};# Log

## The default Error Logging procedure...
proc ErrorLog {message} {
  ## If you don't want messages to be printed, comment the following lines...
  catch {puts stderr "### Error: $message"
         puts stderr "@@@ Stack Trace: $::errorInfo"; flush stderr}
  catch {
    set file [open $::GUI_MainWindow::ProcessingLog a]
    puts $file "### Error: $message"
    puts $file "@@@ Stack Trace: $::errorInfo"
    close $file
  }
};# ErrorLog

##
## Do not modify below this point (unless you know what you are doing!)
##

## Display the main window of the Application.
proc DisplayMainWindow {{win .}} {
  @DisplayMainWindowProcBody@
};# DisplayMainWindow

## The procedure called to exit the Application
proc Exit {} {
  if {$::ApplicationInfo(EnableGUI)} {
    ## Save any available state...
    if {[info exists ::SavedState]} {
      set file [open $::UserAppDir/SavedState.tcl w]
      puts $file "array set ::SavedState \{[array get ::SavedState]\}"
      close $file
    }
    destroy .
  } else {
    exit
  }
};# Exit

## This procedure is called every time the user presses the "Execute" button
@ApplicationExecuteProcBody@

## Utility function for selecting a directory...
proc SelectDirectory {entry} {
  set folder [tk_chooseDirectory -parent .mw \
                                 -title {Please Select a Directory:}]
  if {![string length $folder]} {return}
  $entry delete 0 end
  $entry insert end $folder
};# SelectDirectory

## Utility function for selecting files...
proc SelectFiles {entry {save 0}} {
  foreach ext $::GUI_MainWindow::DirectorySelectionExtensions {
    lappend filetypes [list {Files} $ext]
  }
  lappend filetypes [list $::GUI_Text(All) *]
  if {$save} {
    GUI_SelectSaveFile $entry -parent .mw -filetypes $filetypes
  } else {
    GUI_SelectFile $entry -multiple 1 -parent .mw -filetypes $filetypes
  }
};# SelectFiles

## Modify some global options...
if {[info exists ::tk_version]} {
  ## We are running under Tk...
  package require Tk
  catch {package require Img}
  option add *highlightBorderWidth 0
  option add *borderWidth 1
}

##
## Data for the splash window...
##
set ::GUI_MainWindow::SplashImage \
 @GUI_MainWindow::SplashImage@

##
## The name of the Collection to be created during processing...
##
set CollectionName @CollectionName@
## Will the Collection be saved on disk during processing?
set SyncCollection @SyncCollection@
## Will the Collection be deleted after the processing has finished?
set DeleteCollection @DeleteCollection@

##
## A file, where the Processing Log will be stored...
set ::GUI_MainWindow::ProcessingLog $::UserAppDir/ProcessingLog.txt
catch {file delete -force -- $::GUI_MainWindow::ProcessingLog}

##
## The image data for the title
##
set ::GUI_MainWindow::TitleImage \
 @GUI_MainWindow::TitleImage@

##
## Restored last saved state, if available...
##
if {$::ApplicationInfo(EnableGUI) && [file exists $UserAppDir/SavedState.tcl]} {
  catch {
    source $UserAppDir/SavedState.tcl
    foreach variable [array names SavedState] {
      set $variable $SavedState($variable)
    }
  }
}

## GUI_FlashWidget
#  Change the colour of a widget, to draw users attention to a widget...
proc GUI_FlashWidget {widget} {
  if {!$::ApplicationInfo(EnableGUI)} {return}
  global SleepTimerVariable
  set SleepTimerVariable 0
  set colour [$widget cget -background]
  for {set i 0} {$i < 3} {incr i} {
    $widget configure -background #8fbc8f
    ## Wait half a second...
    after 300 {set SleepTimerVariable 1}
    vwait SleepTimerVariable
    $widget configure -background $colour
    ## Wait half a second...
    after 300 {set SleepTimerVariable 0}
    vwait SleepTimerVariable
  }
};# GUI_FlashWidget

## Source the User provided Handlers...
set UserHandlersFile \
    [file dirname [file normalize [info script]]]/UserHandlers.tcl
if {![file exists $UserHandlersFile]} {
  ## The User handlers file has not be found.
  gut_info "File \"$UserHandlersFile\" cannot be located!\
            \n\tPlease re-install the Application!"
  exit 2
}
source $UserHandlersFile

## Display the main window
if {$ApplicationInfo(EnableGUI)} {
  set win [ggi_unused_win .scriptmw]
  toplevel $win
  DisplayMainWindow $win.
  wm protocol $win WM_DELETE_WINDOW "Exit"
  unset win
} elseif {$ApplicationInfo(ServerMode)} {
  ## A request for server mode: Do nothing :-)
} else {
  ## Has the user provided all the needed info?
  if {![info exists ::UserInputPaths]} {
    switch $::GUI_MainWindow::FileSelectionMode {
      files {
        puts stderr "Error: No Input File(s) specified:"
        puts stderr "\tPlease use the \"-inputfile <path>\" one or more\
                       times\n\tto specify one or more input files."
        exit -1
      }
      directory {
        puts stderr "Error: No Input Directory specified:"
        puts stderr "\tPlease use the \"-inputdir <path>\" parameter\
                       \n\tto specify an output directory."
        exit -1
      }
      default {}
    }
  }
  if {![info exists ::UserOutputPaths]} {
    switch $::GUI_MainWindow::OutputSelectionMode {
      directory {
        puts stderr "Error: No Output Directory specified:"
        puts stderr "\tPlease use the \"-outputdir <path>\" parameter\
                       \n\tto specify an output directory."
        exit -1
      }
      file {
        puts stderr "Error: No Output File specified:"
        puts stderr "\tPlease use the \"-outputfile <path>\" parameter\
                       \n\tto specify an output file."
        exit -1
      }
      none {set ::UserOutputPaths {}}
    }
  }
  proc gut_info {msg args} {
    puts stderr "Error: $msg"
    Exit
  }
  Execute
  Exit
}
