#!/bin/sh
# The next line is executed by /bin/sh, but not tcl \
exec wish "$0" ${1+"$@"}

namespace eval ::ImportKDETheme {
  variable ImageNameMap
  ##############################################################################
  ##  Please Update at wish.
  ##
  ##  The following is a map between image names and KDE theme image names...
  ##############################################################################
  
  array set ImageNameMap {
    Add                            {}
    Any                            {}
    BackNice                       {}
    BackNice1                      {}
    DoubleArrowDown                {}
    DoubleArrowUp                  {}
    English                        {}
    Greek                          {}
    GreyDot                        {}
    HTMLTagAnchor                  {}
    HTMLTagBold                    {}
    HTMLTagBr                      {}
    HTMLTagCubes                   22x22/filesystems/blockdevice.png
    HTMLTagH1                      {}
    HTMLTagH2                      {}
    HTMLTagH3                      {}
    HTMLTagH4                      {}
    HTMLTagH5                      {}
    HTMLTagHr                      {}
    HTMLTagI                       {}
    HTMLTagLi                      {}
    HTMLTagMisc                    {}
    HTMLTagP                       {}
    HTMLTagTable                   22x22/actions/month.png
    HTMLTagTd                      22x22/actions/1day.png
    HTMLTagTr                      22x22/actions/7days.png
    HTMLTagU                       {}
    Hellenic                       {}
    IAddArrowGreen                 {}
    IAddArrowRed                   {}
    IAddDocuments                  {}
    IApplication                   48x48/apps/kservices.png
    IBack                          32x32/actions/back.png
    IBinaryFile                    48x48/mimetypes/binary.png
    IBook                          {}
    IBook2                         {}
    IBookOpen                      22x22/actions/contents.png
    ICancel48x48                   {}
    ICancelGray                    32x32/actions/fileclose.png
    ICollection                   {48x48/filesystems/folder2_open.png
                                   48x48/filesystems/folder.png}
    ICollectionGate               {48x48/filesystems/folder2_red_open.png
                                   48x48/filesystems/folder_red.png}
    ICollectionRegistered         {48x48/filesystems/folder_txt.png
                                   48x48/filesystems/folder_yellow.png}
    ICollectionXML                 48x48/filesystems/folder_html.png
    ICommentSmall                  {}
    IConsole                       48x48/apps/terminal.png
    IConsoleSmall                  32x32/apps/terminal.png
    ICore                          48x48/apps/core.png
    ICpu                           {}
    IDocument                      48x48/mimetypes/document.png
    IDocumentGate                  48x48/mimetypes/document2.png
    IDocumentRegistered            48x48/mimetypes/document2.png
    IDocumentSmall                 16x16/mimetypes/document.png
    IDocumentXML                   48x48/mimetypes/html.png
    IDynamicComponent              48x48/filesystems/exec.png
    IDynamicComponentSmall         22x22/filesystems/exec.png
    IEarth                         48x48/apps/browser.png
    IFileBroken                    48x48/filesystems/file_broken.png
    IFolder                       {48x48/filesystems/folder_empty.png
                                   48x48/filesystems/folder.png}
    IFolderLocked                  48x48/filesystems/folder_locked.png
    IFolderSmall                  {16x16/filesystems/folder_empty.png
                                   16x16/filesystems/folder.png}
    IFolderSmallOpen              {16x16/filesystems/folder_empty_open.png
                                   16x16/filesystems/folder_open.png}
    IForward                      {32x32/actions/foward.png
                                   32x32/actions/forward.png}
    IGUI                           48x48/apps/window_list.png
    IHelpDoc                       {}
    IMagnifyingGlass               32x32/actions/search.png
    IModule                        32x32/actions/run.png
    IModuleActive                  {}
    IModuleEnabled                 {}
    IModuleInactive                {}
    IModulePostCons                {}
    IModulePreCons                 {}
    IModuleProperties              48x48/apps/winprops.png
    IModuleProps                   {}
    IModuleRun                     {}
    IModuleViewers                 {}
    IMultipleFiles                 48x48/mimetypes/kmultiple.png
    IOS_Linux                      {}
    IOS_Linux2                     {}
    IOS_Solaris                    {}
    IOS_Unknown                    {}
    IOS_Windows                    {}
    IOS_Windows2                   {}
    IPartAlwaysDownload            32x32/actions/down.png
    IPartDownload                  32x32/actions/bookmark_add.png
    IPartNoDownload                32x32/actions/button_cancel.png
    IProperties                    48x48/mimetypes/info.png
    IProperties_Old                {}
    IQuestionMark                  32x32/actions/help.png
    IRemoveDocuments               {}
    IRightLeft                     {}
    IRightLeft2                    {}
    IScript                        {}
    ISearchFolder                  {}
    ISourceCpp                     48x48/mimetypes/source_cpp.png
    ISystem                       {48x48/mimetypes/source_moc.png
                                   48x48/mimetypes/source_make.png}
    ISystemOld                     {}
    ISystemSmall                  {22x22/mimetypes/source_moc.png
                                   22x22/mimetypes/source_make.png}
    ISystemSmallOld                {}
    ITAdd                          {}
    ITAddCollectionPath            {}
    ITAddCurveP                    {}
    ITAddCurveP1                   {}
    ITAddDepend                    {}
    ITAddModuleDir                 {}
    ITBoolean                      {}
    ITBottom                       {}
    ITCancel                       16x16/actions/cancel.png
    ITComboBox                     {}
    ITCompile                      16x16/actions/compfile.png
    ITConsole                      16x16/apps/terminal.png
    ITCreateCollection             16x16/actions/folder_new.png
    ITCreateDocument               16x16/actions/filenew.png
    ITCreateModule                 {}
    ITCreateSystem                 {}
    ITDeleteCollection             {}
    ITDeleteDocument               16x16/actions/edit_delete.png
    ITDeleteFolder                 {}
    ITDeleteSystem                 {}
    ITDown                         16x16/actions/down.png
    ITEarth                        {}
    ITEdit                         16x16/actions/edit.png
    ITEditCollection               {}
    ITEditCopy                     16x16/actions/editcopy.png
    ITEditCut                      16x16/actions/editcut.png
    ITEditModule                   {}
    ITEditPaste                    16x16/actions/editpaste.png
    ITEditSystem                   {}
    ITEditText                     16x16/actions/edit.png
    ITEllogonMode                  {}
    ITEntryClear                   16x16/actions/editdelete.png
    ITError                        16x16/actions/cancel.png
    ITExit                         16x16/actions/exit.png
    ITExplore                      {}
    ITExportSystem                 {}
    ITExternalEditor               16x16/actions/edit.png
    ITHelp                         16x16/actions/help.png
    ITHideTags                     {}
    ITIconBoxLarge                 16x16/actions/view_icon.png
    ITIconBoxList                  16x16/actions/view_tree.png
    ITIconBoxSmall                 16x16/actions/view_multicolumn.png
    ITImage                       {16x16/mimetypes/image2.png
                                   16x16/mimetypes/image.png}
    ITImportSystem                 {}
    ITIntegers                     {}
    ITItemHelp                     16x16/actions/info.png
    ITLoad                         16x16/actions/fileopen.png
    ITLogo                         {}
    ITMemory                       16x16/devices/memory.png
    ITMemoryClear                  {}
    ITNew                          16x16/actions/filenew.png
    ITNewFolder                    16x16/actions/folder_new.png
    ITNewMany                      {}
    ITNewOverlay                   {}
    ITNewSystem                    {}
    ITNext                        {16x16/actions/next.png
                                   16x16/actions/foward.png
                                   16x16/actions/forward.png}
    ITOpen                         16x16/actions/fileopen.png
    ITOpenCollection               32x32/filesystems/folder2_open.png
    ITOpenDocument                 32x32/mimetypes/document.png
    ITOpenSystem                   16x16/mimetypes/source_moc.png
    ITPrev                        {16x16/actions/previous.png
                                   16x16/actions/back.png}
    ITProperties                   16x16/actions/configure.png
    ITReLoadModules                {}
    ITRedraw                       16x16/actions/rebuild.png
    ITReloadLastLM                 {}
    ITReloadModule                 16x16/actions/reload.png
    ITRemDepend                    {}
    ITRemove                       16x16/actions/cancel.png
    ITRenameModule                 {}
    ITRenameSystem                 {}
    ITRun                          16x16/actions/exec.png
    ITSave                         16x16/actions/filesave.png
    ITSaveLayout                   {}
    ITSaveLayout1                  {}
    ITSearch                       16x16/actions/filefind.png
    ITSearchLarge                  48x48/apps/kfind.png
    ITSelectColour                 16x16/actions/colorize.png
    ITSelectFont                   16x16/actions/fonts.png
    ITSetGrid                      {}
    ITShowTags                     {}
    ITStar                         16x16/actions/bookmark.png
    ITTool                         16x16/actions/exec.png
    ITTools                        16x16/actions/configure.png
    ITTop                          {}
    ITUp                           16x16/actions/up.png
    ITUpdate                       {}
    ITUpdateDocument               {}
    ITViewAnns                     {}
    ITViewColAtt                   {}
    ITViewDocAtt                   {}
    ITViewText                     16x16/actions/filefind.png
    ITViewTextLarge                32x32/actions/filefind.png
    ITViewTimeLg                   16x16/apps/clock.png
    ITWarning                      {}
    ITWarning2                     {}
    ITZoom                         16x16/actions/viewmag.png
    ITextDocument                 {32x32/mimetypes/txt2.png
                                   32x32/mimetypes/txt.png}
    ITik                          {16x16/actions/ok.png
                                   16x16/actions/button_ok.png
                                   16x16/actions/apply.png}
    ITinyDoc                      {16x16/mimetypes/document2.png
                                   16x16/mimetypes/document.png}
    IToolbar                       {}
    IToolbarVertical               {}
    IToolbarWin                    {}
    IToolbarWinVertical            {}
    ITrashCanFull                  48x48/filesystems/trashcan_full.png
    IUp                            32x32/actions/undo.png
    IUpDown                        {}
    IWWW                           22x22/mimetypes/html.png
    IWWW2                          16x16/mimetypes/html.png
    IWarning                       {}
    Logo48x44                      {}
    Logo75x70                      {}
    NextNice                       {}
    NextNice1                      {}
    Remove                         32x32/actions/stop.png
    Step1                          {}
    Step2                          {}
    Step3                          {}
    Step4                          {}
    Step5                          {}
    Step6                          {}
    Step7                          {}
    Step8                          {}
    Step9                          {}
    TRayTracedSystem               {}
    TTik                          {16x16/actions/ok.png
                                   16x16/actions/button_ok.png
                                   16x16/actions/apply.png}
    TclLogo64                      {}
    TclPwrdLogo75                  {}
    ToolBox                        {}
    WriteDoc                       {}
    mini-lower                     16x16/actions/1downarrow.png
    mini-raise                     16x16/actions/1uparrow.png
  }
  
  #############################################################################
  ##  End of modifications section.
  #############################################################################
  
  variable KDEThemeURL
  variable SizeMap {16x16 16x16}
  
proc Initialise {{win {}}} {
  variable ImageNameMap
  variable scriptURL
  variable HomeDir
  variable defaultThemeURL
  variable ImageCache
  variable ThemeName
  
  ## Get the main directory. This script is assumed to be placed inside
  ## share/Themes/ImportKDETheme.tcl
  set scriptURL [file normalize [info script]]
  set HomeDir [file dirname [file dirname [file dirname $scriptURL]]]
  ## Update auto_path, so the application's libraries can be found
  lappend ::auto_path $HomeDir/CDM \
                      $HomeDir/lib \
                      $HomeDir/GUI \
                      $HomeDir/GUI/Dialogs \
                      $HomeDir/GUI/Widgets \
                      $HomeDir/GUI/Widgets/BWidget \
                      $HomeDir/Viewers \
                      $HomeDir/Utils \
                      $HomeDir/lib/tkdnd lib \
                      $HomeDir/XML/TclXML-2.0 \
                      $HomeDir/lib/tclblend1.3.0 \
                      $HomeDir/lib/tree8.04/library
  
  ## Retrieve the image names by examining the default theme directory...
  set defaultThemeURL $HomeDir/share/Themes/Default
  set CWD [pwd]
  cd $defaultThemeURL
  set defaultThemeImages [concat [glob -nocomplain -type f *.png] \
                                 [glob -nocomplain -type f *.gif]]
  cd $CWD
  
  ## Process the retrieved images and create the Image Cache array...
  foreach image $defaultThemeImages {
    set imageName [file root $image]
    set ImageCache($imageName) $defaultThemeURL/$image
  }
  ## Remove some special images...
  foreach imageName {IAgentPreview Compile Install TMCILogo EllogonSplash
                     EllogonSplashAcBar EllogonSplashInBar Preview unknown
                     ITBlank} {
    unset -nocomplain ImageCache($imageName)
  }
  
  ## Create the tool window...
  package require BWidget
  catch {package require Img}
  
  ## Theme Details section...
  labelframe $win.themeDetails -text {Theme Details:}
    label $win.themeDetails.themeNameLabel -text {New Theme Name:}
    entry $win.themeDetails.themeName -textvariable \
         ::ImportKDETheme::ThemeName
    label $win.themeDetails.kdeThemeURLLabel -text {KDE Theme URL:}
    entry $win.themeDetails.kdeThemeURL -textvariable \
         ::ImportKDETheme::KDEThemeURL
    button $win.themeDetails.kdeThemeURLSelect -text ... \
         -command ::ImportKDETheme::SelectKDEURL
    grid $win.themeDetails.themeNameLabel $win.themeDetails.themeName \
         -sticky snew -padx 2 -pady 2
    grid $win.themeDetails.kdeThemeURLLabel $win.themeDetails.kdeThemeURL \
         $win.themeDetails.kdeThemeURLSelect \
         -sticky snew -padx 2 -pady 2
    grid columnconfigure $win.themeDetails 1 -weight 1
  pack $win.themeDetails -fill x -padx 2 -pady 2
  
  ## New Theme Preview section...
  labelframe $win.themePreview -text {Theme Preview:}
    ScrolledWindow $win.themePreview.previewWindow
    set frame [$win.themePreview.previewWindow getframe]
    ScrollableFrame $frame.previewFrame -background white -width 815
    $win.themePreview.previewWindow setwidget $frame.previewFrame
    set frame [$frame.previewFrame getframe]
    CreatePreviewButtons $frame
    pack $win.themePreview.previewWindow -fill both -expand 1 -padx 2 -pady 2
  pack $win.themePreview -fill both -padx 2 -pady 2 -expand 1
  
  ## Button Section...
  frame $win.buttons
    button $win.buttons.previewTheme -text {Preview Theme} \
      -command ::ImportKDETheme::PreviewTheme
    button $win.buttons.saveTheme -text {Save Theme} \
      -command ::ImportKDETheme::SaveTheme
    grid $win.buttons.previewTheme $win.buttons.saveTheme \
      -sticky snew  -padx 2 -pady 2
  pack $win.buttons -fill x -padx 2 -pady 2
};# Initialise

proc SelectKDEURL {} {
  variable KDEThemeURL

  set dir [tk_chooseDirectory -initialdir $KDEThemeURL -mustexist 1]
  if {[string length $dir]} {
    set KDEThemeURL $dir
    PreviewTheme
  }
};# SelectKDEURL

proc CreatePreviewButtons {frame {pattern *}} {
  variable ImageCache
  variable PreviewFrame
  set PreviewFrame $frame
  set x 0; set y 0
  foreach imageName [lsort [array names ImageCache $pattern]] {
    image create photo $imageName -file $ImageCache($imageName)
    button $frame.preview_$imageName \
      -background white -foreground navy -padx 1 -pady 1 -borderwidth 1 \
      -text "$imageName\n([image width $imageName]x[image height $imageName])" \
      -image $imageName -compound top \
      -highlightthickness 0
    grid $frame.preview_$imageName -row $y -column [incr x] \
      -sticky snew -padx 1 -pady 1
    if {$x > 5} {set x 0; incr y}
  }
};# CreatePreviewButtons

proc PreviewTheme {} {
  variable ImageNameMap
  variable ImageCache
  variable KDEThemeURL
  variable PreviewFrame
  variable SizeMap
  foreach imageName [array names ImageNameMap] {
    foreach path $ImageNameMap($imageName) {
      set path [string map $SizeMap $path]
      if {[file exists $KDEThemeURL/$path]} {
        if {![catch {image create photo $imageName -file $KDEThemeURL/$path}]} {
          $PreviewFrame.preview_$imageName configure -text \
          "$imageName\n([image width $imageName]x[image height $imageName])"
          break
        }
      }
    }
  }
};# PreviewTheme

proc SaveTheme {} {
  variable ImageNameMap
  variable HomeDir
  variable ThemeName
  variable KDEThemeURL

  if {![string length $ThemeName]} {
    tk_messageBox -icon error -type ok -message \
      {Please specify a name for the theme!}
    return
  }

  set newThemeURL $HomeDir/share/Themes/$ThemeName
  if {[file exists $newThemeURL]} {
    set ans [tk_messageBox -icon question -type yesno -message \
      {A theme with the same name already exists. Do you want to overwrite it?}]
    if {$ans == "no"} return
  }
  ## Create the theme directory...
  catch {file delete -force -- $newThemeURL}
  file mkdir $newThemeURL
  ## Inherit dome files from the "Crystal" theme...
  file copy -force $HomeDir/share/Themes/Crystal/EllogonSplashAcBar.ppm \
                   $HomeDir/share/Themes/Crystal/EllogonSplashInBar.ppm \
                   $HomeDir/share/Themes/Crystal/EllogonSplash.gif \
                   $HomeDir/share/Themes/Crystal/SplashScreen.tcl \
                   $HomeDir/share/Themes/Crystal/Theme.tcl \
                   $HomeDir/share/Themes/Crystal/Preview.gif \
                   $newThemeURL
  ## Save the theme's images...
  foreach imageName [array names ImageNameMap] {
    foreach path $ImageNameMap($imageName) {
      if {[file exists $KDEThemeURL/$path]} {
        set filename [$imageName cget -file]
        file copy -force -- $filename $newThemeURL/$imageName.png
        #$imageName write $newThemeURL/$imageName.png -format png
        break
      }
    }
  }
  ## Modify the contents of Theme.tcl...
  set file [open $newThemeURL/Theme.tcl]
  fconfigure $file -encoding utf-8
  set data [read $file]
  close $file
  set file [open $newThemeURL/Theme.tcl w]
  fconfigure $file -encoding utf-8
  puts $file [string trim [string map [list Crystal $ThemeName] $data]]
  close $file
};# SaveTheme

};# namespace eval ImportKDETheme

::ImportKDETheme::Initialise
