global GUI_Options HomeDir tcl_platform PANE

## General Preferences
switch $tcl_platform(platform) {
  windows {array set GUI_Options [list ToolbarFrameRelief flat \
                ToolbarFrameReliefBorderWidth 0 ToolbarRelief groove \
                ToolbarReliefBorderWidth 0 ToolbarHandleRelief flat \
                ToolbarHandleReliefBorderWidth 1 ToolbarDecorate 1 \
                ToolbarHandleBackground $GUI_Options(Background) \
                ToolbarImageHandle 0 \
                ToolbarBackground $GUI_Options(Background) \
                ToolbarHandleBackground $GUI_Options(Background)]}
  default {array set GUI_Options [list ToolbarFrameRelief raised \
                ToolbarFrameReliefBorderWidth 1 ToolbarRelief flat \
                ToolbarReliefBorderWidth 0 ToolbarHandleRelief raised \
                ToolbarHandleReliefBorderWidth 1 ToolbarDecorate 0 \
                ToolbarHandleBackground $GUI_Options(Background) \
                ToolbarImageHandle 0 \
                ToolbarBackground $GUI_Options(Background) \
                ToolbarHandleBackground $GUI_Options(Background)]}
}

after 2000 {set GUI_Options(ToolbarImageHandle) 0}
foreach file [glob $HomeDir/share/Themes/Default/*.gif] {
  set image [file root [file tail $file]]
  if {[catch {image create photo $image -file \
    [file join $HomeDir share Themes Default $image.gif]}]} {
    GUI_LoadImage $image
  }
  if {[info exists GUI_Options(ImgLocation:$image)]} {
    set GUI_Options(ImgLocation:$image) [$image cget -file]
  }
}

switch $tcl_platform(platform) {
  windows {
    array set GUI_Options {InputForeground SystemWindowText
                           InputBackground SystemWindow
                           TextFg          SystemWindowText
                           TextBg          SystemWindow}
  }
  unix -
  default {
    array set GUI_Options {InputForeground black
                           InputBackground #CCCCCC
                           TextFg          black
                           TextBg          #CCCCCC}
  }
}

array set GUI_Options [list \
  ModuleShape rectangle ModuleWidth 75 ModuleHeight 60 \
  ModuleBorderWidth 1 ModuleBorderWidthSelected 2 \
  ModuleBorderColor {} ModuleBorderColorSelected $GUI_Options(SelectBackground)\
  ModuleTextWidth 75 ModuleTextJustify center ModuleTextAnchor center \
  ModuleTextPadX 0 ModuleTextPadY 0 \
  ModuleImageAnchor center ModuleImagePadX -24 ModuleImagePadY -18 \
  ModuleInactive orange ModuleEnabled lightgray \
  ModuleActive #aea2a4 ModuleRun red \
  ModuleTextInactive yellow ModuleTextEnabled green \
  ModuleTextActive white ModuleTextRun white \
]

## Pane Options...
array set PANE [list BorderWidth $GUI_Options(BorderWidth) \
  Relief raised Color $GUI_Options(Background)]
set GUI_Options(ExplorerPaneWidth) 8

## Default Background
option add *Background          $GUI_Options(Background)
option add *highlightBackground $GUI_Options(Background)
option add *activeForeground    black
#option add *activeBackground    $GUI_Options(Background)

## (BWidget) ArrowButton Widget Section
option add *ArrowButton.foreground       #000000
option add *ArrowButton.background       $GUI_Options(Background)
option add *ArrowButton.activeForeground #000000
option add *ArrowButton.activeBackground $GUI_Options(Background)

## Button Widget Section
option add *Button.Foreground       #000000
option add *Button.Background       $GUI_Options(Background)
option add *Button.activeForeground #000000
option add *Button.activeBackground $GUI_Options(Background)

## Canvas Widget Section
option add *Canvas.Background $GUI_Options(Background)

## CheckButton Widget Section
option add *Checkbutton.selectColor         #A52A2A
option add *Checkbutton.activeBackground    $GUI_Options(Background)

## BWidget's ComboBox Section
option add *ComboBox.background             $GUI_Options(Background)

## Entry Widget Section
option add *Entry.Foreground  $GUI_Options(InputForeground)
option add *Entry.Background  $GUI_Options(InputBackground)
option add *Entry.selectForeground $GUI_Options(SelectForeground)
option add *Entry.selectBackground $GUI_Options(SelectBackground)

## Explorer Widget Section
array set GUI_Options [list ExplorerFg $GUI_Options(InputForeground) \
  ExplorerBg $GUI_Options(InputBackground) ExplorerStandout navy \
  ExplorerStandoutBg $GUI_Options(Background) \
  ExplorerHilightFg $GUI_Options(SelectForeground) \
  ExplorerHilightBg $GUI_Options(SelectBackground) \
  ExplorerLineFg gray50 ExplorerLineBg $GUI_Options(InputBackground) \
  TooltipForeground black TooltipBackground #ffffaa]

## System Window Options
array set GUI_Options [list SystemBg $GUI_Options(Background)]

## Frame Widget Section
option add *Frame.Background $GUI_Options(Background)

## Label Widget Section
option add *Label.Foreground #000000
option add *Label.Background $GUI_Options(Background)

## Listbox Widget Section
option add *Listbox.Foreground  $GUI_Options(InputForeground)
option add *Listbox.Background  $GUI_Options(InputBackground)
option add *Listbox.selectForeground $GUI_Options(SelectForeground)
option add *Listbox.selectBackground $GUI_Options(SelectBackground)

## Menu Widget Section
option add *Menu.Foreground       #000000
option add *Menu.Background       $GUI_Options(Background)
option add *Menu.activeForeground $GUI_Options(MenuSelectFg)
option add *Menu.activeBackground $GUI_Options(MenuSelectBg)
option add *Menu.selectColor      #A52A2A

## MenuButton Widget Section
option add *Menubutton.Foreground       #000000
option add *Menubutton.Background       $GUI_Options(Background)
option add *Menubutton.activeForeground $GUI_Options(MenuSelectFg)
option add *Menubutton.activeBackground $GUI_Options(MenuSelectBg)

## ScrollBar Widget Section
option add *Scrollbar.Background  $GUI_Options(Background)
option add *Scrollbar.troughColor $GUI_Options(Background)

## Spinbox Widget Section
option add *Spinbox.Foreground  $GUI_Options(InputForeground)
option add *Spinbox.Background  $GUI_Options(InputBackground)
option add *Spinbox.selectForeground $GUI_Options(SelectForeground)
option add *Spinbox.selectBackground $GUI_Options(SelectBackground)
option add *Spinbox.activeForeground #000000
option add *Spinbox.activeBackground $GUI_Options(Background)

## Text Widget Section
option add *Text.Foreground    $GUI_Options(InputForeground) 
option add *Text.Background    $GUI_Options(InputBackground) 
option add *Text.selectForeground    $GUI_Options(SelectForeground)
option add *Text.selectBackground    $GUI_Options(SelectBackground)

## (BWidget) TitleFrame Widget Section
option add *TitleFrame.background     $GUI_Options(Background)

## Progress Widget Section
option add *Progress.undoneForeground black                        
option add *Progress.undoneBackground white                        
option add *Progress.doneForeground   $GUI_Options(SelectForeground) 
option add *Progress.doneBackground   $GUI_Options(SelectBackground)

source [file join $HomeDir GUI DrawModule.tcl]
