##########################################################################
# 
#        C45Suite.tcl - Thursday February 08 17:58:44 (EET) 2001
#       This is a loosed coupled (Tcl) Module for use with 
#       Ellogon, version 1.00...
#
##########################################################################


# Location of this module (C45Suite)
global creole_C45Suite_home 
catch {source [file join $creole_C45Suite_home Export.tcl]}

## creole_C45Suite
#  
proc creole_C45Suite {doc col args} {
  global GUI_Text creole_C45Suite creole_C45Suite_home UserHomeDir CDM_TempDir
  set win [ggi_unused_win .creole_C45Suite]
  toplevel $win
  wm withdraw $win
  wm title $win {C 4.5 Suite...}

  if {[llength [info command C45Image]] == 0} {
    image create photo C45Image -file [file join $creole_C45Suite_home C45.ppm]
  }
  
  set TitleFrame $win.title
  frame $TitleFrame
    label $TitleFrame.image -image C45Image
    label $TitleFrame.text -height 2 -anchor w -justify left -text \
      {C 4.5 Suite} -font {Helvetica 13 bold}
    grid $TitleFrame.image $TitleFrame.text -sticky snew -padx 3 -pady 6
    grid columnconfigure $TitleFrame 1 -weight 1
  pack $TitleFrame -fill x -expand 1

  set Frame $win.combo
  frame $Frame

  ## Select Vectors...
  TitleFrame $Frame.selvectors -text {Select File containing Vectors:}
    set VF [$Frame.selvectors getframe]
    label $VF.msg -anchor w -justify left -text {Vectors File:}
    entry $VF.val -textvar creole_C45Suite($win-VectorsFile) -width 45
    set creole_C45Suite($win-VectorsFile) [file join $UserHomeDir Vectors.txt]
    label $VF.imsg -anchor w -justify left -text \
      {Number of columns to ignore while creating names:}
    spinbox $VF.ival -textvar creole_C45Suite($win-IgnoreColumns) \
      -from 0 -to 10 -justify center -width 3
    button $VF.sel -image ITOpen -textvar GUI_Text(SelectFile) -compound left\
      -command "GUI_SelectFile $VF.val -defaultextension *.* \
          -filetypes [list [list [list $GUI_Text(All) [list * *.*]]]]"
    GUI_MakeEntryFileDropTarget $VF.val
    grid $VF.msg $VF.val $VF.sel -padx 2 -pady 2 -sticky snew
    grid $VF.imsg -columnspan 2  -padx 2 -pady 2 -sticky snew
    grid $VF.ival -row 1 -column 2 -padx 2 -pady 2 -sticky snew
    grid columnconfigure $VF 1 -weight 1
  pack $Frame.selvectors -pady 2 -fill x -expand 1

  ## Parameters...
  TitleFrame $Frame.parameters -text {Iterate Over Parameter Values:}
    set VF [$Frame.parameters getframe]
    label  $VF.mmsg  -anchor w -justify left -text {Parameter m:}
    entry  $VF.mval  -textvar creole_C45Suite($win-ParameterM)
    button $VF.mcalc -text Set -command \
      "creole_C45SuiteCalcValues creole_C45Suite($win-ParameterM)"
    set creole_C45Suite($win-ParameterM) "2 4 6 8 10"
    label  $VF.cmsg  -anchor w -justify left -text {Parameter c:}
    entry  $VF.cval  -textvar creole_C45Suite($win-ParameterC)
    button $VF.ccalc -text Set -command \
      "creole_C45SuiteCalcValues creole_C45Suite($win-ParameterC)"
    set creole_C45Suite($win-ParameterC) "10 30 50 70 90"
    checkbutton $VF.enableGrouping -anchor w -justify left \
      -variable creole_C45Suite($win-Grouping) -text \
      {Enable Feature Grouping}     
    grid $VF.mmsg $VF.mval $VF.mcalc -padx 2 -pady 2 -sticky snew
    grid $VF.cmsg $VF.cval $VF.ccalc -padx 2 -pady 2 -sticky snew
    grid $VF.enableGrouping -columnspan 3 -padx 2 -pady 2 -sticky snew
    grid columnconfigure $VF 1 -weight 1
  pack $Frame.parameters -pady 2 -fill x -expand 1

  ## N-Fold Cross Validation...
  TitleFrame $Frame.crossValidation -text {Cross Validation:}
    set CF [$Frame.crossValidation getframe]
    checkbutton $CF.enableCrossValidation -anchor w -justify left \
      -variable creole_C45Suite($win-CrossValidation) -text \
      {Enable N-fold Cross Validation} -command \
      "if \{\$creole_C45Suite($win-CrossValidation)\} \
      \{$CF.val conf -state normal\} else \{$CF.val conf -state disabled\}"
    label   $CF.msg -anchor w -justify left -text {Number of Folds:}
    spinbox $CF.val -textvar creole_C45Suite($win-FoldsNumber) \
      -from 0 -to 30 -justify center
    set creole_C45Suite($win-FoldsNumber)     10
    set creole_C45Suite($win-CrossValidation) 1
    grid $CF.enableCrossValidation -columnspan 2 -padx 2 -pady 2 -sticky snew
    grid $CF.msg $CF.val -padx 2 -pady 2 -sticky snew
    grid columnconfigure $CF 1 -weight 1
  pack $Frame.crossValidation -pady 2 -fill x -expand 1
 
  ## Output File...
  TitleFrame $Frame.file -text {Results File:}
    set File [$Frame.file getframe]
    label  $File.msg -anchor w -justify left -text {Results File:}
    entry  $File.val -textvar creole_C45Suite($win-ResultsFile)
    set creole_C45Suite($win-ResultsFile) [file join $UserHomeDir Results.txt]
    button $File.sel -image ITOpen -textvar GUI_Text(SelectFile) -compound left\
      -command "GUI_SelectSaveFile $File.val -defaultextension *.* \
          -filetypes [list [list [list $GUI_Text(All) [list * *.*]]]]"
    GUI_MakeEntrySaveFileDropTarget $File.val
    label  $File.dmsg -anchor w -justify left -text {Temporary Work Directory:}
    entry  $File.dval -textvar creole_C45Suite($win-TempDir)
    set creole_C45Suite($win-TempDir) \
      [file join $CDM_TempDir creole_C45SuiteTempDir[pid]]
    button $File.dsel -image ITOpen -textvar GUI_Text(SelectFile) \
      -compound left -command "GUI_SelectDirectory $File.dval"
    Tooltip::tooltip $File.dsel -textvariable GUI_Text(SelectDirectory)
    button $File.export -text Export... \
      -command "C45SuiteExport \$creole_C45Suite($win-ResultsFile)"
    checkbutton $File.delTempDir -anchor w -justify left \
      -variable creole_C45Suite($win-DeleteTempDir) -text \
      {Delete Temporary Directory when Finished}    
    set creole_C45Suite($win-DeleteTempDir) 1
    grid $File.msg  $File.val  $File.sel  -padx 2 -pady 2 -sticky snew
    grid $File.dmsg $File.dval $File.dsel -padx 2 -pady 2 -sticky snew
    grid $File.export -columnspan 3   -padx 2 -pady 2 -sticky snw
    grid $File.delTempDir -columnspan 3   -padx 2 -pady 2 -sticky snew
    grid columnconfigure $File 1 -weight 1
  pack $Frame.file -pady 2 -fill x -expand 1
  pack $Frame -padx 4 -pady 5 -fill x -expand 1

  ## Button Section
  set ButtonFrame $win.buttons
  frame $ButtonFrame
    button $ButtonFrame.apply -textvar GUI_Text(Apply) -command \
      [list creole_C45SuiteApply $win] -default active
    bind $win <Return> "$ButtonFrame.apply invoke"
    button $ButtonFrame.close -textvar GUI_Text(Close) -command "destroy $win"
    pack $ButtonFrame.apply $ButtonFrame.close -side left -padx 4
  pack $ButtonFrame -padx 4 -pady 5 -expand 1
  update
  gut_ModalDlg $win
  wm deiconify $win
} ;# creole_C45Suite

## Run C4.5...
proc creole_C45SuiteApply {win} {
  global creole_C45Suite
  set TempDir $creole_C45Suite($win-TempDir)
  file mkdir $TempDir
  ## Initialise array. We support up to 200 fields :-)
  for {set i 0} {$i < 200} {incr i} {set Field($i) {}}
  
## Step 1: Construct Names file from the Vectors file...
  creole_C45SuiteLog $win "Generating Attribute Names File..." header
  ## Try to find out the number of vectors in the file. First try to use "wc":
  ## If this fails, then estimate it from the file size...
  if {[catch {exec wc $creole_C45Suite($win-VectorsFile)} lines]} {
    set size [file size $creole_C45Suite($win-VectorsFile)]
    set lines [expr int($size/100.0)]
  } else {
    set lines [lindex $lines 0]
  }
  ## Try to get a reasonable root name
  set RootName Experiment
  set creole_C45Suite($win-RootName) $RootName
  ## Read the vector file...
  set vf [open $creole_C45Suite($win-VectorsFile)]
  set wwin [ggi_wait_message {Generating Names...} 0]
  if {$creole_C45Suite($win-IgnoreColumns)} {
    for {set i 0} {$i < $creole_C45Suite($win-IgnoreColumns)} {incr i} {
      set Field($i) ignore
    }
  }
  ## Iterate over lines...
  set line_index 0
  while {[gets $vf line] >= 0} {
    ## Remove white space and the last "."
    ## Substitute all \, win ^A, as we will split on ","...
    set line [string map "\\\\, \001" [string trim $line " \t."]]

    ## Break line into its fields...
    set fields [split $line ,]

    if {$creole_C45Suite($win-IgnoreColumns)} {
      set i $creole_C45Suite($win-IgnoreColumns)
      foreach field [lrange $fields $creole_C45Suite($win-IgnoreColumns) end] {
        CDM_LappendUnique Field($i) $field
        incr i
      }
    } else {
      set i 0
      foreach field $fields {
        CDM_LappendUnique Field($i) $field
        incr i
      }
    }
    incr line_index
    ggi_wait_update {} [expr \
      {($lines>$line_index)?(int(double($line_index)/$lines*100)):99}] $wwin
  }
  close $vf
  ggi_destroy_wait $wwin
  ## Remove useless entries...
  foreach field [array names Field] {
    if {![llength $Field($field)]} {unset Field($field)}
  }
  ## Print results...
  set nameFile [open [file join $TempDir $RootName.names] w]
  ## The classes should be on top of the file...
  set class [lindex [lsort -integer [array names Field]] end]
  set Field($class) [lsort -unique $Field($class)]
  set i [lsearch -exact $Field($class) ?]
  if {$i != -1} {
    set Field($class) [lreplace $Field($class) $i $i]
  }
  if {![llength $Field($class)]} {
    set Field($class) ignore
  }
  puts $nameFile [string map "\001 \\\\," \
                         [join [lsort -unique $Field($class)] ,].]

  ## and then the rest of the fields...
  foreach field [lrange [lsort -int [array names Field]] 0 [expr $class-1]] {
    set Field($field) [lsort -unique $Field($field)]
    set i [lsearch -exact $Field($field) ?]
    if {$i != -1} {
      set Field($field) [lreplace $Field($field) $i $i]
    }
    if {[llength $Field($field)] < 2} {
      set Field($field) ignore
    }
    puts $nameFile [string map "\001 \\\\," \
                     "Field_$field: [join [lsort -unique $Field($field)] ,]."]
  }
  close $nameFile
## Step 2: Iterate over the values of the m & c parameters...
  creole_C45SuiteLog $win "Copying Vectors file..." header
  file copy -force $creole_C45Suite($win-VectorsFile) \
    [file join $TempDir $RootName.all]
  creole_C45SuiteLog $win {}
  set i 1
  set Classes [lsort -unique $Field($class)]
  set CWD [pwd]
  cd $TempDir
  catch {file delete -force $creole_C45Suite($win-ResultsFile)}
  foreach m $creole_C45Suite($win-ParameterM) {
    foreach c $creole_C45Suite($win-ParameterC) {
      creole_C45SuiteLog $win "Running Experiment $i: m=$m, c=$c" header
      if {[catch {creole_C45SuiteNFoldCrossValidation $win $m $c $Classes} \
                                                                       error]} {
        creole_C45SuiteLog $win "Error\n$error" error
      }
      incr i
    }
  }
  cd $CWD
  
  ## Delete Unwanted Files...
  if {$creole_C45Suite($win-DeleteTempDir)} {
    file delete -force $creole_C45Suite($win-TempDir)
  }
};# creole_C45SuiteApply

## This function performs N-Fold Cross validation with C4.5...
proc creole_C45SuiteNFoldCrossValidation {win m c ClassNames} {
  global creole_C45Suite
  if {[info exists ClassNames]} {
    set i 0
    foreach class $ClassNames {
      set Label($i) $class
      incr i
    }
    set class_nu [llength $ClassNames]
  } else {
    error "You forgot to define the Class Names!"
  }

  for {set cl 0} {$cl < $class_nu} {incr cl} {
    set Recall($cl) 0.0
    set recall($cl) 0
    set Precision($cl) 0.0
    set precision($cl) 0
    if {![info exists Label($cl)]} {set Label($cl) "Class $cl"}
  }

  ##########################################
  ## DO NOT MODIFY BELOW THIS POINT!
  ##########################################
  set fname $creole_C45Suite($win-RootName)
  set filename $fname
  append filename ".all"
  set mparam   $m
  set cparam   $c
  
  set sizeav 0
  set accuracy 0

  set N $creole_C45Suite($win-FoldsNumber)
  
  #############################################################################
  ## Split dataset into N parts, according to the distribution of the
  ## classes in the original dataset...
  #############################################################################

  ##########
  # Step 1:
  # Sort vectors into files according to their class
  set original_file [open $filename]

  ## We will work in a temp directory that we will delete afterwards...
  set TempDir TemporaryDirectory_[pid]
  file mkdir $TempDir
  cd $TempDir

  ## Open the class files...
  foreach class $ClassNames {
    set File($class) [open [string map {/ __} Class_$class] w]
    set VectorCount($class) 0
  }

  ## Seperate the vectors into the proper files...
  while {![eof $original_file]} {
    gets $original_file line
    if {![string length $line]} {continue}
    set class [string trimright [lindex [split $line ,] end] .]
    puts $File($class) $line
    incr VectorCount($class)
  }
  close $original_file

#######################################################
## TODO: Unix specific (split)...
  ## Close files...
  foreach class [array names File] {
    ## Close the file...
    close $File($class)
    ## Now, split each class file into N pieces...
    set lines [format "%u" [expr {int($VectorCount($class) / double($N) + 1)}]]
    exec split -l $lines [string map {/ __} Class_$class] \
                         [string map {/ __} Class_${class}_]
    ## We don't need the whole file any more...
    file delete -force [string map {/ __} Class_$class]
  }

#######################################################
## TODO: Only 10-fold...
  ## Now create the N data files...
  set file_list {Part1 Part2 Part3 Part4 Part5 Part6 Part7 Part8 Part9 Part10}
  foreach suffix {aa ab ac ad ae af ag ah ai aj} file $file_list {
    catch {file delete -force ../$file}
    foreach class $ClassNames {
      catch {exec cat [string map {/ __} Class_${class}_$suffix] >> ../$file}
      catch {file delete -force [string map {/ __} Class_${class}_$suffix]}
    }
    ## Now, we should randomise the file, but that's not important for C4.5
  }
  
  ## We are done. Return to the original directory...
  cd ..
  ## Remove the (empty) temporary dir...
  catch {file delete -force $TempDir}
  
  ## Iteration...
  foreach file $file_list {
    set datafile $fname
    append datafile ".data"
    set testfile $fname
    append testfile ".test"
  
    exec /bin/rm -f $datafile 
    exec /bin/rm -f $testfile
  
    exec touch $datafile
    exec /bin/cp $file $testfile
  
    foreach file1 $file_list {
      if {$file1 != $file} {
         exec cat $file1 >> $datafile
      }
    }
    exec /bin/rm -f tempfile
    if {[catch {exec c4.5 -f $fname -u -m $mparam -c $cparam > tempfile} \
           error]} {
       if {[string first {child process exited abnormally} $error] == -1} {
         creole_C45SuiteLog $win "Error:\n$error" error
         return
       }
    }
  
    ###############################################
    set inputfile tempfile
    if [catch {open $inputfile r} input] {
       error "Cannot open $inputfile"
    }
  
    ## Find the string "Evaluation on test data ": This is where the results
    ## are...
    while {![eof $input]} {
      gets $input line
      if {[string first "Evaluation on test data " $line] != -1} { break; }
    }
  
    ## Skip the next 5 lines...
    for {set i 0} {$i < 5} {incr i} {
      gets $input line
    }
  
    # Read size and error...
    gets $input line
    set line [string trim $line]
    set list [split $line ")"]
    set line [lindex $list 1]
    set line [string trimleft $line]
    set size [lindex [split $line] 0]
    set error [lindex [split $line "(%"] 1]
  
    # Read the matrix: First skip 4 lines...
    for {set i 0} {$i < 4} {incr i} {
      gets $input line
    }
    ## ...and then read the matrix, line by line.
    for {set i 0} {$i < $class_nu} {incr i} {
      gets $input line
      set line_index 1
      for {set j 0} {$j < $class_nu} {incr j} {
        set value [string trim [string range $line \
           [expr {$line_index}] [expr {$line_index+4}]]]
        if {![string length $value]} {set value 0}
        set Matrix($i,$j) $value
        incr line_index 5
      }
    }
    close $input

    ## Calculate Recall figures...
    for {set i 0} {$i < $class_nu} {incr i} {
      set sum 0.0
      for {set j 0} {$j < $class_nu} {incr j} {
        set sum [expr {$sum + $Matrix($i,$j)}]
      }
      if {[expr {$sum > 0.0}]} {
        set Recall($i) [expr {$Recall($i) + $Matrix($i,$i)/$sum}]
      }
    }

    ## Calculate Precision figures...
    for {set i 0} {$i < $class_nu} {incr i} {
      set sum 0.0
      for {set j 0} {$j < $class_nu} {incr j} {
        set sum [expr {$sum + $Matrix($j,$i)}]
      }
      if {[expr {$sum > 0.0}]} {
        set Precision($i) [expr {$Precision($i) + $Matrix($i,$i)/$sum}]
      }
    }
    set accuracy [expr {100.0 - $error + $accuracy}]
    set sizeav   [expr {$size + $sizeav}] 
  };# foreach file...
  set size             [expr {$sizeav / 10.}]
  set accuracy         [expr {$accuracy / 10.}]
  for {set i 0} {$i < $class_nu} {incr i} {
    set Recall($i) [expr {$Recall($i)/10.}]
    set Precision($i) [expr {$Precision($i)/10.}]
  }
  # Print Results...
  set rf [open $creole_C45Suite($win-ResultsFile) a]
  creole_C45SuiteLog $win "m=$mparam c=$cparam size=$size accuracy=$accuracy "
  puts -nonewline $rf "m=$mparam c=$cparam size=$size accuracy=$accuracy "
  for {set i 0} {$i < $class_nu} {incr i} {
    creole_C45SuiteLog $win "$Label($i): R=$Recall($i) P=$Precision($i) "
    puts -nonewline $rf "$Label($i): R=$Recall($i) P=$Precision($i) "
  }
  creole_C45SuiteLog $win {}
  puts $rf {}
  close $rf
};# creole_C45SuiteNFoldCrossValidation

## This function opens and manages a Log Window...
proc creole_C45SuiteLog {Win message {type {}} args} {
  set win $Win.logWindow
  if {![winfo exists $win]} {
    set text [ggi_view_text_file {} {} {} "C 4.5 Suite Log Window..." $win]
    $text tag configure header -background black -foreground white
    $text tag configure error  -background red   -foreground white
  }

  set text $win.frame.text
  $text configure -state normal
  switch -exact $type {
    header  {$text insert end "\n$message\n \n" header}
    error   {$text insert end "\n$message\n \n" error}
    default {$text insert end "$message\n"}
  }
  $text see end
  $text configure -state disabled
  update
};# creole_C45SuiteLog

## This function displays a dialog that allows end user to set parameter
## values with a for loop...
proc creole_C45SuiteCalcValues {var} {
  set win [ggi_unused_win .creole_C45SuiteCalcValues]
  toplevel $win
  wm withdraw $win
  wm title $win {Generating Parameter Values...}

  label   $win.msg   -text {Generating Parameter Values...}
  label   $win.from  -text {From:}
  spinbox $win.fromv -from 0 -to 199 -justify center -width 6
  label   $win.to    -text {To:}
  spinbox $win.tov   -from 1 -to 200 -justify center -width 6
  label   $win.step  -text {Step:}
  spinbox $win.stepv -from 1 -to 200 -justify center -width 6

  grid $win.msg -columnspan 6 -padx 2 -pady 2 -sticky snew
  grid $win.from $win.fromv $win.to $win.tov $win.step $win.stepv \
    -padx 2 -pady 2 -sticky snew

  button $win.ok     -textvar GUI_Text(Ok)     -command \
    "set $var {}
     for \{set i \[$win.fromv get\]\} \{\$i <= \[$win.tov get\]\} \
     \{incr i \[$win.stepv get\]\} {
       lappend $var \$i
     }
     destroy $win"
  button $win.cancel -textvar GUI_Text(Cancel) -command "destroy $win"
  grid $win.ok     -row 2 -column 2 -padx 2 -pady 2 -sticky sn
  grid $win.cancel -row 2 -column 3 -padx 2 -pady 2 -sticky sn
  gut_ModalDlg $win
  wm deiconify $win
};# creole_C45SuiteCalcValues
#
# End of File
#

