##########################################################################
# 
#	CreateAnnotationsFromVectors.tcl - Thursday January 25 19:57:56 (EET) 2001
#       This is a loosed coupled (Tcl) Module for use with 
#       Ellogon, version 1.00...
#
##########################################################################


# Location of this module (CreateAnnotationsFromVectors)
global creole_CreateAnnotationsFromVectors_home

## creole_CreateAnnotationsFromVectors
#  
proc creole_CreateAnnotationsFromVectors {doc args} {
  global UserHomeDir GUI_Text
  entry .entry__
  .entry__ insert end $UserHomeDir/Vectors.txt
  GUI_SelectFile .entry__ -defaultextension *.* \
          -filetypes [list [list $GUI_Text(All) [list * *.*]]]
  set file [.entry__ get]
  destroy .entry__

  set cols  [GUI_GetCollectionNames]
  set colts [GUI_GetCollectionNameTails]
  
  ## Process Vector file...
  set v [open $file]
  while {1} {
    gets $v line
    if {[eof $v]} {break}
    if {![string length $line]} {continue}

    set vector  [split [string map {\\ {}} $line] ,:]
    eval set id [lindex $vector 1]
    set class   [string range [lindex $vector end] 0 end-1]
    foreach {col doc type id} [split $id |:] {break}
    if {![info exists Col($col)]} {
      set index [lsearch $colts $col]
      puts "Opening Collection: [lindex $cols $index]"
      set Col($col) [tip_OpenCollection [lindex $cols $index]]
    }
    if {![info exists Doc($doc)]} {
      puts "Opening Document: $doc"
      set Doc($doc) [tip_GetDocument $Col($col) $doc]
    }

    set ann [tip_GetAnnotation $Doc($doc) $id]
    set ann [tip_CreateAnnotation c4.5 [tip_GetSpans $ann] \
            [list [list value [list GDM_STRING $class]]]]
    tip_AddAnnotation $Doc($doc) $ann
  }
  close $v
  foreach col [array names Col] {
    tip_Sync  $Col($col)
    tip_Close $Col($col)
  }
} ;# creole_CreateAnnotationsFromVectors


## Procedure: creole_CreateAnnotationsFromVectors_Initialize
#   Use this function in order to do some initialization. This function will
#   be called just before creole_CreateAnnotationsFromVectors in the following situations:
#    *) If the user has opened a whole Collection, this function will be 
#       called just before the first document in Collection gets proccessed 
#       with creole_CreateAnnotationsFromVectors
#    *) If the user has opened a single Document, this function will be called
#       just before calling creole_CreateAnnotationsFromVectors
#   Please, refer to the Ellogon's Programming Manual for more 
#   information on this function...
proc creole_CreateAnnotationsFromVectors_Initialize {col doc args} {
  global creole_CreateAnnotationsFromVectors_home
  ## Do some initilization here...
} ;# creole_CreateAnnotationsFromVectors_Initialize

## Procedure: creole_CreateAnnotationsFromVectors_Finish
#   Use this function in order to do some Clean-Up. This function will
#   be called after all calls to creole_CreateAnnotationsFromVectors in the following 
#   situations:
#    *) If the user has opened a whole Collection, this function will be 
#       called just after the last document in Collection gets proccessed with 
#       creole_CreateAnnotationsFromVectors
#    *) If the user has opened a single Document, this function will be called
#       just after calling creole_CreateAnnotationsFromVectors
#   Please, refer to the Ellogon's Programming Manual for more 
#   information on this function...
proc creole_CreateAnnotationsFromVectors_Finish {col doc args} {
  global creole_CreateAnnotationsFromVectors_home
  ## Clean-Up...
} ;# creole_CreateAnnotationsFromVectors_Finish

#
# End of File
#

