##########################################################################
# 
#	DetailedComparisonTool.tcl - ΞΒΞΒΞΒΞΒΞΒΞΒΞΒΞΒΞΒΞΒ­ΞΒΞΒΞΒΞΒ± ΞΒΞΒΞΒΞΒΞΒΞΒ³ΞΒΞΒΞΒΞΒΞΒΞΒΞΒΞΒΞΒΞΒΞΒΞΒ 04 20:44:01 (EEST) 2003
#       This is a loosed coupled (Tcl) Component for use with 
#       Ellogon, version 1.5...
#
##########################################################################


# Location of this module (DetailedComparisonTool)
global creole_DetailedComparisonTool_home

## creole_DetailedComparisonTool
#  
proc creole_DetailedComparisonTool {doc col args} {
  ## Allow this module to operate as a Tool. In Tools, the main routine gets
  ## always called with the doc & col as arguments...
  creole_DetailedComparisonTool_Initialize $col $doc
};# creole_DetailedComparisonTool


## Procedure: creole_DetailedComparisonTool_Initialize
#   Use this function in order to do some initialisation. This function will
#   be called just before creole_DetailedComparisonTool in the following situations:
#    *) If the user has opened a whole Collection, this function will be 
#       called just before the first document in Collection gets proccessed 
#       with creole_DetailedComparisonTool
#    *) If the user has opened a single Document, this function will be called
#       just before calling creole_DetailedComparisonTool
#   Please, refer to the Ellogon's Programming Manual for more 
#   information on this function...
proc creole_DetailedComparisonTool_Initialize {col doc args} {
  set DetailedEvaluation [lindex $args 0]
  ## Allow this module to operate as a button module.
  ## In buttons, the initialisation routine gets
  ## always called with the col & doc as arguments...
  if {[string length $col] == 0} {
    gut_info $::GUI_Text(PleaseOpenColl/Doc)
    return
  }
  update
  tip_Sync $col
  ## Collect all the possible values...
  if {[string length $doc] && $DetailedEvaluation} {
    ## The user has opened a single Document...
    foreach type {ne NE timex TIMEX numex NUMEX term TERM} {
      foreach value [$doc GetAnnotationAttributeValues $type type] {
        CDM_LappendUnique Values($type) $value
      }
    }
  } elseif {$DetailedEvaluation} {
    ## The user has opened a Collection...
    set wwin [ggi_wait_message {} 0]
    set Progress 0.0
    set Step [expr {100.0/([tip_Length $col]+1)}]
    set DOC [tip_FirstDocument $col]
    while {[string length $DOC]} {
      foreach type {ne NE timex TIMEX numex NUMEX term TERM} {
        foreach value [$DOC GetAnnotationAttributeValues $type type] {
          CDM_LappendUnique Values($type) $value
        }
      }
      set DOC [tip_NextDocument $col]
      set Progress [expr {$Progress+$Step}]
      ggi_wait_update {} $Progress $wwin
    }
    ggi_destroy_wait $wwin
  }
  ##
  ## Configure the Comparison facilities...
  ##
  global CDMTools_CompareCollections
  set CDMTools_CompareCollections(::KeyCollectionName::) [tip_GetName $col]
  set CDMTools_CompareCollections(::ResCollectionName::) [tip_GetName $col]
  if {[string length $doc]} {
    set CDMTools_CompareCollections(::KeyDocumentId::) [tip_GetId $doc]
    set CDMTools_CompareCollections(::ResDocumentId::) [tip_GetId $doc]
  } else {
    set CDMTools_CompareCollections(::KeyDocumentId::) {}
    set CDMTools_CompareCollections(::ResDocumentId::) {}
  }
  set CDMTools_CompareCollections(::CheckAttributes::)    1
  set CDMTools_CompareCollections(::NumberAttributes::)   1
  set CDMTools_CompareCollections(Attribute0)             type
  set CDMTools_CompareCollections(::CompareValues::)      1
  set CDMTools_CompareCollections(::SpanOverlapPercent::) 100.0
  set Results {}
  if {$DetailedEvaluation} {
    ##
    ## Perform individual comparisons for all entity types & values...
    ##
    set CDMTools_CompareCollections(::NumberAnnotations::) 1
    set CDMTools_CompareCollections(::CreateLog::)         0
    foreach CDMTools_CompareCollections(KeyAnnType0) {ne timex numex term} \
            CDMTools_CompareCollections(ResAnnType0) {NE TIMEX NUMEX TERM} {
      append Results \
        "\n==================================================================\
         \nResults on named-entities of type\
           $CDMTools_CompareCollections(KeyAnnType0):\
         \n------------------------------------------------------------------\n"
      set CDMTools_CompareCollections(::CValues0::) {}
        foreach {precision recall fMeasure
                 totalCorrectAnns totalKeyAnns totalResponseAnns} \
                 [CDMTools_CompareCollections 0 0 0] {break}
        append Results \
          "[format %-15s *]:\
             P: [format %.3f $precision]\
             R: [format %.3f $recall]\
             FM: [format %.3f $fMeasure]\
             TCA: [format %5d [expr {int($totalCorrectAnns)}  ]]\
             TKA: [format %5d [expr {int($totalKeyAnns)}      ]]\
             TRA: [format %5d [expr {int($totalResponseAnns)} ]]\n"
      if {[info exists Values($CDMTools_CompareCollections(KeyAnnType0))] &&
          [info exists Values($CDMTools_CompareCollections(ResAnnType0))]} {
        set values [lsort -unique \
                   [concat $Values($CDMTools_CompareCollections(KeyAnnType0)) \
                           $Values($CDMTools_CompareCollections(ResAnnType0))]]
      } elseif {[info exists Values($CDMTools_CompareCollections(KeyAnnType0))]} {
        set values $Values($CDMTools_CompareCollections(KeyAnnType0))
      } elseif {[info exists Values($CDMTools_CompareCollections(ResAnnType0))]} {
        set values $Values($CDMTools_CompareCollections(ResAnnType0))
      } else {
        set values {}
      }
      foreach value $values {
        set CDMTools_CompareCollections(::CValues0::) $value
        foreach {precision recall fMeasure
                 totalCorrectAnns totalKeyAnns totalResponseAnns} \
                 [CDMTools_CompareCollections 0 0 0] {break}
        append Results \
          "[format %-15s $value]:\
             P: [format %.3f $precision]\
             R: [format %.3f $recall]\
             FM: [format %.3f $fMeasure]\
             TCA: [format %5d [expr {int($totalCorrectAnns)}  ]]\
             TKA: [format %5d [expr {int($totalKeyAnns)}      ]]\
             TRA: [format %5d [expr {int($totalResponseAnns)} ]]\n"
      }
      append Results \
        "\n==================================================================\n"
    }
  };# if {$DetailedEvaluation}
  set CDMTools_CompareCollections(::NumberAnnotations::) 4
  set CDMTools_CompareCollections(KeyAnnType0)           ne
  set CDMTools_CompareCollections(ResAnnType0)           NE
  set CDMTools_CompareCollections(KeyAnnType1)           timex
  set CDMTools_CompareCollections(ResAnnType1)           TIMEX
  set CDMTools_CompareCollections(KeyAnnType2)           numex
  set CDMTools_CompareCollections(ResAnnType2)           NUMEX
  set CDMTools_CompareCollections(KeyAnnType3)           term
  set CDMTools_CompareCollections(ResAnnType3)           TERM
  set CDMTools_CompareCollections(::CValues0::)          {}
  set CDMTools_CompareCollections(::CreateLog::)         1
  ##
  ## Make a collective comparison, with log...
  ##
  foreach {precision recall fMeasure
           totalCorrectAnns totalKeyAnns totalResponseAnns} \
           [CDMTools_CompareCollections 0 0 0] {break}
  append Results "Results on All named-entities:\
      \n------------------------------------------------------------------\
      \nPrecision: $precision\
      \nRecall:    $recall\
      \nF-Measure: $fMeasure\
      \nTotal Correct Annotations:  [format %d [expr int($totalCorrectAnns)]]\
      \nTotal Key Annotations:      [format %d [expr int($totalKeyAnns)]]\
      \nTotal Response Annotations: [format %d [expr int($totalResponseAnns)]]\
      \n==================================================================\n"
  catch {ggi_view_text $Results {Detailed Comparison Results...}}
  catch {puts $Results}
};# creole_DetailedComparisonTool_Initialize

## Procedure: creole_DetailedComparisonTool_Finish
#   Use this function in order to do some Clean-Up. This function will
#   be called after all calls to creole_DetailedComparisonTool in the following 
#   situations:
#    *) If the user has opened a whole Collection, this function will be 
#       called just after the last document in Collection gets proccessed with 
#       creole_DetailedComparisonTool
#    *) If the user has opened a single Document, this function will be called
#       just after calling creole_DetailedComparisonTool
#   Please, refer to the Ellogon's Programming Manual for more 
#   information on this function...
proc creole_DetailedComparisonTool_Finish {col doc args} {
  global creole_DetailedComparisonTool_home
  ## Clean-Up...
};# creole_DetailedComparisonTool_Finish

## Commands for editing this file in VIM UTF-8 mode...
# vim: syntax=tcl encoding=utf-8 fileencoding=utf-8

#
# End of File DetailedComparisonTool.tcl
#
