## Some Predifined Values for Different annotations and attributes, for use
## with the Edit Annotations Tool...

##
## token -> pos
##
set ::EditAnnotationsTool::ValuesSpec(hellenic:token:pos) {
  {---     {Aρθρα}}
  {DDT     {Οριστικό Aρθρο}}
  {IDT     {Αόριστο Aρθρο}}
  {---     {Ουσιαστικά}}
  {NNM     {Ουσιαστικό, ενικός, αρσενικό}}
  {NNF     {Ουσιαστικό, ενικός, θηλυκό}}
  {NNN     {Ουσιαστικό, ενικός, ουδέτερο}}
  {NNSM    {Ουσιαστικό, πληθυντικός, αρσενικό}}
  {NNSF    {Ουσιαστικό, πληθυντικός, θηλυκό}}
  {NNSN    {Ουσιαστικό, πληθυντικός, ουδέτερο}}
  {NNPM    {Κύριο Όνομα (ουσιαστικό), ενικός, αρσενικό}}
  {NNPF    {Κύριο Όνομα (ουσιαστικό), ενικός, θηλυκό}}
  {NNPN    {Κύριο Όνομα (ουσιαστικό), ενικός, ουδέτερο}}
  {NNPSM   {Κύριο Όνομα (ουσιαστικό), πληθυντικός, αρσενικό}}
  {NNPSF   {Κύριο Όνομα (ουσιαστικό), πληθυντικός, θηλυκό}}
  {NNPSN   {Κύριο Όνομα (ουσιαστικό), πληθυντικός, ουδέτερο}}
  {---     {Επίθετα}}
  {JJM     {Επίθετο, ενικός, αρσενικό}}
  {JJF     {Επίθετο, ενικός, θηλυκό}}
  {JJN     {Επίθετο, ενικός, ουδέτερο}}
  {JJSM    {Επίθετο, πληθυντικός, αρσενικό}}
  {JJSF    {Επίθετο, πληθυντικός, θηλυκό}}
  {JJSN    {Επίθετο, πληθυντικός, ουδέτερο}}
  {CD      {Απόλυτα αριθμητικά (ένα, δύο, τρία, ... και νούμερα: 1, 2, 3...)}}
  {---     {Αντωνυμίες}}
  {PRP     {Προσωπική Αντωνυμία}}
  {PP      {Κτητική Αντωνυμία}}
  {REP     {Αυτοπαθής Αντωνυμία}}
  {DP      {Οριστική Αντωνυμία}}
  {IP      {Δεικτική Αντωνυμία}}
  {WP      {Αναφορική Αντωνυμία}}
  {QP      {Ερωτηματική Αντωνυμία}}
  {INP     {Αόριστη Αντωνυμία}}
  {---     {Ρήματα}}
  {VB      {Ρήμα παροντικού χρόνου}}
  {VBD     {Ρήμα παρελθοντικού χρόνου}}
  {VBF     {Ρήμα μελλοντικού χρόνου}}
  {VBS     {Ρήμα παροντικού χρόνου, πληθυντικός}}
  {VBDS    {Ρήμα παρελθοντικού χρόνου, πληθυντικός}}
  {VBFS    {Ρήμα μελλοντικού χρόνου, πληθυντικός}}
  {MD      {Βοηθητικό ρήμα (έχω, είμαι)}}
  {---     {Μετοχές}}
  {VBG     {Μετοχή ενεργητικού χρόνου (-οντας, -ώντας)}}
  {VBP     {Μετοχή παροντικού χρόνου}}
  {VBPD    {Μετοχή παρελθοντικού χρόνου}}
  {VBPF    {Μετοχή μελλοντικού χρόνου}}
  {---     {Aκλιτα Μέρη του Λόγου}}
  {RB      {Επίρρημα}}
  {IN      {Πρόθεση (με, σε, για, ως, προς, κατά, μετά, παρά, αντί, από, δίχως,\
           χωρίς, ίσαμε, δια, εκ, εξ, εν, επί, περί, προ, υπέρ, υπό, συν,\
           μείον, πλην)}}
  {CC      {Σύνδεσμος}}
  {RP      {Μόριο (ας, θα, να, μα, για)}}
  {UH      {Επιφώνημα}}
  {FW      {Ξένη λέξη}}
  {---     {Διάφορα Σύμβολα}}
  {DATE    {Ημερομηνία}}
  {AB      {Σύτμηση}}
  {SYM     {Σύμβολο}}
  {LS      {Σύμβολο Λίστας}}
  {\.      {Τελεία}}
  {\,      {Κόμμα}}
  {\:      {Aνω-κάτω τελεία}}
  {\;      {Ερωτηματικό}}
  {\!      {Θαυμαστικό}}
  {\(      {Αριστερή παρένθεση}}
  {\)      {Δεξιά παρένθεση}}
  {\"      {Εισαγωγικα (\", ', «, »)}}
}
set ::EditAnnotationsTool::ValuesSpec(hellenic:token:pos) {
{--- {Οριστικό Άρθρο} 3}
  {AtDfMaSgNm     {Οριστικό άρθρο αρσενικό ενικός ονομαστική}}
  {AtDfMaSgGe     {Οριστικό άρθρο αρσενικό ενικός γενική}}
  {AtDfMaSgAc     {Οριστικό άρθρο αρσενικό ενικός αιτιατική}}
  {AtDfMaPlNm     {Οριστικό άρθρο αρσενικό πληθυντικός ονομαστική}}
  {AtDfMaPlGe     {Οριστικό άρθρο αρσενικό πληθυντικός γενική}}
  {AtDfMaPlAc     {Οριστικό άρθρο αρσενικό πληθυντικός αιτιατική}}
  {AtDfFeSgNm     {Οριστικό άρθρο θηλυκό ενικός ονομαστική}}
  {AtDfFeSgGe     {Οριστικό άρθρο θηλυκό ενικός γενική}}
  {AtDfFeSgAc     {Οριστικό άρθρο θηλυκό ενικός αιτιατική}}
  {AtDfFePlNm     {Οριστικό άρθρο θηλυκό πληθυντικός ονομαστική}}
  {AtDfFePlGe     {Οριστικό άρθρο θηλυκό πληθυντικός γενική}}
  {AtDfFePlAc     {Οριστικό άρθρο θηλυκό πληθυντικός αιτιατική}}
  {AtDfNeSgNm     {Οριστικό άρθρο ουδέτερο ενικός ονομαστική}}
  {AtDfNeSgGe     {Οριστικό άρθρο ουδέτερο ενικός γενική}}
  {AtDfNeSgAc     {Οριστικό άρθρο ουδέτερο ενικός αιτιατική}}
  {AtDfNePlNm     {Οριστικό άρθρο ουδέτερο πληθυντικός ονομαστική}}
  {AtDfNePlGe     {Οριστικό άρθρο ουδέτερο πληθυντικός γενική}}
  {AtDfNePlAc     {Οριστικό άρθρο ουδέτερο πληθυντικός αιτιατική}}
{--- {Αόριστο Άρθρο} 3}
  {AtIdMaSgNm     {Αόριστο άρθρο αρσενικό ενικός ονομαστική}}
  {AtIdMaSgGe     {Αόριστο άρθρο αρσενικό ενικός γενική}}
  {AtIdMaSgAc     {Αόριστο άρθρο αρσενικό ενικός αιτιατική}}
  {AtIdMaPlNm     {Αόριστο άρθρο αρσενικό πληθυντικός ονομαστική}}
  {AtIdMaPlGe     {Αόριστο άρθρο αρσενικό πληθυντικός γενική}}
  {AtIdMaPlAc     {Αόριστο άρθρο αρσενικό πληθυντικός αιτιατική}}
  {AtIdFeSgNm     {Αόριστο άρθρο θηλυκό ενικός ονομαστική}}
  {AtIdFeSgGe     {Αόριστο άρθρο θηλυκό ενικός γενική}}
  {AtIdFeSgAc     {Αόριστο άρθρο θηλυκό ενικός αιτιατική}}
  {AtIdFePlNm     {Αόριστο άρθρο θηλυκό πληθυντικός ονομαστική}}
  {AtIdFePlGe     {Αόριστο άρθρο θηλυκό πληθυντικός γενική}}
  {AtIdFePlAc     {Αόριστο άρθρο θηλυκό πληθυντικός αιτιατική}}
  {AtIdNeSgNm     {Αόριστο άρθρο ουδέτερο ενικός ονομαστική}}
  {AtIdNeSgGe     {Αόριστο άρθρο ουδέτερο ενικός γενική}}
  {AtIdNeSgAc     {Αόριστο άρθρο ουδέτερο ενικός αιτιατική}}
  {AtIdNePlNm     {Αόριστο άρθρο ουδέτερο πληθυντικός ονομαστική}}
  {AtIdNePlGe     {Αόριστο άρθρο ουδέτερο πληθυντικός γενική}}
  {AtIdNePlAc     {Αόριστο άρθρο ουδέτερο πληθυντικός αιτιατική}}
{--- {Ουσιαστικά} 3}
  {NoMaSgNm       {Ουσιαστικό αρσενικό ενικός ονομαστική}}
  {NoMaSgGe       {Ουσιαστικό αρσενικό ενικός γενική}}
  {NoMaSgAc       {Ουσιαστικό αρσενικό ενικός αιτιατική}}
  {NoMaPlNm       {Ουσιαστικό αρσενικό πληθυντικός ονομαστική}}
  {NoMaPlGe       {Ουσιαστικό αρσενικό πληθυντικός γενική}}
  {NoMaPlAc       {Ουσιαστικό αρσενικό πληθυντικός αιτιατική}}
  {NoFeSgNm       {Ουσιαστικό θηλυκό ενικός ονομαστική}}
  {NoFeSgGe       {Ουσιαστικό θηλυκό ενικός γενική}}
  {NoFeSgAc       {Ουσιαστικό θηλυκό ενικός αιτιατική}}
  {NoFePlNm       {Ουσιαστικό θηλυκό πληθυντικός ονομαστική}}
  {NoFePlGe       {Ουσιαστικό θηλυκό πληθυντικός γενική}}
  {NoFePlAc       {Ουσιαστικό θηλυκό πληθυντικός αιτιατική}}
  {NoNeSgNm       {Ουσιαστικό ουδέτερο ενικός ονομαστική}}
  {NoNeSgGe       {Ουσιαστικό ουδέτερο ενικός γενική}}
  {NoNeSgAc       {Ουσιαστικό ουδέτερο ενικός αιτιατική}}
  {NoNePlNm       {Ουσιαστικό ουδέτερο πληθυντικός ονομαστική}}
  {NoNePlGe       {Ουσιαστικό ουδέτερο πληθυντικός γενική}}
  {NoNePlAc       {Ουσιαστικό ουδέτερο πληθυντικός αιτιατική}}
{--- {Επίθετα} 3}
  {AjMaSgNm       {Επίθετο αρσενικό ενικός ονομαστική}}
  {AjMaSgGe       {Επίθετο αρσενικό ενικός γενική}}
  {AjMaSgAc       {Επίθετο αρσενικό ενικός αιτιατική}}
  {AjMaPlNm       {Επίθετο αρσενικό πληθυντικός ονομαστική}}
  {AjMaPlGe       {Επίθετο αρσενικό πληθυντικός γενική}}
  {AjMaPlAc       {Επίθετο αρσενικό πληθυντικός αιτιατική}}
  {AjFeSgNm       {Επίθετο θηλυκό ενικός ονομαστική}}
  {AjFeSgGe       {Επίθετο θηλυκό ενικός γενική}}
  {AjFeSgAc       {Επίθετο θηλυκό ενικός αιτιατική}}
  {AjFePlNm       {Επίθετο θηλυκό πληθυντικός ονομαστική}}
  {AjFePlGe       {Επίθετο θηλυκό πληθυντικός γενική}}
  {AjFePlAc       {Επίθετο θηλυκό πληθυντικός αιτιατική}}
  {AjNeSgNm       {Επίθετο ουδέτερο ενικός ονομαστική}}
  {AjNeSgGe       {Επίθετο ουδέτερο ενικός γενική}}
  {AjNeSgAc       {Επίθετο ουδέτερο ενικός αιτιατική}}
  {AjNePlNm       {Επίθετο ουδέτερο πληθυντικός ονομαστική}}
  {AjNePlGe       {Επίθετο ουδέτερο πληθυντικός γενική}}
  {AjNePlAc       {Επίθετο ουδέτερο πληθυντικός αιτιατική}}
{--- {Απόλυτα Αριθμητικά & Νούμερα} 3}
  {NmCd           {Απόλυτα αριθμητικά (ένα, δύο, τρία, ... και νούμερα: 1, 2, 3...)}}
{--- {Αντωνυμίες} 3}
  {PnMaSgNm       {Αντωνυμία αρσενικό ενικός ονομαστική}}
  {PnMaSgGe       {Αντωνυμία αρσενικό ενικός γενική}}
  {PnMaSgAc       {Αντωνυμία αρσενικό ενικός αιτιατική}}
  {PnMaPlNm       {Αντωνυμία αρσενικό πληθυντικός ονομαστική}}
  {PnMaPlGe       {Αντωνυμία αρσενικό πληθυντικός γενική}}
  {PnMaPlAc       {Αντωνυμία αρσενικό πληθυντικός αιτιατική}}
  {PnFeSgNm       {Αντωνυμία θηλυκό ενικός ονομαστική}}
  {PnFeSgGe       {Αντωνυμία θηλυκό ενικός γενική}}
  {PnFeSgAc       {Αντωνυμία θηλυκό ενικός αιτιατική}}
  {PnFePlNm       {Αντωνυμία θηλυκό πληθυντικός ονομαστική}}
  {PnFePlGe       {Αντωνυμία θηλυκό πληθυντικός γενική}}
  {PnFePlAc       {Αντωνυμία θηλυκό πληθυντικός αιτιατική}}
  {PnNeSgNm       {Αντωνυμία ουδέτερο ενικός ονομαστική}}
  {PnNeSgGe       {Αντωνυμία ουδέτερο ενικός γενική}}
  {PnNeSgAc       {Αντωνυμία ουδέτερο ενικός αιτιατική}}
  {PnNePlNm       {Αντωνυμία ουδέτερο πληθυντικός ονομαστική}}
  {PnNePlGe       {Αντωνυμία ουδέτερο πληθυντικός γενική}}
  {PnNePlAc       {Αντωνυμία ουδέτερο πληθυντικός αιτιατική}}
  {PnSgNm         {Αντωνυμία χωρίς γένος ενικός ονομαστική}}
  {PnSgGe         {Αντωνυμία χωρίς γένος ενικός γενική}}
  {PnSgAc         {Αντωνυμία χωρίς γένος ενικός αιτιατική}}
  {PnPlNm         {Αντωνυμία χωρίς γένος πληθυντικός ονομαστική}}
  {PnPlGe         {Αντωνυμία χωρίς γένος πληθυντικός γενική}}
  {PnPlAc         {Αντωνυμία χωρίς γένος πληθυντικός αιτιατική}}
  {--- {Απρόσωπα Ρήματα} 3}
  {VbIs           {Απρόσωπο Ρήμα}}
{--- {Προσωπικά Ρήματα} 3}
  {VbMnPrSg       {Ρήμα προσωπικό παροντικού χρόνου, ενικός}}
  {VbMnPaSg       {Ρήμα προσωπικό παρελθοντικού χρόνου, πληθυντικός}}
  {VbMnXxSg       {Ρήμα προσωπικό μελλοντικού χρόνου, ενικός}}
  {VbMnPrPl       {Ρήμα προσωπικό παροντικού χρόνου, πληθυντικός}}
  {VbMnPaPl       {Ρήμα προσωπικό παρελθοντικού χρόνου, πληθυντικός}}
  {VbMnXxPl       {Ρήμα προσωπικό μελλοντικού χρόνου, πληθυντικός}}
{--- {Απαρέμφατο} 3}
  {VbNfAv         {Απαρέμφατο ενεργητικής φωνής}}
  {VbNfPv         {Απαρέμφατο παθητικής φωνής}}
{--- {Μετοχές} 3}
  {VbPpPrPvNm     {Μετοχή Παροντικού Χρόνου Παθητικής Φωνής Ονομαστική}}
  {VbPpPrPvGe     {Μετοχή Παροντικού Χρόνου Παθητικής Φωνής Γενική}}
  {VbPpPrPvAc     {Μετοχή Παροντικού Χρόνου Παθητικής Φωνής Αιτιατική}}
  {VbPpPrAv       {Μετοχή Παροντικού Χρόνου Ενεργητικής Φωνής (-οντας, -ώντας)}}
{--- {Aκλιτα Μέρη του Λόγου} 3}
  {Ad             {Επίρρημα}}
  {AsPp           {Πρόθεση}}
  {Cj             {Σύνδεσμος}}
  {Pt             {Μόριο (ας, θα, να, μα, για)}}
  {Ij             {Επιφώνημα}}
  {RgFw           {Ξένη λέξη}}
{--- {Διάφορα Σύμβολα} 3}
  {RgAb           {Σύτμηση}}
  {RgAn           {Ακρώνυμο}}
  {RgSy           {Σύμβολο}}
  {Pu             {Σημείο Στίξης}}
}
set ::EditAnnotationsTool::ValuesSpec(english:token:pos) \
   $::EditAnnotationsTool::ValuesSpec(hellenic:token:pos)

##
## token -> case
##
set ::EditAnnotationsTool::ValuesSpec(hellenic:token:case) {
  {nom     {Ονομαστική}}
  {gen     {Γενική}}
  {acc     {Αιτιατική}}
  {voc     {Κλητική}}
}
set ::EditAnnotationsTool::ValuesSpec(english:token:case) {
  {nom     {Nominal}}
  {gen     {General}}
  {acc     {Accusative}}
  {voc     {Vocal}}
}

##
## token -> person
##
set ::EditAnnotationsTool::ValuesSpec(hellenic:token:person) {
  {1st     {Πρώτο πρόσωπο}}
  {2nd     {Δεύτερο πρόσωπο}}
  {3rd     {Τρίτο πρόσωπο}}
}
set ::EditAnnotationsTool::ValuesSpec(english:token:person) \
   $::EditAnnotationsTool::ValuesSpec(hellenic:token:person)

##
## token -> number
##
set ::EditAnnotationsTool::ValuesSpec(hellenic:token:number) {
  {singular  {Ενικός Αριθμός}}
  {plural    {Πληθυντικός Αριθμός}}
}
set ::EditAnnotationsTool::ValuesSpec(english:token:number) \
   $::EditAnnotationsTool::ValuesSpec(hellenic:token:number)

##
## name -> type
##
set ::EditAnnotationsTool::ValuesSpec(hellenic:name:type) {
  {person           {Πρόσωπο}}
  {organisation     {Οργανισμός}}
  {location         {Τοποθεσία}}
  {person_org       {Πρόσωπο & Οργανισμός}}
  {location_org     {Τοποθεσία & Οργανισμός}}
}
set ::EditAnnotationsTool::ValuesSpec(english:name:type) {
  {person           {Person}}
  {organisation     {Organisation}}
  {location         {Location}}
  {person_org       {Person & Organisation}}
  {location_org     {Location & Organisation}}
}

## Commands for editing this file in VIM UTF-8 mode...
# vim: syntax=tcl encoding=utf-8 fileencoding=utf-8
# vim: guifont=-misc-fixed-medium-r-normal--20-200-75-75-c-100-iso10646-1
