##########################################################################
# 
#	ReportTclVersionInformation.tcl - Monday August 30 16:08:35 (+0300) 2004
#       This is a loosed coupled (Tcl) Component for use with 
#       Ellogon, version 1.7.0...
#
##########################################################################


# Location of this module (ReportTclVersionInformation)
global creole_ReportTclVersionInformation_home

## creole_ReportTclVersionInformation
#  
proc creole_ReportTclVersionInformation {doc col args} {
  set msg {}
  lappend msg " -- Invocation Information --"
  lappend msg "Executable Path: \"[info nameofexecutable]\""
  lappend msg "Arguments:       \"[join $::argv {\", \"}]\""
  lappend msg "$::ApplicationName Version: \"$::ApplicationVersion\""
  lappend msg "$::ApplicationName Installation Path: \"$::HomeDir\""
  lappend msg "User Home Directory: \"$::UserHomeDir\""
  lappend msg " -- Ellogon Preferences --"
  foreach key [lsort [array names ::ApplicationInfo]] {
    lappend msg "  $key: $::ApplicationInfo($key)"
  }
  lappend msg " -- Tcl Related Information --"
  lappend msg "Tcl Version:     \"[info tclversion]\""
  lappend msg "Tcl PatchLevel:  \"[info patchlevel]\""
  lappend msg "Library Path:    \"[info library]\""
  lappend msg " -- Tk Related Information --"
  lappend msg "Tk Version:      \"$::tk_version\""
  lappend msg "Tk PatchLevel:   \"$::tk_patchLevel\""
  lappend msg "Library Path:    \"$::tk_library\""
  lappend msg " -- Operating System Related Information --"
  foreach key [lsort [array names ::tcl_platform]] {
    lappend msg "$key: $::tcl_platform($key)"
  }
  lappend msg " -- Initialisation Files --"
  lappend msg "Platform Initialisation File Path: $::tcl_rcFileName"
  if {[file exists $::tcl_rcFileName]} {
    set file [open $::tcl_rcFileName]
    set data [read $file]
    close $file
    lappend msg "Platform Initialisation File Exists: yes."
    lappend msg "--- Platform Initialisation File Content:"
    lappend msg $data
    lappend msg "--- Platform Initialisation File Content End!"
  } else {
    lappend msg "Platform Initialisation File Exists: no."
  }
  lappend msg " -- Library Contents --"
  foreach file [glob -directory [file dirname [info library]] *] {
    lappend msg "  $file"
  }
  foreach file [glob -directory [info library] *] {
    lappend msg "  $file"
  }
  foreach file [glob -directory $::tk_library *] {
    lappend msg "  $file"
  }
  lappend msg " -- Loaded Packages --"
  foreach pkg [info loaded] {
    lappend msg " ++ \"$pkg\""
  }
  ggi_view_text [join $msg \n]
};# creole_ReportTclVersionInformation

#
# End of File ReportTclVersionInformation.tcl
#
