/***************************************************************************
*
*       WEKA_Loader.java - Saturday November 06 23:00:43 (GTB Standard Time) 2004
*       This is a java coupled (Java) Component for use with 
*       Ellogon, version 1.7.0...
*
***************************************************************************/

import tcl.lang.*;
import Ellogon.JCDM.*;
import weka.core.*;
import weka.gui.*;

/* 
 * Class: creole_WEKA_Loader
 * This is the class of interest, as it implements the basic function
 * required by the Ellogon platform in order to succesfully load this
 * plug-in module. This function is the main function of the module, responsible
 * for doing the basic processing...
 */
class creole_WEKA_Loader implements Command {
  /* Location of this module (WEKA_Loader) */
  public static String creole_WEKA_Loader_home;
  
  public void cmdProc(Interp interp, TclObject argv[]) throws TclException {
    /* Initialise the WEKA GUI! */
    String args[] = {""};
    GUIChooser.main(args);
  } /* creole_WEKA_Loader::cmdProc */
} /* class creole_WEKA_Loader */


/* Function: creole_WEKA_Loader_Initialize
    Use this function in order to do some initialisation. This function will
    be called just before creole_WEKA_Loader in the following
    situations:
     *) If the user has opened a whole Collection, this function will be 
        called just before the first document in Collection gets proccessed 
        with creole_WEKA_Loader
     *) If the user has opened a single Document, this function will be called
        just before calling creole_WEKA_Loader
    Please, refer to the Ellogon's Programming Manual for more 
    information on this function... */
class creole_WEKA_Loader_Initialize implements Command {
  /* Location of this module (WEKA_Loader) */
  public static String creole_WEKA_Loader_home;
  
  public void cmdProc(Interp interp, TclObject argv[]) throws TclException {
    // if (argv.length < 3) {
    //   throw new TclNumArgsException(interp, 1, argv,
    //                                            "Collection Document ?args?");
    // }
    // OCDM_Collection Col = new OCDM_Collection(argv[1].toString());
    // OCDM_Document   Doc = new OCDM_Document(argv[2].toString());
    
    /* Do some initilization here... */

  } /* creole_WEKA_Loader_Initialize::cmdProc */
} /* class creole_WEKA_Loader_Initialize */


/*  Function: creole_WEKA_Loader_Finish
    Use this function in order to do some Clean-Up. This function will
    be called after all calls to creole_WEKA_Loader in the following 
    situations:
     *) If the user has opened a whole Collection, this function will be 
        called just after the last document in Collection gets proccessed with 
        creole_WEKA_Loader
     *) If the user has opened a single Document, this function will be called
        just after calling creole_WEKA_Loader
    Please, refer to the Ellogon's Programming Manual for more 
    information on this function... */
class creole_WEKA_Loader_Finish implements Command {
  /* Location of this module (WEKA_Loader) */
  public static String creole_WEKA_Loader_home;

  public void cmdProc(Interp interp, TclObject argv[]) throws TclException {
    // if (argv.length < 3) {
    //   throw new TclNumArgsException(interp, 1, argv,
    //                                            "Collection Document ?args?");
    // }
    // OCDM_Collection Col = new OCDM_Collection(argv[1].toString());
    // OCDM_Document   Doc = new OCDM_Document(argv[2].toString());
    
    /* Clean-Up... */

  } /* creole_WEKA_Loader_Finish::cmdProc */
} /* class creole_WEKA_Loader_Finish */

/**********************************************************************
 **               --   Ignore the Following Code   --              
 **  The following Java code takes care the interfaces to the Ellogon
 **  platform. Please modify with care...
 **********************************************************************/

/* 
 * This class implements a simple Tcl extension package and registers the
 * Components commands with the main Ellogon Tcl interpreter.
 * Modify with care...
 */
public class WEKA_Loader extends Extension {
  public void init(Interp interp) {
    /* Register the Module Main Command */
    interp.createCommand("creole_WEKA_Loader",
                         new creole_WEKA_Loader());
    interp.createCommand("creole_WEKA_Loader_Initialize",
                         new creole_WEKA_Loader_Initialize());
    interp.createCommand("creole_WEKA_Loader_Finish",
                         new creole_WEKA_Loader_Finish());
  }

  public static void SetComponentHome(String path) {
    creole_WEKA_Loader.creole_WEKA_Loader_home =
    creole_WEKA_Loader_Initialize.creole_WEKA_Loader_home =
    creole_WEKA_Loader_Finish.creole_WEKA_Loader_home =
                                                                           path;
  }
} /* class WEKA_Loader */

/* 
 * End of WEKA_Loader.java
 */
