##########################################################################
# 
#        AddSentenceConstituents.tcl - Sunday March 05 09:06:31 (EET) 2000
#       This is a loosed coupled (Tcl) Module for use with 
#       Ellogon, version 1.0...
#
##########################################################################


# Location of this module (AddSentenceConstituents)
global creole_AddSentenceConstituents_home

## creole_AddSentenceConstituents
#  
proc creole_AddSentenceConstituents {doc args} {

  set Tokens    [tip_SelectAnnotationsSorted $doc token]
  set Sentences [tip_SelectAnnotations       $doc sentence]
  ## Is the Document an HTML/XML Document?
  if {[llength [tip_SelectAnnotations $doc sentence \
                                       {[llength ann::html_constituents ]}]]} {
    set HTML 1
  } else {
    set HTML 0
  }

  ## The idea is simple: Select all token Annotations, sorted according to
  ## their spans (tip_SelectAnnotationsSorted). Then for every sentence
  ## Annotation get its first span (we assume that sentences have only one
  ## span) and find all the token Annotations that are within this span...
  foreach s $Sentences {
    tip_GetSpanOffsets [tip_GetFirstSpan $s] start end
    set tokens [tip_AnnotationsInRange $Tokens $start $end]
    ## Get ids...
    set cons {}; set html_cons {}
    foreach token $tokens {
      if {$HTML} {
        ## Check the type Attribute to see if it is an HTML token...
        set type [tip_GetAttribute $token type]
        if {[llength $type]} {
          set type [tip_GetValueValue $type]
          if {[string match HTML* $type] || [string match XML* $type]} {
            lappend html_cons [tip_GetId $token]
          } else {
            lappend cons [tip_GetId $token]
          }
        } else {
          lappend cons [tip_GetId $token]
        }
      } else {
        lappend cons [tip_GetId $token]
      }
    }
    set s [tip_PutAttribute $s [tip_CreateAttribute constituents \
                               [tip_CreateAttributeValue GDM_STRING_SET $cons]]]
    if {$HTML} {
      set s [tip_PutAttribute $s [tip_CreateAttribute html_constituents \
                          [tip_CreateAttributeValue GDM_STRING_SET $html_cons]]]
    }
    tip_AddAnnotation $doc $s
  }
  # record the fact that we ran and exit normally
  tip_PutAttribute $doc [tip_CreateAttribute AddSentenceConstituents \
                             [tip_CreateAttributeValue GDM_STRING {}]]
  return
};# creole_AddSentenceConstituents

#
# End of File
#
