##########################################################################
# 
#  EBrill.tcl - Wednesday November 22 18:47:34 (GTB Standard Time) 2008
#  This is a loosed coupled (Tcl) Component for use with 
#  Ellogon, version 1.8.0...
#
##########################################################################

# Location of this module (EBrill)
global creole_EBrill_home

## creole_EBrill
#
# This module sets up and calls the Ellogon's native HBrill tagger
# for the desired language.
#
# Input: A collection of documents subjected to tokenization and sentence
#        splitting and the corpus language which should be english or greek.
# Output: An extra attribute named "pos" in the token annotations which
#         contains the part-of-speech tag of each token.
# Procedure: Uses directly the Ellogon's native POS tagger with the appropriate
#            language selection.
proc creole_EBrill {doc args} {
  global creole_HBrill_home creole_EBrill_home
  
  set language [string tolower [lindex $args 0]]
  
  creole_HBrill $doc \
    $creole_HBrill_home/$language/FinalLexicon \
    $creole_HBrill_home/$language/Bigrams \
    $creole_HBrill_home/$language/LexicalRules \
    $creole_HBrill_home/$language/ContextualRules \
    -l $language

  tip_PutAttribute $doc [tip_CreateAttribute EBrill \
                             [tip_CreateAttributeValue GDM_STRING {}]]
};# creole_EBrill

proc creole_EBrill_Initialize {col doc args} {
  global creole_HBrill_home creole_EBrill_home
  
  set language [string tolower [lindex $args 0]]
  
  creole_HBrill_Initialize $col $doc \
    $creole_HBrill_home/$language/FinalLexicon \
    $creole_HBrill_home/$language/Bigrams \
    $creole_HBrill_home/$language/LexicalRules \
    $creole_HBrill_home/$language/ContextualRules \
    -l $language
};# creole_EBrill_Initialize

proc creole_EBrill_Finish {col doc args} {
  global creole_HBrill_home creole_EBrill_home
  
  set language [string tolower [lindex $args 0]]
  
  creole_HBrill_Finish $col $doc \
    $creole_HBrill_home/$language/FinalLexicon \
    $creole_HBrill_home/$language/Bigrams \
    $creole_HBrill_home/$language/LexicalRules \
    $creole_HBrill_home/$language/ContextualRules \
    -l $language
};# creole_EBrill_Finish

#
# End of File EBrill.tcl
#
