#!/bin/sh
# \
  exec tclsh "$0" "$@"

set Root [lindex $argv 0]
set dirs [glob Results_$Root*]
set files {}
foreach dir $dirs {
  if {[file isdir $dir] && [file exists [file join $dir TrainResults]]} {
    lappend files [file join $dir TrainResults]
  }
}
if {$files != {}} {
  set data [eval exec grep -- --Accuracy $files]
  set data [split $data "\n"]
  foreach line $data {
    set file [lindex $line 0]
    set Acc  [expr [lindex $line 2] * 100.0]
    regexp "${Root}(\[0-9\]+)/" $file tmp size
    if {![info exists Total($size)]} {set Total($size) 0.0; set HM($size) 0}
    set Total($size) [expr $Total($size) + $Acc]
    incr HM($size)
    lappend Values($size) $Acc
  }
}

## Standard Deviation
foreach size [array names Values] {
  set N [llength $Values($size)]
  set tmp 0.0; set mean [expr double($Total($size))/double($N)]
  foreach val $Values($size) {
    set tmp [expr $tmp + pow( ($val - $mean ) , 2)]
  }
  set Deviation($size) [expr sqrt($tmp/double($N - 1))]
}

## Get word cound...
if {$files != {}} {
  set data [eval exec grep -- words  $files]
  set data [split $data "\n"]
  foreach line $data {
    set list [split $line ", "]
    set ind [expr [llength $list] -2]
    set words [lindex $list $ind]
    incr ind -5
    set file [lindex $list $ind]
    regexp "${Root}(\[0-9\]+)" $file tmp size
    set Words($size) $words
  }
}
foreach size [lsort -integer [array names Total]] {
  puts "$Words($size) [expr $Total($size)/$HM($size)] $Deviation($size) $size"
}
