# 
#        HBrill/creole_config.tcl - configuration file
#
#        Saturday September 11 14:31:19 (EEST) 1999
#        
#        $Id: template_config.tcl, Ellogon, version 1.0... 
#            (Georgios Petasis, 23/11/1998), petasis@iit.demokritos.gr   $


set creole_config(HBrill) {  
  title {Hellenic POS Tagger}
  pre_conditions
  {
    collection_attributes      {}
    document_attributes        {language_hellenic}
    annotations                {token {sentence constituents}}
  }
  post_conditions
  {
    collection_attributes      {}
    document_attributes        {HBrill}
    annotations                {{token pos}} 
  }
  viewers
  {
    {token pos}                        single_span {Brill POS Tags...}
    {token}                            raw         {Raw Token}
    $creole_HBrill_home/GreekTags.html text_file {Greek POS Tag Definitions}
  }
  parameters
  {
    {Lexicon}          %FILE% "$creole_HBrill_home/greek/FinalLexicon"
    {Bigrams}          %FILE% "$creole_HBrill_home/greek/Bigrams"
    {Lexical Rules}    %FILE% "$creole_HBrill_home/greek/LexicalRules"
    {Contextual Rules} %FILE% "$creole_HBrill_home/greek/ContextualRules"
    {Additional Wordlist}            {-w %FILE%}   {}
    {Intermediate output}            {-i %FILE%}   {}
    {Process lines}                  {-s %NUMBER%} {}
    {Start State Tagger only}        -S            {}
    {Start State Algorithm Language} {-l %COMBO%}  {greek english}
  }
  coupling dynamic
  description 
    "This is the Greek Part-of-Speech Tagger (based on Brill Tagger).\n\
     Author: Petasis Georgios, petasis@iit.demokritos.gr"
  module_encoding iso8859-7
}

## Compatibility Mode: Use 0 for Ellogon mode, 1 for GATE compatibility
## mode...
set ::CDM::ComponentMode(creole_HBrill) 0

#
# End of File
#

