#!/bin/sh
# The next line is executed by /bin/sh, but not tcl \
exec tclsh "$0" ${1+"$@"}

proc Usage {} {
  global argv0 argv argc

  if {$argc < 1} {
    puts stderr "Usage: $argv0 file1 ?file2 ...?"
    exit 1
  }
}
Usage

proc Freqs {} {
  global argv

  foreach filename $argv {
    set file [open $filename]
    while {![eof $file]} {
      if {[gets $file line] < 1} {continue}
      set line [string trim $line]
      if {[info exists Line($line)]} {
        incr Line($line)
      } else {
        set  Line($line) 1
      }
    }
    close $file
  }
  
  foreach line [array names Line] {
    lappend Freq($Line($line)) $line
  }
  
  foreach freq [lsort -integer -decreasing [array names Freq]] {
    foreach line $Freq($freq) {
      puts "$freq: $line"
    }
  }
}
Freqs
