set Categories {person_firstname person_surname location trash}
set Words2Classify {}
set ::Encoding iso8859-7

proc ReadData {} {
  global Words2Classify
  set file [open [lindex $::argv 0]]
  fconfigure $file -encoding $::Encoding
  while {[gets $file line] > 0} {
    lappend Words2Classify [string trim $line]
  }
  close $file
};
ReadData
set ::Word2Classify [lindex $::Words2Classify 0]
set ::Words2Classify [lrange $::Words2Classify 1 end]

proc Classify {category} {
  lappend ::Words($category) $::Word2Classify
  if {![llength $::Words2Classify]} Exit
  set ::Word2Classify [lindex $::Words2Classify 0]
  set ::Words2Classify [lrange $::Words2Classify 1 end]
};# Classify

proc Exit {} {
  foreach category [array names ::Words] {
    set file [open $category.lst a]
    fconfigure $file -encoding $::Encoding
    foreach word $::Words($category) {
      puts $file $word
    }
    close $file
  }
  exit
};# Exit

proc CreateDlg {} {
  label .word_2_classify -font {Arial 14 bold} -bg white -fg navy \
    -textvariable ::Word2Classify
  frame .frame
  foreach category $::Categories {
    button .frame.cat_$category -text $category -command "Classify $category"\
      -font {Arial 12 bold} -bd 1
    pack .frame.cat_$category -side left -padx 10 -pady 10
  }
  pack .word_2_classify .frame -side top -fill x
};# CreateDlg
CreateDlg
wm protocol . WM_DELETE_WINDOW Exit
