##########################################################################
# 
#	SimpleTokeniser.tcl - Monday February 26 19:32:06 (EET) 2001
#       This is a loosed coupled (Tcl) Module for use with 
#       Ellogon, version 1.00...
#
##########################################################################


# Location of this module (SimpleTokeniser)
global creole_SimpleTokeniser_home

## creole_SimpleTokeniser
#  
proc creole_SimpleTokeniser {doc args} {
  ggi_wait_update $doc 0
  foreach {generate_sentences} $args {break}
  
  set Text   [tip_GetRawData $doc]
  set length [string length $Text]
  
  ## We have to find the first word...
  set start 0
  set end [tcl_endOfWord $Text $start]
  if {[tcl_startOfNextWord $Text $start] < $end} {
    set start [tcl_startOfNextWord $Text $start]
  }
  set TextStart $start
  tip_AddAnnotation $doc \
      [tip_CreateAnnotation token [list [tip_CreateSpan $start $end]] \
         [list [tip_CreateAttribute type \
                             [tip_CreateAttributeValue GDM_STRING word]]]]

  ## And now iterate over all other words...
  while {$start >= 0} {
    set start [tcl_startOfNextWord $Text $start]
    set end   [tcl_endOfWord $Text $start]
    #puts "start: $start, end:$end ($length) [expr {$end*50.0/$length}]"; update
    if {$start != -1 && $end != -1} {
      tip_AddAnnotation $doc \
        [tip_CreateAnnotation token [tip_CreateSpanSet $start $end] \
          [tip_CreateAttributeSet type \
                             [tip_CreateAttributeValue GDM_STRING word]]]
      ggi_wait_update $doc [expr {$end*50.0/$length}]
    }
  }
  
  ## As a bonus, add sentence annotations on every newline character :-)
  if {$generate_sentences} {
    set Tokens [tip_SelectAnnotationsSorted $doc token]
    set start 0
    set end [string first "\n" $Text $start]
    while {$end != -1} {
      set tokens [tip_AnnotationsInRange $Tokens $start $end]
      set sstart [lindex [tip_GetFirstSpan [lindex $tokens 0  ]] 0]
      set send   [lindex [tip_GetFirstSpan [lindex $tokens end]] 1]
      set cons {}
      foreach token $tokens {
        lappend cons [tip_GetId $token]
      }
      tip_AddAnnotation $doc \
          [tip_CreateAnnotation sentence [tip_CreateSpanSet $sstart $send] \
            [tip_CreateAttributeSet constituents \
                               [tip_CreateAttributeValue GDM_STRING_SET $cons]]]
      set start [expr {$end+1}]
      set end [string first "\n" $Text $start]
      ggi_wait_update $doc [expr {50.0+$end*50.0/$length}]
    }
  }
  # record the fact that we ran and exit normally
  tip_PutAttribute $doc [tip_CreateAttribute SimpleTokeniser \
                             [tip_CreateAttributeValue GDM_STRING {}]]
  return
};# creole_SimpleTokeniser
#
# End of File
#
